/* 25 Dec 1999. Daniel Hellerstein (danielh@crosslink.net) 
  The "remote client" component of updater (cgi-bin vesion)

For details, see updater.doc

Reminder:  uses the "sitelist.in" files, that is stored in the
updater_dir directory.

SITELIST.IN file contains "mime-like" records, with each record containing
several single-line entries, and with records seperated by blank lines.
Entries have the following structure:
   name: value
where
  name may be one of  site, username, password, or description
*/

/**** User changeable parameters ****/

/*  the "updater" directory -- should be a fully qualified directory.
    Or, leave it blank to use the default (the UPDATER subdirectory of 
    the cgi-bin directory). */

UPDATER_DIR='' 
 
/* colors and or background used in some html displays */
back1='bgcolor="#88aa66"'

/* allow use of GZIP encoding */
candogzip=1

/* allow use of rsync-differencing */
candorsync=1

/* Script to use (used when calling central server). 
   Leave blank to use default of cgi-bin/updater.cmd */
CSCRIPT_NAME=''

/* Script to use (used when calling remote server). 
   Leave blank to use default of cgi-bin/rupdater.cmd */
RSCRIPT_NAME=''

/* status messages (0=none, 1=some, 2=more */
verbose=1

/**** End of User changeable parameters ****/

rupdater_cgi:    

parse arg  stuff

verb=value('REQUEST_METHOD',,'os2environment')
if verb="" then do
   say " This cgi-bin script is not meant to be run in stand-alone mode. "
   exit
end  /* Do */
signal on error name badguys; signal on syntax name badguys
crlf = '0d0a'x

rscript_name=strip(rscript_name,'l','/')
cscript_name=strip(cscript_name,'l','/')
list= value("QUERY_STRING",,'os2environment')
servername=value('SERVER_NAME',,'os2environment')
basedir=directory()

signal on error name badguys; signal on syntax name badguys
crlf = '0d0a'x

call check_dlls         /* load some dlls */

if result=0 then return

if updater_dir='' then do
     updater_dir=strip(basedir,,'\')'\UPDATER'
end /* do */

if dosisdir(updater_dir)=0 then do
    say 'Content-type: text/plain '
    say
    say ' UPDATER configuration error. No such updater directory: 'updater_dir      
    return 
end

sites_dir=updater_dir'\SITES'
if dosisdir(sites_dir)=0 then do
    say 'Content-type: text/plain '
    say
    say ' UPDATER configuration error. No such sites directory: 'sites_dir
    return 
end

sitelist_file=stream(sites_dir'\sitelist.in','c','query exists')
if sitelist_file='' then do
    say 'Content-type: text/plain '
    say
    say ' UPDATER configuration error. No SITELIST.IN file in 'sites_dir
    return 
end
foo=stream(sitelist_file,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then do
  if verbose>1 then  call pmprintf('RUpDater-CGI configuration error: can not open 'sitelist_file)
  return 0
end
ii=stream(sitelist_file,'c','query size')
if ii='' | ii=0 then do
    say 'Content-type: text/plain '
    say
    say ' UPDATER configuration error.  Empty file: 'sitelist_file
    return 
end
sitelist=charin(sitelist_file,1,ii)||'0d0a'x||' '
foo=stream(sitelist_file,'c','close')

/* pull out arguments */
args.=''
if list='' then list='name=!list'
do until list=""                /* get user input */
   parse var list a1 '&' list
   parse var a1 a1a '=' a1b0
   a1a='!'||translate(strip(a1a))
   args.a1a=decodekeyval(strip(translate(a1b0,' ','+'||'000d0a09'x)))
end

call do_remote

exit 


/********************************************/
/* the remote portion  */
do_remote:

call read_sitelist              /* load sitelist. stem */

if translate(args.!name)='!LIST' then do
   call get_sitelist
   return 1
end

/* obtain a list of packages? */
if translate(args.!action)='GETP' then do          
  call get_site_packages
  return 1
end

/* obtain the contents of  a package  */
if translate(args.!action)='GETL' then do          
  call get_a_package_list
  return 1
end

/* start getting files from a package  */
if translate(args.!action)='DOIT' then do          
  call start_file_get
  return 1
end


/* check status  */
if translate(args.!action)='STATUS' then do          
  call check_status
  return 1
end

/* check reset  */
if translate(args.!action)='RESET' then do          
  call reset_it
  return 1
end


call saystring 'unsupported option '
return 1


/********/
/* say amessage as text/plain */
domessage:procedure expose cscript_name rscript_name
parse arg amess
say "Content-type: text/plain"
say
say amess
return 1

/*************/
/* construct a list of sites
*/
get_sitelist:

astext=1
say 'Content-type: text/html'
say
say '<html><head><title>Currently accessible UpDater Sites </title></head>'
say '<body 'back1'>'
say '<h3>Welcome to UpDater (beta 1.08) !</h3>'
say 'From this <em>remote server</em> (at 'servername')'
say 'you can <u>update</u> <em>packages of files</em> from '
say 'these <em>central servers</em> :'
say '<ol>'
do jj=1 to sitelist.0
  say '<li> <a href="http://'||servername'/'rscript_name'?action=getP&name='sitelist.jj.!name'">'
  say sitelist.jj.!name'</a>: 'sitelist.jj.!description
end /* do */
say '</ol>'
say '<hr>Would you like to read the <a target="info" href="/'cscript_name'?send=UPDATER.DOC&text=1">UpDater documentation</a>'
say '</body></html>'
return foo


/*************/
/* ask a site for it's list of packages */
get_site_packages:

 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end
 if imatch=0 then do
     call saystring ' RUpDater_CGI Error: No such site: 'thename
     return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password

 say 'Content-type: text/html '
 say
 say '<html><head><title>Currently available packages </title></head>'
 say '<body 'back1'>'
 say '<h3>UpDater packages offered by 'thename ' </h3> '

 stuff=get_a_url(aip,'/'cscript_name'?package=!list',auser,apwd)

 if stuff='' then return stuff
 
 parse var stuff ndo (crlf) stuff
 say 'The <em>UpDater central server</em> at <tt>'thename'</tt>'
 say 'currently supports 'ndo' <em>file packages</em><p>'
 say '<b>Please choose a package to update </b>'
 say '<ol>'
 do until stuff=''
   parse var stuff aline (crlf) stuff
   aline=strip(aline)
   if abbrev(aline,';')=1 then iterate
   parse var aline adate aname adesc
   parse var aname aname0 '.' .
   say '<li> <a href="/'rscript_name'?action=getl&name='thename'&package='aname0'">'aname0'</a>: 'adesc
end /* do */
say '</ol>'

say 'Or ...<menu>'
say '<li>you can directly query the <em>UpDater central server</em> '
say  '<tt>'thename'</tt> <a href="http://'||aip'/'cscript_name'?package=!list&ashtml=1">for the details </a>'
say '<li><a href="/'rscript_name'?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'
say '</menu>'
say '</body></html>'

return foo


/*************/
/* get a package list */
get_a_package_list:

 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     call saystring 'RUpDater_CGI Error: No such site: 'thename
      return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password
 aroot=sitelist.mm.!root

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    call saystring 'RUpDater_CGI error: no package specified '
    return ' '
  end

 if aroot='' then do
    call saystring 'RUpDater_CGI Error: No root directory info for 'thename','thepackage
    return ' '
 end

 if args.!nocache<>1 then
   areq='/'cscript_name'?action=getl&package='thepackage
 else
   areq='/'cscript_name'?action=getl&nocache=1&package='thepackage

 say 'X-Updater0: 'thepackage

 stuff=get_a_url(aip,areq,auser,apwd)

 if stuff='' then return stuff

this_site_dir=sites_dir'\'thename
oo=dosisdir(this_site_dir)
if oo=0 then do
   foo=sysmkdir(this_site_dir)
   if foo<>0 then do
      call saystring 'RUpDater_CGI error: unable to create 'this_site_dir' ('oo
      return ' '
   end
end

/* save this package list */
 plist_file=this_site_dir'\'thepackage'.pkg'
 foo=sysfiledelete(plist_file)
 foo=stream(plist_file,'c','open write')
 if abbrev(translate(foo),'READY')=0 then do
     call saystring 'RUpDater_CGI ERROR: Unable to create package file 'plist_file
     return ' '
 end /* do */
 oo=charout(plist_file,stuff,1)
 if oo<>0 then do
     call saystring 'RUpDater_CGI ERROR: Unable to write to package file 'plist_file
     return ' '
 end /* do */
 foo=stream(plist_file,'c','close')
 
 say 'Content-type: text/html'
 say
 say '<html><head><title>Contents of an UpDater package </title></head>'
 say '<body 'back1'>'
 say '<h3>Are you ready to UpDate? </h3> '

 parse var stuff hdrl (crlf) stuff
 currenttime=0; created=0;age=0
 do until hdrl=''
    parse var hdrl avar hdrl
    parse var avar a1 '=' a2 ;a1=striP(translate(a1))
    if a1='PACKAGE' then packagename=strip(a2)
    if a1='CREATED' then created=a2
    if a1='CURRENT_TIME' then currenttime=a2
 end /* do */
 if created>0 & currenttime>0 then do
  numeric digits 10
  age=currenttime-created
  if age='0' then do
    hrs=0; days=0
  end
  else do
       parse var age days '.' mins ; mins='.'mins
       hrs=1440*mins/60
  end
 end /* do */


 say '<ul>'
 say '<li>Package location (the central server): <tt>'thename'</tt>'
 say '<li>Package: <tt>'packagename'</tt>'
 if age>0 then 
   say ' <em>(using a version that is 'days 'days 'hrs 'hrs old )</em> '
 say '<a href="/'rscript_name'?action=getl&nocache=1&name='thename'&package='packagename'&iter='||time('s')||'">'
 say ' (request the latest version?)</a>'

 mm=0
 do until stuff=''
    parse var stuff aline (crlf) stuff
    aline=strip(aline) 
    if abbrev(aline,';')=1 then iterate
    mm=mm+1
    parse var aline entries.mm.!date entries.mm.!entry entries.mm.!file entries.mm.!rdir
 end /* do */
 say '<li>Number of files:<tt> 'mm'</tt>'
 say '<li>Package list saved to <tt>:'plist_file'</tt>'
 say '<li>You can save files to: <b>'aroot'</b>'
 say '</ul>'
 say 'Reminder: the <u>package list</u> file, and the <u>save files to</u> directory,'
 say 'are on this remote server at <tt>'servername'</tt>'

say '<hr width="30%">'

/* now create a form that lists options */
say '<form action="/'rscript_name'" method="GET">'
say '<input type="hidden" name="action" value="doit">'
say '<input type="hidden" name="name" value="'thename'">'
say '<input type="hidden" name="package" value="'thepackage'">'

say '<input type="Submit" value="Get the files in 'packagename'... ">'
say '<table><tr valign="top">'

say '<tr valign="top"><td>Destination directory (on this remote server)</td> '
say '<td><input type="text" name="DESTDIR" value="'||word(aroot,1)||'" size=30> </td>'

say '<tr valign="top"><td>Backup directory (on this remote server).</td> '
say '<td><input type="text" name="BACKUPDIR" size=30>'
say '<br><em> To suppress backing up changed files, leave this field empty.</em></td>'


say '<tr valign="top"><td>Update checks &amp; cleanup option</td>'
say '<td><input type="radio" name="TIMECHECK" value="1" checked> '
say 'Update if newer (using file creation date) <bR>'
say '<input type="radio" name="TIMECHECK" value="2" > '
say 'Update if 32bit (crc32) file hash is different <bR>'
say '<input type="radio" name="TIMECHECK" value="3" > '
say 'Update if 128bit (md4) file hash is different <bR>'

say '<input type="radio" name="TIMECHECK" value="0">'
say 'Always update '

say '<hr width="25%"> <input type="checkbox" name="DELETE" value="1" > '
say 'Delete all existing files (in the destination directory) that are not mentioned in this package'
say '</td>'


say '<tr valign="top"><td valign="top">Range to retrieve</td>'
say '<td> Enter two numbers: from  '
say '#<input type="text" name="RANGE1"  size=5> to '
say '#<input type="text" name="RANGE2"  size=5> <em>(leave both boxes blank to retrieve all files)</em>'

say '</td>'
say ''
say ''
say ''
say '</table>'


say ''
say ''
say ''
ab='Get the files in 'packagename'...'
say '<input type="Submit" value="'||reverse(ab)||'">'

say '</form>'

say '<a href="/'rscript_name'?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'

say '</body></html>'

return foo


/*************/
/* check status of an update requests */
reset_it:
 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     call saystring 'RUpDater_CGI Error: No such site: 'thename
      return ' '
 end

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    call saystring 'RUpDater_CGI error: no package specified '
    return ' '
  end

  asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(thepackage)
  istat=eventsem_close(asem)

  suicide=translate(asem||'_DIE')
  istat=eventsem_post(suicide)
  if Istat=187 then do                  /* doesn't exist, so create it posted */
      istat=eventsem_create(suicide,'P')
  end /* do */

  this_site_dir=sites_dir'\'thename
  oo=dosisdir(this_site_dir)
  if oo=0 then do
     call saystring 'RUpDater_CGI error: unable to find directory 'this_site_dir
     return ' '
  end 
  outfile=this_site_dir'\'thepackage'.rpt'
  foo=0

  foot=eventsem_post(suicide)
  
  if foo>0 then do
    say 'Content-type: text/html'
    say
    say '<html><head><title>UpDater ReSet Failed </title></head>'
    say '<body 'back1'>'
    say '<h3>UpDater ReSet Failed  </h3> '
    say 'Unable to reset UpDater. You may have to restart this server'
    return 1
  end 

  say 'Content-type: text/html'
   say
   say '<html><head><title>UpDater ReSet </title></head>'
   say '<body 'back1'>'
   say '<h3>UpDater ReSet  </h3> '
   say 'UpDater has been reset.<p>'
   say ' -- you should now be able to <a href="/'rscript_name'?">submit an UpDater request'
   say '<br>Or, <a href="/'rscript_name'?">return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'

   say "</body></html>"
   return 1
 


/*************/
/* check status of an update requests */
check_status:
 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     call saystring 'RUpDater_CGI Error: No such site: 'thename
      return ' '
 end

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    call saystring 'RUpDater_CGI error: no package specified '
    return ' '
  end

  this_site_dir=sites_dir'\'thename
  oo=dosisdir(this_site_dir)
  if oo=0 then do
     call saystring 'RUpDater_CGI error: unable to find directory 'this_site_dir
     return ' '
  end 
  outfile=this_site_dir'\'thepackage'.rpt'

  asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(thepackage)
  istat=eventsem_query(asem)

  iss=stream(outfile,'c','query size')
  if iss=0 | iss='' then do
     call saystring 'RUpDater_CGI warning: empty report file 'outfile
     return ' '
  end
  foo=stream(outfile,'c','close')
   say 'Content-type: text/html'
   say
   say '<html><head><title>UpDater Status </title></head>'
   say '<body 'back1'>'
   say '<h3>UpDater status  </h3> '
   say 'The <a href="/'rscript_name'?action=status&name='thename'&package='thepackage'&iter='||time('s')'">'
   say 'update</a>'
   say 'of the <em> 'thepackage ' </em> package on the<tt> 'thename '</tt>'
   say '<em>central server</em> to this <em>remote server </em> (<tt>'servername'</tt>)'
   say '<p><b>Status</b>:'
   if istat=1 then  say '<tt><b>Package is now being updated</b></tt>'
   if istat<=0 then say '<tt><b>Package is <u>not</u> currently being updated </b></tt>'
   say '<p><b>Current status report:</b> '
   say ' <em>('outfile') </em>'

 iok=0
 signal on error name oy1 ; signal on syntax name oy1 
 goon=this_site_dir'\'thepackage'.sta'
 address cmd '@type 'outfile ' > ' goon
 iok=1
oy1:            /* jump here if @type doesn't work */
   signal on error name badguys; signal on syntax name badguys

   if iok<>0 then do   /* chek for > output */
     jsz=stream(goon,'c','query size')
   end
   if iok=0 | jsz=0 | jsz='' then do
      say 'Content-type: text/html'
      say
      say '<p><b>Unable to read status file</b>. Please wait a few seconds'
      say 'and '
      say '<a href="/'rscript_name'?action=status&name='thename'&package='args.!package'&iter='||time('s')'">'
      say 'try again</a>'
      say '<p> Or... you can '
      say '<a href="/'rscript_name'?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
      say 'stop &amp; reset UpDater</a>'
      say '</body></html>'
      foo=sysfiledelete(goon)
      return foo
   end /* do */
   say '<pre>'
   ook=charin(goon,1,jsz)
   call charout,ook
   say '</pre>'
   foo=stream(goon,'c','close')
   foo=sysfiledelete(goon)

   say '<hr><h4>Note</h4>'
   say 'If you need to stop this update, or if UpDater seems '
   say 'to be hung, you can try to '
   say '<a href="/'rscript_name'?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
   say 'stop &amp; reset UpDater</a>'

  say '<br>Or, <a href="/'rscript_name'?">return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'

   say '</body></html>'
   return foo
end /* do */
     


/*************/
/* start to get files from a package */
start_file_Get:


 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     call saystring 'RUpDater_CGI Error: No such site: 'thename
      return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password
 aroot=sitelist.mm.!root

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    call saystring 'RUpDater_CGI error: no package specified '
    return ' '
  end

asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(args.!package)
foo=eventsem_query(asem)

if foo>=1 then do               /* updater is running on this package */
   say 'Content-type: text/html'
   say
   say '<html><head><title>RUpDater_CGI is busy </title></head>'
   say '<body 'back1'>'
   say '<h3>RUpDater_CGI is busy </h3> '
   say 'The <em>'args.!package'</em> package from the <tt>'thename'</tt> server is currently being updated'
   say '<p>To (re)update this package, please try again in a few minutes '
   say '<blockquote>Would you like to <a href="/'rscript_name'?action=status&name='thename'&package='args.!package'&iter='||time('s')||'">'
   say 'query the status of this update</a>?</blockquote>'
   say '</body></html>'
   return foo
end /* do */

destdir=strip(translate(args.!destdir))
destdir=translate(strip(destdir,,'\'))
if destdir='' then do
     call saystring 'RUpDater_CGI Error: You forgot to specify a destination directory.'
      return ' '
end

backupdir=strip(translate(args.!backupdir))
if backupdir='' then backupdir=0

if aroot='' then do
     call saystring 'RUpDater_CGI Error: No root directory info for 'thename','thepackage
      return ' '
end

dd=destdir'\'
/* check to see if destdir is permitted */
isok=0
do mm=1 to words(aroot)
   aroot0=translate(strip(word(aroot,mm)))
   aroot0=strip(aroot0,,'\')'\'
   if abbrev(dd,aroot0)=1 then do
       isok=1 ; leave
    end
end
if isok=0   then do
     call saystring 'RUpDater_CGI Error: Destination directory not allowed: 'destdir
      return ' '
end

if backupdir<>0 then do           /* is backup directory allowed */
  backupdir=translate(strip(backupdir,,'\'))
  dd=backupdir'\'
  isok=0
  do mm=1 to words(aroot)
   aroot0=translate(strip(word(aroot,mm)))
   aroot0=strip(aroot0,,'\')'\'
   if abbrev(dd,aroot0)=1 then do
       isok=1 ; leave
    end
  end
  if isok=0   then do
     call saystring 'RUpDater_CGI Error: Backup directory not allowed: 'backupdir
      return ' '
  end
end
  


this_site_dir=sites_dir'\'thename
oo=dosisdir(this_site_dir)

if oo<>0 then do          /* check for .pkg file */
 plist_file=this_site_dir'\'thepackage'.pkg'
 foo=stream(plist_file,'c','open read')
end

if oo=0  |  abbrev(translate(foo),'READY')=0 then do
   say 'Content-type: text/html'
   say
   say '<html><head><title>Package list not found </title></head>'
   say '<body 'back1'>'
   say '<h3>A package list is not available </h3> '
   say 'A <em> package list </em> for the <tt>'thepackage'</tt> package '
   say '(from the <tt>'thename'</tt>site) is not available<p>'
   say 'Would you like to <a href="/'rscript_name'"?action=getl&name='thename'&package='thepackage'">'
   call lineout tempfkle,'download it now</a>? '
   say '</body></html>'
   return foo
end

say 'Content-type: text/html'
say
say '<html><head><title>UpDating a package of files </title></head>'
say '<body 'back1'>'
say '<h3>UpDating a package of files </h3> '
say 'UpDater is now obtaining files from the 'thepackage ' package on the 'thename ' site.'
say '<p><b>Notes:</b>'
say '<menu>'
say '<li>Files written to <tt>'destdir'</tt>'
if args.!backupdir<>0 & args.!backupdir<>'' then
say '<li>Changed files backed up to <tt>'args.!backupdir'</tt>'

say '<li>Using the package-list in:<tt> 'plist_file'</tt>'
if args.!delete=1 then
   say '<li>Files not specified in the package-list <b>will</b> be deleted '
else
   say '<li>Files not specified in the package-list will <b>not</b> be removed '

select 
  when args.!timecheck=0 then
   say '<li><b>All</b> files will be downloaded'
  when args.!timecheck=1 then
   say '<li>Only files with older dates will be downloaded'
  when args.!timecheck=2 then
   say '<li>Only files that have changed will be downloaded'
  when args.!timecheck=2 then
   say '<li>Only files that have changed (strong check) will be downloaded'

  otherwise nop
end

arange1=strip(args.!range1)
arange2=strip(args.!range2)

if args.!range1>0 & datatype(args.!range1)='NUM' then 
    say '<li>Range specified:<tt> 'args.!range1' - 'args.!range2'</tt>'

say '</ul>'

/* now, launch a thread that will obtain the files in plist_file, from package
  the package at the server at aip (with auser and apwd username and password )
*/

backupdir=strip(args.!backupdir)
if backupdir='' then backupdir=0
tcheck=pos(args.!timecheck,'123') ; dodel=1
if args.!delete<>1 then dodel=0
if arange1='' | arange2='' then 
   arange12=0
else
   arange12=arange1':'arange2
args='OBTAIN 'plist_file'  '||strip(auser)||':'||strip(apwd)||' 'destdir' 'tcheck' 'dodel' 'asem' 'backupdir' 'arange12
aprog=updater_dir'\updmncgi.cmd'

address cmd '@DETACH 'aprog' 'args
do mm=1 to 20
   call syssleep(0.1)
   foo=eventsem_wait(asem,7000)
   if foo=0 then leave
end
if foo<>0 then do
   say '<p><B>FAILURE! ('foo')</b>'
   say 'Unable to start the UpDater Daemon. Try again later'
   say '... or, you can try to '
   say '<a href="/'rscript_name'?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
   say 'stop &amp; reset UpDater</a>'
   say '</body></html>'
   return foo
end /* do */

say '<p> Do you want to ...'
say '<menu>'
say '<li><a href="/'rscript_name'?action=status&name='thename'&package='thepackage'&iter='||time('s')||'">'
say 'check the status</a> of this package acquisition?'
say '<li><a href="/'rscript_name'?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
say 'stop this update &amp; reset UpDater</a>'

say '<li><a href="/'rscript_name'?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'
say '</menu>'

say '</body></html>'
say
return foo


/*************************************/
/* read sitelist */
read_sitelist:procedure expose sitelist. crlf sitelist  cscript_name rscript_name

doing=0
sitelist.=''
sitelist.0=0
do until sitelist=''

  parse var sitelist aline (crlf) sitelist
  aline=strip(aline)

  if abbrev(aline,';')=1 then iterate   /* skip comments */
  if aline='' & doing=0 then iterate   /* skip multiple blank lines */
  if aline='' & doing=1 then do                /* end of record */
     doing=0
     iterate
  end 

  if doing=0 then do            /* start of a new record */
     sitelist.0=sitelist.0+1
     doing=1
  end
  if pos(':',aline)=0 then iterate  /* error, ignore */

  ith=sitelist.0


  parse var aline aname ':' avalue
  aname=strip(translate(aname))
      
  SELECT
    when abbrev(aname,'NAME')=1 then sitelist.ith.!NAME=space(avalue,0)
    when abbrev(aname,'ADD')=1  then sitelist.ith.!ADDRESS=space(avalue,0)
    when abbrev(aname,'DESC')=1 then sitelist.ith.!DESCRIPTION=avalue
    when abbrev(aname,'USER')=1 then sitelist.ith.!USERNAME=avalue
    when abbrev(aname,'PASS')=1 then sitelist.ith.!PASSWORD=avalue
    when abbrev(aname,'ROOT')=1 then sitelist.ith.!ROOT=strip(avalue)
    otherwise nop
  end

end             /* do loop */
return 1



/*** jump here on error */
badguys:
say 'content-type: text/plain'
say
say "RUpDater_CGI error "Rc " at " sigl
return 



/********************/
/* check for unzip and rsync dlls */
check_dlls:


/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( "SockLoadFuncs","rxSock","SockLoadFuncs")
  if foo=0 then call SockLoadFuncs
end
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rxSock dynamic link library"
   say
   return 0
end

/* Load up advanced REXX functions */
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
  foo= RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
  if foo=0 then call SysLoadFuncs
end
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rexxutil dynamic link library"
   say
   return 0
end

/* Load up REXX lib functions */
if RxFuncQuery("rexxlibregister")=1 then  do    /* not there */
  foo=rxfuncadd('rexxlibregister','rexxlib', 'rexxlibregister')
  if foo=0 then call rexxlibregister
end
if RxFuncQuery("Rexxlibregister")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rexxlib dynamic link library"
   say
   return 0
end

if candorsync=1 then do         /* can we really? */
  if rxfuncquery('rx_md4')=1  then do
     foo=RXFuncAdd('RXRsyncLoad', 'RXRSYNC', 'RxRsyncLoad')
     if foo=0 then  call rxrsyncload
     t1=rxfuncquery('rx_md4')
     if t1=1 then do
       if verbose>1 then call pmprintf('RUpDater-CGI-cgi warning: rxrsync not available -'directory())
       candorsync=0
     end  
  end
end


/* see if GZIP is available */
if candogzip=0 then signal check_done

signal on error name nogzip; signal on syntax name nogzip
isok=0
nn=queued()
do nn0=1 to nn
   pull .
end
address cmd '@GZIP -V 2> NUL '
if rc=0 then isok=1
do nn0=1 to nn
   pull .
end
nogzip: 
candogzip=isok
if candogzip=0 & verbose>1 then call pmprintf('RUpDater-CGI-cgi warning: GZIP not available')

signal on error name badguys; signal on syntax name badguys

checkdone:              /* skip here if gzip disabled */

return 1


/************************************************/
/* procedure from TEST-CGI.CMD by  Frankie Fan <kfan@netcom.com>  7/11/94 */
DecodeKeyVal: procedure
  parse arg Code
  Text=''
  Code=translate(Code, ' ', '+')
  rest='%'
  do while (rest\='')
     Parse var Code T '%' rest
     Text=Text || T
     if (rest\='' ) then
      do
        ch = left( rest,2)
        if verify(ch,'01234567890ABCDEF')=0 then
           c=X2C(ch)
        else
           c=ch
        Text=Text || c
        Code=substr( rest, 3)
      end
  end
  return Text



/**********************/
mkPACK64:procedure
parse arg mess

biga=xrange('A','Z')||xrange('a','z')||xrange('0','9')||'+/'

s2=x2b(c2x(mess))

nith=trunc((length(s2)/6)+.9)
cont=copies(' ',nith)
oof=""
do mm=0 to 63
      oof=oof||x2c(b2x(right('00'||x2b(d2x(mm)),6)))
end /* do */
do ith=1 to nith 
  a1=substr(s2,(ith*6)-5,6,0)
  cont=overlay(x2c(b2x(a1)),cont,ith) 
end /* do */
pint=""
pint=translate(cont,biga,oof)
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint

/************/
/* unpack64   :  astring=unpack64(mkpack64(astring)) */

unpack64:procedure
char_set='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
do mm=0 to length(char_set)-1
   a.mm=substr(char_set,mm+1,1)
end /* do */

parse arg mess
newmess=""
do mm=1 to length(mess)
   a1=substr(mess,mm,1)
   a1a=c2d(a1)
   select
     when a1a>64 & a1a<91  then a1b=a1a-65  /* ascii 65 to 90 */
     when a1a>96 & a1a<123 then a1b=26+(a1a-97)  /* ascii 97 to 122 */
     when a1a>47 & a1a<58  then a1b=a1a+4   /* ascii 48 to 57 */
     when a1='+' then a1b=62
     when a1='/' then a1b=63
     when a1='=' then iterate
     otherwise return ""        /* error */
   end
   pp=x2b(d2x(a1b))
   if length(pp)>6 then
        pp=substr(pp,3)
   else
        pp=right(pp,6,0)
   newmess=newmess||pp
end
ilen=trunc(length(newmess)/8)*8 ; newmess=left(newmess,ilen)
newm=x2c(b2x(newmess))
return newm


/************/
/* say an error string */
saystring:procedure
say 'content-type: text/plain'
say
parse arg aa
say aa
say
return 1



/***********/
/* get a url, using socket calls */
get_a_url:procedure expose servername  verbose
parse arg server,request,username,pwd

if abbrev(translate(server),'HTTP://')=1 then parse var server . '://' server

crlf = '0d0a'x

parse var server server ':' httpport
server=strip(server);
if httpport='' then httpport=80
httpport=strip(httpport)
family  ='AF_INET'

rc=1
if verify(server,'1234567890.')>0 then 
   rc=sockgethostbyname(server, "serv.0")  /* get dotaddress of server */
else
  serv.0addr=strip(server)

if rc=0 then do
   if verbose>1 then call pmprintf(' RUpdater-cgi ERROR: Unable to resolve "'server'"')
   return ' '
end

dotserver=serv.0addr                    /* .. */

gosaddr.0family=family                  /* set up address */
gosaddr.0port  =httpport
gosaddr.0addr  =dotserver

gosock = SockSocket(family, "SOCK_STREAM", "IPPROTO_TCP")

message='GET 'request ' HTTP/1.1'crlf'HOST:'server||crlf

message=message||'Referer:Rupdater-cgi@'||servername||crlf
if upwd<>' ' then  message=message||'Authorization: '||upwd||crlf
message=message||'Connection: close' crlf

if username<>'' then do
   upwd=mkbase64(strip(username)':'strip(pwd))
   upwd='Basic 'upwd
   message=message||'Authorization: '||upwd||crlf
end
message=message||crlf
got=''
rc = SockConnect(gosock,"gosaddr.0")
if rc<0 then do; 
  if verbose>1 then
     call pmprintf('RUpDater-CGI ERROR: Unable to connect to "'server'"')
  return ' '
end
rc = SockSend(gosock, message)
/* Now wait for the response */
do r=1 by 1
  rc = SockRecv(gosock, "response", 1000)
  got=got||response
  if rc<=0 then leave
end 
rc = SockClose(gosock)

findit=crlf||crlf
ifindit=pos(findit,got)
t1=substr(got,1,ifindit)

/* look for 401 return code */
parse var t1  line1 '0d0a'x t2
parse var line1 . icode .
if icode>399  then do
  if verbose>1 then
     call pmprintf('RUpDater-CGI ERROR: not able ('icode') to query 'server)
  return ' '
end

return substr(got,ifindit+4)


/************/
/* create a base64 packing of a message */
mkbase64:procedure

do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
s2=x2b(c2x(mess))
ith=0
do forever
   ith=ith+1
   a1=substr(s2,1,6,0)
   ms.ith=x2d(b2x(a1))
   if length(s2)<7 then leave
   s2=substr(s2,7)
end /* do */
pint=""
do kk=1 to ith
    oi=ms.kk ; pint=pint||a.oi
end /* do */
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint


