/* 25 Dec 1999. Daniel Hellerstein (danielh@crosslink.net)
  UpDater: An rsync based server-to-server updater.
            
        This is the "remote" portion.

 For details, see updater.doc

Reminder: this portion uses the "sitelist.in" files, that is stored in the
updater_dir directory.

SITELIST.IN file contains "mime-like" records, with each record containing
several single-line entries, and with records seperated by blank lines.
Entries have the following structure:
   name: value
where
  name may be one of  site, username, password, or description


*/


/**** User changeable parameters ****/

/*  the "updater" directory -- should be a fully qualified directory.
    Or, leave it blank to use the default (the UPDATER subdirectory of 
    the GoServe working directory). */

UPDATER_DIR='' 
  
/* colors and or background used in some html displays */
back1='bgcolor="#88aa66"'

/* allow use of GZIP encoding */
candogzip=1

/**** End of User changeable parameters ****/

rupdater:    

parse arg  ddir, tempfile, reqstrg,list,verb ,uri,user, ,
          basedir ,workdir,privset,enmadd,transaction,verbose, ,
         servername,host_nickname,homedir,aparam,semqueue,prog_file,reqnum


if verb="" then do
   say " This SRE-http procedure is not meant to be run in stand-alone mode. "
   exit
end  /* Do */

signal on error name badguys; signal on syntax name badguys
crlf = '0d0a'x

call check_dlls         /* load some dlls */


/* may need this below */
parse var privset privset1 ',' privset2
privset=privset1||' '||privset2

if updater_dir='' then do
     updater_dir=strip(basedir,,'\')'\UPDATER'
end /* do */

if dosisdir(updater_dir)=0 then do
     'string UPDATER configuration error. No such updater directory: 'updater_dir      
      return ' '
end

sites_dir=updater_dir'\SITES'
if dosisdir(sites_dir)=0 then do
     'string UPDATER configuration error. No such sites directory: 'sites_dir
      return ' '
end

sitelist_file=stream(sites_dir'\sitelist.in','c','query exists')
if sitelist_file='' then do
     'string UPDATER configuration error. No SITELIST.IN file in 'sites_dir
      return ' '
end
foo=stream(sitelist_file,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then do
  if verbose>1 then  call pmprintf('UPDATER configuration error: can not open 'sitelist_file)
  return 0
end
ii=stream(sitelist_file,'c','query size')
if ii='' | ii=0 then do
     'string UPDATER configuration error. Empty file: 'sitelist_file
      return ' '
end
sitelist=charin(sitelist_file,1,ii)||'0d0a'x||' '
foo=stream(sitelist_file,'c','close')

/* pull out arguments */
args.=''
if list='' then list='name=!list'
do until list=""                /* get user input */
   parse var list a1 '&' list
   parse var a1 a1a '=' a1b0
   a1a='!'||translate(strip(a1a))
   args.a1a=packur(strip(translate(a1b0,' ','+'||'000d0a09'x)))
end

call do_remote

return result


/********************************************/
/* the remote portion  */
do_remote:

call read_sitelist              /* load sitelist. stem */

if translate(args.!name)='!LIST' then do
   call get_sitelist
   return result
end

/* obtain a list of packages? */
if translate(args.!action)='GETP' then do          
  call get_site_packages
  return result
end

/* obtain the contents of  a package  */
if translate(args.!action)='GETL' then do          
  call get_a_package_list
  return result
end

/* start getting files from a package  */
if translate(args.!action)='DOIT' then do          
  call start_file_get
  return result
end


/* check status  */
if translate(args.!action)='STATUS' then do          
  call check_status
  return result
end

/* check reset  */
if translate(args.!action)='RESET' then do          
  call reset_it
  return result
end


'string unsupported '
return ' '


/*************/
/* construct a list of sites
*/
get_sitelist:

astext=1
call lineout tempfile,'<html><head><title>Currently accessible UpDater Sites </title></head>'
call lineout tempfile,'<body 'back1'>'
call lineout tempfile,'<h3>Welcome to UpDater (beta 1.10) !</h3>'
call lineout tempfile,'From this <em>remote server</em> (at 'servername')'
call lineout tempfile,'you can <u>update</u> <em>packages of files</em> from '
call lineout tempfile,'these <em>central servers</em> :'
call lineout tempfile,'<ol>'
do jj=1 to sitelist.0
  call lineout tempfile,'<li> <a href="http://'||servername'/rupdater?action=getP&name='sitelist.jj.!name'">'
  call lineout tempfile,sitelist.jj.!name'</a>: 'sitelist.jj.!description
end /* do */
call lineout tempfile,'</ol>'
call lineout tempfile,'<hr>Would you like to read the <a target="info" href="/updater?send=UPDATER.DOC&text=1">UpDater documentation</a>'
call lineout tempfile,'</body></html>'
call lineout tempfile
FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
return foo


/*************/
/* ask a site for it's list of packages */
get_site_packages:

 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     'string RUpdater Error: No such site: 'thename
      return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password
 stuff=get_a_url(aip,'UpDater?package=!list',auser,apwd)
 if stuff='' then return stuff

 call lineout tempfile,'<html><head><title>Currently available packages </title></head>'
 call lineout tempfile,'<body 'back1'>'
 call lineout tempfile,'<h3>UpDater packages offered by 'thename ' </h3> '
 
 parse var stuff ndo (crlf) stuff
 call lineout tempfile,'The <em>UpDater central server</em> at <tt>'thename'</tt>'
 call lineout tempfile,'currently supports 'ndo' <em>file packages</em><p>'
 call lineout tempfile,'<b>Please choose a package to update </b>'
 call lineout tempfile,'<ol>'
 do until stuff=''
   parse var stuff aline (crlf) stuff
   aline=strip(aline)
   if abbrev(aline,';')=1 then iterate
   parse var aline adate aname adesc
   parse var aname aname0 '.' .
   call lineout tempfile,'<li> <a href="/rupdater?action=getl&name='thename'&package='aname0'">'aname0'</a>: 'adesc
end /* do */
call lineout tempfile,'</ol>'

call lineout tempfile,'Or ...<menu>'
call lineout tempfile,'<li>you can directly query the <em>UpDater central server</em> '
call lineout tempfile, '<tt>'thename'</tt> <a href="http://'||aip'/updater?package=!list&ashtml=1">for the details </a>'
call lineout tempfile,'<li><a href="/Rupdater?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'
call lineout tempfile,'</menu>'
call lineout tempfile,'</body></html>'

call lineout tempfile
FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
return foo


/*************/
/* get a package list */
get_a_package_list:

 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     'string RUpdater Error: No such site: 'thename
      return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password
 aroot=sitelist.mm.!root

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    'string RUpDater error: no package specified '
    return ' '
  end

 if aroot='' then do
    'string RUpdater Error: No root directory info for 'thename','thepackage
    return ' '
 end

 if args.!nocache<>1 then
   areq='UpDater?action=getl&package='thepackage
 else
   areq='UpDater?action=getl&nocache=1&package='thepackage

 stuff=get_a_url(aip,areq,auser,apwd)
 if stuff='' then return stuff

this_site_dir=sites_dir'\'thename
oo=dosisdir(this_site_dir)
if oo=0 then do
   foo=sysmkdir(this_site_dir)
   if foo<>0 then do
      'string RUpDater error: unable to create 'this_site_dir' ('oo
      return ' '
   end
end

/* save this package list */
 plist_file=this_site_dir'\'thepackage'.pkg'
 foo=sysfiledelete(plist_file)
 foo=stream(plist_file,'c','open write')
 if abbrev(translate(foo),'READY')=0 then do
     'string RUpDater ERROR: Unable to create package file 'plist_file
     return ' '
 end /* do */
 oo=charout(plist_file,stuff,1)
 if oo<>0 then do
     'string RUpDater ERROR: Unable to write to package file 'plist_file
     return ' '
 end /* do */
 foo=stream(plist_file,'c','close')
 
 call lineout tempfile,'<html><head><title>Contents of an UpDater package </title></head>'
 call lineout tempfile,'<body 'back1'>'
 call lineout tempfile,'<h3>Are you ready to UpDate? </h3> '

 parse var stuff hdrl (crlf) stuff
 currenttime=0; created=0;age=0
 do until hdrl=''
    parse var hdrl avar hdrl
    parse var avar a1 '=' a2 ;a1=striP(translate(a1))
    if a1='PACKAGE' then packagename=strip(a2)
    if a1='CREATED' then created=a2
    if a1='CURRENT_TIME' then currenttime=a2
 end /* do */
 if created>0 & currenttime>0 then do
  numeric digits 10
  age=currenttime-created
  if age='0' then do
    hrs=0; days=0
  end
  else do
       parse var age days '.' mins ; mins='.'mins
       hrs=1440*mins/60
  end
 end /* do */


 call lineout tempfile,'<ul>'
 CALL LINEOUT TEMPFILE,'<li>Package location (the central server): <tt>'thename'</tt>'
 call lineout tempfile,'<li>Package: <tt>'packagename'</tt>'
 if age>0 then 
   call lineout tempfile,' <em>(using a version that is 'days 'days 'hrs 'hrs old )</em> '
 call lineout tempfile,'<a href="/rupdater?action=getl&nocache=1&name='thename'&package='packagename'&iter='||time('s')||'">'
 call lineout tempfile,' (request the latest version?)</a>'

 mm=0
 do until stuff=''
    parse var stuff aline (crlf) stuff
    aline=strip(aline) 
    if abbrev(aline,';')=1 then iterate
    mm=mm+1
    parse var aline entries.mm.!date entries.mm.!entry entries.mm.!file entries.mm.!rdir
 end /* do */
 call lineout tempfile,'<li>Number of files:<tt> 'mm'</tt>'
 call lineout tempfile,'<li>Package list saved to <tt>:'plist_file'</tt>'
 call lineout tempfile,'<li>You can save files to: <b>'aroot'</b>'
 call lineout tempfile,'</ul>'
 call lineout tempfile,'Reminder: the <u>package list</u> file, and the <u>save files to</u> directory,'
 call lineout tempfile,'are on this remote server at <tt>'servername'</tt>'

call lineout tempfile,'<hr width="30%">'

/* now create a form that lists options */
call lineout tempfile,'<form action="/RUPDATER" method="GET">'
call lineout tempfile,'<input type="hidden" name="action" value="doit">'
call lineout tempfile,'<input type="hidden" name="name" value="'thename'">'
call lineout tempfile,'<input type="hidden" name="package" value="'thepackage'">'

call lineout tempfile,'<input type="Submit" value="Get the files in 'packagename'... ">'
call lineout tempfile,'<table><tr valign="top">'

call lineout tempfile,'<tr valign="top"><td>Destination directory (on this remote server)</td> '
call lineout tempfile,'<td><input type="text" name="DESTDIR" value="'||word(aroot,1)||'" size=30> </td>'

call lineout tempfile,'<tr valign="top"><td>Backup directory (on this remote server).</td> '
call lineout tempfile,'<td><input type="text" name="BACKUPDIR" size=30>'
call lineout tempfile,'<br><em> To suppress backing up changed files, leave this field empty.</em></td>'


call lineout tempfile,'<tr valign="top"><td>Update checks &amp; cleanup option</td>'
call lineout tempfile,'<td><input type="radio" name="TIMECHECK" value="1" checked> '
call lineout tempfile,'Update if newer (using file creation date) <bR>'
call lineout tempfile,'<input type="radio" name="TIMECHECK" value="2" > '
call lineout tempfile,'Update if 32bit (crc32) file hash is different <bR>'
call lineout tempfile,'<input type="radio" name="TIMECHECK" value="3" > '
call lineout tempfile,'Update if 128bit (md4) file hash is different <bR>'
call lineout tempfile,'<input type="radio" name="TIMECHECK" value="0">'
call lineout tempfile,'Always update '

call lineout tempfile,'<hr width="25%"> <input type="checkbox" name="DELETE" value="1" > '
call lineout tempfile,'Delete all existing files (in the destination directory) that are not mentioned in this package'
call lineout tempfile,'</td>'


call lineout tempfile,'<tr valign="top"><td valign="top">Range to retrieve</td>'
call lineout tempfile,'<td> Enter two numbers: from  '
call lineout tempfile,'#<input type="text" name="RANGE1"  size=5> to '
call lineout tempfile,'#<input type="text" name="RANGE2"  size=5> <em>(leave both boxes blank to retrieve all files)</em>'

call lineout tempfile,'</td>'
call lineout tempfile,''
call lineout tempfile,''
call lineout tempfile,''
call lineout tempfile,'</table>'


call lineout tempfile,''
call lineout tempfile,''
call lineout tempfile,''
ab='Get the files in 'packagename'...'
call lineout tempfile,'<input type="Submit" value="'||reverse(ab)||'">'

call lineout tempfile,'</form>'

call lineout tempfile,'<a href="/Rupdater?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'

call lineout tempfile,'</body></html>'

call lineout tempfile
FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
return foo


/*************/
/* check status of an update requests */
reset_it:
 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     'string RUpdater Error: No such site: 'thename
      return ' '
 end

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    'string RUpDater error: no package specified '
    return ' '
  end

  asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(thepackage)
  istat=eventsem_close(asem)

  suicide=translate(asem||'_DIE')
  istat=eventsem_post(suicide)
  if Istat=187 then do                  /* doesn't exist, so create it posted */
      istat=eventsem_create(suicide,'P')
  end /* do */

  this_site_dir=sites_dir'\'thename
  oo=dosisdir(this_site_dir)
  if oo=0 then do
     'string RUpDater error: unable to find directory 'this_site_dir
     return ' '
  end 
  outfile=this_site_dir'\'thepackage'.rpt'
  foo=0

  foot=eventsem_post(suicide)
  
  if foo>0 then do
    call lineout tempfile,'<html><head><title>UpDater ReSet Failed </title></head>'
    call lineout tempfile,'<body 'back1'>'
    call lineout tempfile,'<h3>UpDater ReSet Failed  </h3> '
    call lineout tempfile,'Unable to reset UpDater. You may have to restart this server'
    call lineout tempfile,"</body></html>"
    call lineout tempfile
    FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
  end 

   call lineout tempfile,'<html><head><title>UpDater ReSet </title></head>'
   call lineout tempfile,'<body 'back1'>'
   call lineout tempfile,'<h3>UpDater ReSet  </h3> '
   call lineout tempfile,'UpDater has been reset.<p>'
   call lineout tempfile,' -- you should now be able to submit an UpDater request'
   call lineout tempfile,'<br>Or, <a href="/Rupdater?">return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'
   call lineout tempfile,"</body></html>"
    call lineout tempfile
    FOO=SREF_GOS('FILE erase text/html NAME 'tempfile)
    return foo
 


/*************/
/* check status of an update requests */
check_status:
 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     'string RUpdater Error: No such site: 'thename
      return ' '
 end

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    'string RUpDater error: no package specified '
    return ' '
  end

  this_site_dir=sites_dir'\'thename
  oo=dosisdir(this_site_dir)
  if oo=0 then do
     'string RUpDater error: unable to find directory 'this_site_dir
     return ' '
  end 
  outfile=this_site_dir'\'thepackage'.rpt'

  asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(thepackage)
  istat=eventsem_query(asem)

  iss=stream(outfile,'c','query size')
  if iss=0 | iss='' then do
     'string RUpDater warning: empty report file 'outfile
     return ' '
  end
  foo=stream(outfile,'c','close')
   call lineout tempfile,'<html><head><title>UpDater Status </title></head>'
   call lineout tempfile,'<body 'back1'>'
   call lineout tempfile,'<h3>UpDater status  </h3> '
   call lineout tempfile,'The <a href="/rupdater?action=status&name='thename'&package='thepackage'&iter='||time('s')'">'
   call lineout tempfile,'update</a>'
   call lineout tempfile,'of the <em> 'thepackage ' </em> package on the<tt> 'thename '</tt>'
   call lineout tempfile,'<em>central server</em> to this <em>remote server </em> (<tt>'servername'</tt>)'
   call lineout tempfile,'<p><b>Status</b>:'
   if istat=1 then  call lineout tempfile,'<tt><b>Package is now being updated</b></tt>'
   if istat<=0 then call lineout tempfile,'<tt><b>Package is <u>not</u> currently being updated </b></tt>'
   call lineout tempfile,'<p><b>Current status report:</b> '
   call lineout tempfile,' <em>('outfile') </em>'

 iok=0
 signal on error name oy1 ; signal on syntax name oy1 
 goon=this_site_dir'\'thepackage'.sta'
 address cmd '@type 'outfile ' > ' goon
 iok=1

oy1:            /* jump here if @type doesn't work */
   signal on error name badguys; signal on syntax name badguys

   if rc=0   & iok<>0 then do   /* chek for > output */
     jsz=stream(goon,'c','query size')
   end
   if rc<>0  | iok=0 | jsz=0 | jsz='' then do
      call lineout tempfile,'<p><b>Unable to read status file</b>. Please wait a few seconds'
      call lineout tempfile,'and '
      call lineout tempfile,'<a href="/rupdater?action=status&name='thename'&package='args.!package'&iter='||time('s')'">'
      call lineout tempfile,'try again</a>'
      call lineout tempfile,'<p> Or... you can '
      call lineout tempfile,'<a href="/rupdater?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
      call lineout tempfile,'stop &amp; reset UpDater</a>'
      call lineout tempfile,'</body></html>'
      call lineout tempfile
      foo=sysfiledelete(goon)
      FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
      return foo
   end /* do */
   call lineout tempfile,'<pre>'

   ook=charin(goon,1,jsz)
   call charout tempfile,ook
   call lineout tempfile,'</pre>'
   foo=stream(goon,'c','close')
   foo=sysfiledelete(goon)

   call lineout tempfile,'<hr><h4>Note</h4>'
   call lineout tempfile,'If you need to stop this update, or if UpDater seems '
   call lineout tempfile,'to be hung, you can try to '
   call lineout tempfile,'<a href="/rupdater?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
   call lineout tempfile,'stop &amp; reset UpDater</a>'

  call lineout tempfile,'<br>Or, <a href="/Rupdater?">return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'

   call lineout tempfile,'</body></html>'
   call lineout tempfile
   FOO=SREF_GOS('FILE  erase TYPE text/html NAME 'tempfile)
   return foo
end /* do */
     


/*************/
/* start to get files from a package */
start_file_Get:


 thename=strip(translate(args.!name))

 imatch=0
 do mm=1 to sitelist.0
     if translate(sitelist.mm.!NAME)<>thename then iterate
     imatch=mm
     leave
 end /* do */
 if imatch=0 then do
     'string RUpdater Error: No such site: 'thename
      return ' '
 end

 aip=sitelist.mm.!address
 auser=sitelist.mm.!username
 apwd=sitelist.mm.!password
 aroot=sitelist.mm.!root
 akey=sitelist.mm.!key
 if akey='' then akey=0

 thepackage=strip(translate(args.!package))
 if thepackage='' then do
    'string RUpDater error: no package specified '
    return ' '
  end

asem='\SEM32\SRE_UPDATER_'||translate(thename)||'_'||translate(args.!package)
foo=eventsem_query(asem)

if foo>=1 then do               /* updater is running on this package */
   call lineout tempfile,'<html><head><title>RUpDater is busy </title></head>'
   call lineout tempfile,'<body 'back1'>'
   call lineout tempfile,'<h3>RUpDater is busy </h3> '
   call lineout tempfile,'The <em>'args.!package'</em> package from the <tt>'thename'</tt> server is currently being updated'
   call lineout tempfile,'<p>To (re)update this package, please try again in a few minutes '
   call lineout tempfile,'<blockquote>Would you like to <a href="/rupdater?action=status&name='thename'&package='args.!package'&iter='||time('s')||'">'
   call lineout tempfile,'query the status of this update</a>?</blockquote>'
   call lineout tempfile,'</body></html>'
   call lineout tempfile
   FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
   return foo
end /* do */

destdir=strip(translate(args.!destdir))
destdir=translate(strip(destdir,,'\'))
if destdir='' then do
     'string RUpdater Error: You forgot to specify a destination directory.'
      return ' '
end

backdir=strip(translate(args.!backdir))
if backdir='' then backdir=0

if aroot='' then do
     'string RUpdater Error: No root directory info for 'thename','thepackage
      return ' '
end

dd=destdir'\'
/* check to see if destdir is permitted */
isok=0
do mm=1 to words(aroot)
   aroot0=translate(strip(word(aroot,mm)))
   aroot0=strip(aroot0,,'\')'\'
   if abbrev(dd,aroot0)=1 then do
       isok=1 ; leave
    end
end
if isok=0   then do
     'string RUpdater Error: Destination directory not allowed: 'destdir
      return ' '
end

if backdir<>0 then do           /* is backup directory allowed */
  backdir=translate(strip(backdir,,'\'))
  dd=backdir'\'
  isok=0
  do mm=1 to words(aroot)
   aroot0=translate(strip(word(aroot,mm)))
   aroot0=strip(aroot0,,'\')'\'
   if abbrev(dd,aroot0)=1 then do
       isok=1 ; leave
    end
  end
  if isok=0   then do
     'string RUpdater Error: Backup directory not allowed: 'backdir
      return ' '
  end
end
  


this_site_dir=sites_dir'\'thename
oo=dosisdir(this_site_dir)

if oo<>0 then do          /* check for .pkg file */
 plist_file=this_site_dir'\'thepackage'.pkg'
 foo=stream(plist_file,'c','open read')
end

if oo=0  |  abbrev(translate(foo),'READY')=0 then do
   call lineout tempfile,'<html><head><title>Package list not found </title></head>'
   call lineout tempfile,'<body 'back1'>'
   call lineout tempfile,'<h3>A package list is not available </h3> '
   call lineout tempfile,'A <em> package list </em> for the <tt>'thepackage'</tt> package '
   call lineout tempfile,'(from the <tt>'thename'</tt>site) is not available<p>'
   call lineout tempfile,'Would you like to <a href="/rupdater?action=getl&name='thename'&package='thepackage'">'
   call lineout tempfkle,'download it now</a>? '
   call lineout tempfile,'</body></html>'
   call lineout tempfile
   FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
   return foo
end

call lineout tempfile,'<html><head><title>UpDating a package of files </title></head>'
call lineout tempfile,'<body 'back1'>'
call lineout tempfile,'<h3>UpDating a package of files </h3> '
call lineout tempfile,'UpDater is now obtaining files from the 'thepackage ' package on the 'thename ' site.'
call lineout tempfile,'<p><b>Notes:</b>'
call lineout tempfile,'<menu>'
call lineout tempfile,'<li>Files written to <tt>'destdir'</tt>'
if args.!backdir<>0 & args.!backdir<>'' then
call lineout tempfile,'<li>Changed files backed up to <tt>'args.!backdir'</tt>'

call lineout tempfile,'<li>Using the package-list in:<tt> 'plist_file'</tt>'
if args.!delete=1 then
   call lineout tempfile,'<li>Files not specified in the package-list <b>will</b> be deleted '
else
   call lineout tempfile,'<li>Files not specified in the package-list will <b>not</b> be removed '

select 
  when args.!timecheck=0 then
   call lineout tempfile,'<li><b>All</b> files will be downloaded'
  when args.!timecheck=1 then
   call lineout tempfile,'<li>Only files with older dates will be downloaded'
  when args.!timecheck=2 then
   call lineout tempfile,'<li>Only files that have changed will be downloaded'
  when args.!timecheck=3 then
   call lineout tempfile,'<li>Only files that have changed (strong check) will be downloaded'

  otherwise nop
end

arange1=strip(args.!range1)
arange2=strip(args.!range2)

if args.!range1>0 & datatype(args.!range1)='NUM' then 
    call lineout tempfile,'<li>Range specified:<tt> 'args.!range1' - 'args.!range2'</tt>'

call lineout tempfile,'</ul>'

/* now, launch a thread that will obtain the files in plist_file, from package
  the package at the server at aip (with auser and apwd username and password )
*/

backdir=strip(args.!backdir)
if backdir='' then backdir=0
tcheck=pos(args.!timecheck,'123') ; dodel=1
if args.!delete<>1 then dodel=0
if arange1='' | arange2='' then 
   arange12=0
else
   arange12=arange1':'arange2
args='OBTAIN 'plist_file'  '||strip(auser)||':'||strip(apwd)||' 'destdir' 'tcheck' 'dodel' 'asem' 'backdir' 'arange12' 'akey
aprog=updater_dir'\updaemon.cmd'
tid0=rexxthread('f',aprog,args)

if tid0>0 then do
 do mm=1 to 20
   call syssleep(0.1)
   foo=eventsem_wait(asem,7000)
   if foo=0 then leave
 end
end

if tid0=0 | foo<>0 then do
   call lineout tempfile,'<p><B>FAILURE! ('foo')</b>'
   call lineout tempfile,'Unable to start the UpDater Daemon. Try again later'
   call lineout tempfile,'... or, you can try to '
   call lineout tempfile,'<a href="/rupdater?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
   call lineout tempfile,'stop &amp; reset UpDater</a>'
   call lineout tempfile,'</body></html>'
   call lineout tempfile
   FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
   return foo
end /* do */

call lineout tempfile,'<menu>'
call lineout tempfile,'<li>Do you want to <a href="/rupdater?action=status&name='thename'&package='thepackage'&iter='||time('s')||'">'
call lineout tempfile,'check the status</a> of this package acquisition?'
call lineout tempfile,'<li><a href="/Rupdater?">Return to the main menu</a> (of the <em>UpDater remote server </em> at 'servername')'
call lineout tempfile,'<li><a href="/rupdater?action=reset&name='thename'&package='thepackage'&iter='||time('s')'">'
call lineout tempfile,'Stop &amp; reset UpDater</a>'
call lineout tempfile,'</menu>'

call lineout tempfile,'</body></html>'
call lineout tempfile
FOO=SREF_GOS('FILE erase TYPE text/html NAME 'tempfile)
return foo





/*************************************/
/* read sitelist */
read_sitelist:procedure expose sitelist. crlf sitelist

doing=0
sitelist.=''
sitelist.0=0
do until sitelist=''

  parse var sitelist aline (crlf) sitelist
  aline=strip(aline)

  if abbrev(aline,';')=1 then iterate   /* skip comments */
  if aline='' & doing=0 then iterate   /* skip multiple blank lines */
  if aline='' & doing=1 then do                /* end of record */
     doing=0
     iterate
  end 

  if doing=0 then do            /* start of a new record */
     sitelist.0=sitelist.0+1
     doing=1
  end
  if pos(':',aline)=0 then iterate  /* error, ignore */

  ith=sitelist.0


  parse var aline aname ':' avalue
  aname=strip(translate(aname))
      
  SELECT
    when abbrev(aname,'NAME')=1 then sitelist.ith.!NAME=space(avalue,0)
    when abbrev(aname,'ADD')=1  then sitelist.ith.!ADDRESS=space(avalue,0)
    when abbrev(aname,'DESC')=1 then sitelist.ith.!DESCRIPTION=avalue
    when abbrev(aname,'USER')=1 then sitelist.ith.!USERNAME=avalue
    when abbrev(aname,'PASS')=1 then sitelist.ith.!PASSWORD=avalue
    when abbrev(aname,'KEY')=1 then sitelist.ith.!KEY=avalue
    when abbrev(aname,'ROOT')=1 then sitelist.ith.!ROOT=strip(avalue)
    otherwise nop
  end

end             /* do loop */
return 1



/*** jump here on error */
badguys:
say "rupdater error "Rc " at " sigl
if completed()=0 then 'string error 'rc ' at ' sigl
return ' '


/********************/
/* check for gzip and rsync dlls -- note that we assume rxsock, rexxutil,
   and rexxlib are available */

check_dlls:

if rxfuncquery('rx_md4')=1  then do
  foo=RXFuncAdd( 'RXRsyncLoad', 'RXRSYNC', 'RxRsyncLoad')
  if foo=0 then call RxRsyncLoad
end
if rxfuncquery('rx_md4')=1  then do
   candorsync=0
   call pmprintf("UpDater warning: unable to find rxrsync")
end

return 0
 
/* the following is here as a reference (gzip is not currently used by rupdater */

if rxfuncquery('rxgzLoadFuncs')=1  then do
  foo=RXFuncAdd( 'rxgzLoadFuncs', 'rxgzLIB', 'rxgzLoadFuncs')
  if foo=0 then call rxgzLoadFuncs
end
if rxfuncquery('rxgzLoadFuncs')=1  then do
   candogzip=0
   call pmprintf("UpDater warning: unable to find rxgzlib")
end
return 0


/***********/
/* get a url, using socket calls */
get_a_url:procedure expose servername crlf
parse arg server,request,username,pwd

if abbrev(translate(server),'HTTP://')=1 then parse var server . '://' server

parse var server server ':' httpport
server=strip(server);
if httpport='' then httpport=80
httpport=strip(httpport)
family  ='AF_INET'

rc=1
if verify(server,'1234567890.')>0 then 
   rc=sockgethostbyname(server, "serv.0")  /* get dotaddress of server */
else
  serv.0addr=strip(server)

if rc=0 then do
   'string RUpdater ERROR: Unable to resolve "'server'"'; 
   return ' '
end

dotserver=serv.0addr                    /* .. */

gosaddr.0family=family                  /* set up address */
gosaddr.0port  =httpport
gosaddr.0addr  =dotserver

gosock = SockSocket(family, "SOCK_STREAM", "IPPROTO_TCP")

message='GET 'request ' HTTP/1.1'crlf'HOST:'server||crlf

message=message||'Referer:Rupdater@'||servername||crlf
if upwd<>' ' then  message=message||'Authorization: '||upwd||crlf
message=message||'Connection: close' crlf

if username<>'' then do
   upwd=mk_base64(strip(username)':'strip(pwd))
   upwd='Basic 'upwd
   message=message||'Authorization: '||upwd||crlf
end
message=message||crlf
got=''
rc = SockConnect(gosock,"gosaddr.0")
if rc<0 then do; 
  'string RUpDater ERROR: Unable to connect to "'server'"'
  return ' '
end
rc = SockSend(gosock, message)
/* Now wait for the response */
do r=1 by 1
  rc = SockRecv(gosock, "response", 1000)
  got=got||response
  if rc<=0 then leave
end 
rc = SockClose(gosock)

findit=crlf||crlf
ifindit=pos(findit,got)
t1=substr(got,1,ifindit)

/* look for 401 return code */
parse var t1  line1 '0d0a'x t2
parse var line1 . icode .
if icode>399  then do
  'string RUpDater ERROR: not able ('icode') to query 'server
  return ' '
end

/* is this chunked? */
t1a=t2
do until t1a=''
   parse var t1a aline '0d0a'x t1a
   parse upper var t1a avar ':' aval
   if strip(avar)='TRANSFER-ENCODING' then do
        if pos('CHUNK',aval)>0 then do
           stuff=DO_unchunk(substr(got,ifindit+4))
           RETURN STUFF
        end /* do */
   end /* do */
END

return substr(got,ifindit+4)


/* unchunk a chunked entity.
  a : the chunked entity entire body)
 inct: if 1, add trailers at beginning of entity (trailers crlf entity) 
*/

DO_unchunk:PROCEDURE
parse arg a,inct

stuff=''
do forever 
  parse var a a1 '0d0a'x a
  parse var a1 a2 ';' .
  da2=x2d(strip(a2))
  if da2=0 then leave
  stuff=stuff||left(a,da2)
  a=substr(a,da2+3)     /* skip crlf */
end

return stuff

/************/
/* create a base64 packing of a message */
mk_base64:procedure

do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
s2=x2b(c2x(mess))
ith=0
do forever
   ith=ith+1
   a1=substr(s2,1,6,0)
   ms.ith=x2d(b2x(a1))
   if length(s2)<7 then leave
   s2=substr(s2,7)
end /* do */
pint=""
do kk=1 to ith
    oi=ms.kk ; pint=pint||a.oi
end /* do */
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint

