/* 2 Jan 2000. Daniel Hellerstein (danielh@crosslink.net)
  The Updater remote client, Netscape helper app 
*/

/**** Begin User changeable parameters ****/

/* Disable the "auto delete of files not in this package" feature
   Set to 1 to disable, 0 to enable. If 1, you will be prompted
   before deletion starts, 0 means "no prompting" */
prompt_auto_delete=1

/* Allow use of rsync encoding. 1=enable, 0=disable
   If you do not have the rxrsync.dll, you should set this to 0. 
   Note: the adler-32 check requires rxrsync.dll */
candorsync=1

/* allow use of GZIP encoding. 1=enable, 0=disable
   If you do not have the gzip.exe, you should set this to 0. */
candogzip=0

/* set of "encryption" specs. ENCRYPT.!BLOWFISH is an example,
  you can delete it if you will never use blowfish */
ENCRYPT.!blowfish='bf -q -d %in %out "%key"'

/* file to log results to. Leave it blank to NOT log results */
logfile=''

/* interval to show "processing file" message, in quiet mode */
quiet_interval=25

/* max seconds to wait for each 1000 byte socket call.
   For slow connections, you may need to increase this */
timeout=30
   
/* program to use to view "results files". Leave blank to suppress this
   option */
viewer='E'

/* status message reporting, 0=few, 1=some, 2=more, 3=too much */
verbose=1

/**** End of User changeable parameters ****/

signal on error name badguys; signal on syntax name badguys
signal on halt name badguys2 ; signal on failure name badguys 
crlf = '0d0a'x
foo=time('r')

call check_dlls         /* load some dlls */
say "       "cy_ye"UpClient: for UpDating files to your computer"normal

temp_dir=strip(value('TEMP',,'os2environment'),'t','\')

parse arg listfile
listfile=strip(listfile)

if listfile='' then do
   say " UpClient is meant to be run as a Netscape helper application"
   exit
end  /* Do */

call read_stuff /* read input file, and parse header info */

/* extract a list of files to GET */
mm=0
do until stuff=''
    parse var stuff aline (crlf) stuff
    aline=strip(aline) 
    if abbrev(aline,';')=1 then iterate
    if aline='' then iterate
    mm=mm+1
    parse var aline entries.mm.!date entries.mm.!entry entries.mm.!file entries.mm.!rdir entries.mm.!noce entries.mm.!crc entries.mm.!asize .
end /* do */
if mm=0 then do
   say
   say reverse"ERROR: "normal"there are no files specified. " 
   say "Perhaps there is a problem with the specification of this package? "
   say 
   call get_key
   exit
end /* do */
entries.0=mm

servername=get_hostname()   /* address of this machine */

/* now get the files ! */
stat.=0
didit.=0

if datatype(quiet_interval)<>'NUM' then quiet_interval=25
retrys.=0
retrying=0

len1=length(entries.0)+1

rng1=1
rng2=entries.0
if pos(':',arange)>0 then do
    parse  var arange j1 ':' j2
    if datatype(j1)='NUM' & datatype(j2)='NUM' then do
         rng1=j1 ; rng2=j2
    end /* do */
end /* do */

if encrypts<>"" then shared_secret=ask_shared()

if dodelete=1 & prompt_auto_delete=1 then do
   if length(destdir||opts.!package)>30 then do
      say '   'bold' Delete all files (in 'destdir') '
      DODELETE=YESNO(NORMAL'   'BOLD'that do not belong to 'OPTS.!PACKAGE)
   end 
   ELSE DO
      DODELETE=YESNO(NORMAL'  'bold'Delete all files (in 'destdir') that do not belong to 'OPTS.!PACKAGE)
   END
end 

/* ask for options */
if logfile<>'' then logfile=set_logfile(logfile,1)
call askopts 'U'

if logfile<>'' then do
  foo=write_message(logfile,1,'UpClient log on 'date('n')' 'time('n') )
  foo=write_message(logfile,1,'   Package: '||opts.!package)
  if  age>0 then do
      foo=write_message(logfile,1, '   (last updated: 'days 'days and ' hrs 'hours ago)')
  end
  else do
      foo=write_message(logfile,1,'   (just updated)')
  end
  foo=write_message(logfile,1,'   which is on the server at: '|| opts.!server)
  foo=write_message(logfile,1,'These will be written to your computer, using...')
  foo=write_message(logfile,1,'   Destination Directory: 'destdir)
  foo=write_message(logfile,1,'   # of files: 'ict '(in 'idirs' directories)')
  foo=write_message(logfile,1,'   Backup Directory: 'backupdir)
  foo=write_message(logfile,1,' ')
end


tocheck=1+rng2-rng1

doretry:                /* jump here to retry unGETable files */

tt=bold'# of files to check: 'normal||tocheck
if norexxlib=1 then
    mestt=tt||' 'cy_ye' (hit ctrl-c to abort)'normal
else
    mestt=tt||' 'cy_ye'(hit ESC to abort)'normal
say mestt
say 

if logfile<>'' then do 
  foo=write_message(logfile,1,'# of files to check: '||tocheck)
  foo=write_message(logfile,1,' ')
end /* do */

didprocess=0

/* open up a socket (and try to re use it as much as possible */
gosock=sockhttp_opensock(,opts.!server)
say " Using socket # "gosock','opts.!server
if abbrev(gosock,'-1')=1 then do
  say "Error, unable to create socket to " server
  exit
end


/* temp file for use by sockhttp */
tempfile0=make_tempname('UC1',norexxlib,temp_dir)


do mm0a=rng1 to rng2
  tempfile=tempfile0
  if norexxlib=0 then do                /*look for escape key */
      aesc=inkey('N')
      iesc=c2x(aesc)
      if iesc=d2x(27) then do
        say 
        say bold "Processing halted "normal" at file # "normal||mm0a
        leave
      end 
  end 

  didprocess=didprocess+1

  if quiet=1 then do
      if (mm0a//quiet_interval)=1 then do
         call charout,bold||' Processing file #: 'normal||mm0a'        '||'0d'x
      end /* do */
  end /* do */
  if retrying=0 then
     mm0=mm0a
  else
     mm0=retrys.mm0a

   cmm0=right(mm0,len1)': '
   afile=entries.mm0.!file
   afilel=strip(translate(afile,'\','/'),,'\')
   rdir0=strip(strip(translate(entries.mm0.!rdir,'\','/')),,'\')
   if rdir0='' then
      tofile=destdir||'\'||afilel
   else
      tofile=destdir||'\'||rdir0||'\'||afilel

/* skip check */
   if skiplist<>"" then do
       didskip=0
       do mm=1 to words(skiplist)
           awrd=strip(word(skiplist,mm))
           oo=wild_match(tofile,awrd)
           if oo<>0 then do             /* matches a skip pattern */
             stat.!skipped=stat.!skipped+1
             foo=write_message(logfile,quiet, ,
                                  cmm0||bold'Skipped 'normal'('awrd ' match) 'normal||tofile)
             didskip=1 ; leave
           end 
        end
        if didskip=1 then iterate
   end 
   
   todir=filespec('d',tofile)||filespec('p',tofile)
   if ais_dir(strip(todir,,'\'))=0 then do
       foo=sysmkdir2(todir)
       if foo<>0 then do
          stat.!nocreate=stat.!nocreate+1
           foo=write_message(logfile,quiet, ,
                           cmm0||reverse'ERROR 'normal'could not make directory for 'tofile)
          iterate
       end
   end

   backfile=''
   if backupdir<>'' then do
      backfile=backupdir'\'afilel
      backdir=filespec('d',backfile)||filespec('p',backfile)
      if ais_dir(strip(backdir,,'\'))=0 then do
        foo=sysmkdir2(backdir)
        if foo<>0 then do
          stat.!nocreate=stat.!nocreate+1
          foo=write_message(logfile,quiet, ,
                  cmm0||reverse'ERROR'normal' could not make backup directory for 'backfile)
          iterate
       end
     end                /* backupdir exists*/
   end          /* backupdir specified */

   foo='!'||strip(translate(tofile))
   didit.foo=1

/* check date first ? */
   arf=sysfiletree(tofile,'tt','FT')
   oldfile=''; timecheck=strip(timecheck)
   if tt.0<>0 then do           /* compare dates */
        oldfile=tofile
        if timecheck=1 then do                  /* update newer files only */
           parse var tt.1 todate . . .
           if left(todate,2)<70 then
              todate='20'||todate
           else
              todate='19'||todate
           if todate>= entries.mm.!date then do
                stat.!nochange=stat.!nochange+1
                foo=write_message(logfile,quiet, ,
                        cmm0||bold'No change'normal' (timestamp check) in 'tofile)
                iterate
           end /* do */
        end                      /*timecheck */
        if candoadler=1 & timecheck=2 & entries.mm0.!crc<>'' then do          /* compare crc32?*/       
           thiscrc=fileadler(oldfile)
           if strip(translate(thiscrc))=strip(traNslate(entries.mm0.!crc)) then do
                stat.!nochange=stat.!nochange+1
                foo=write_message(logfile,quiet,cmm0||bold'No change'normal' (crc32 check) in 'tofile)
                iterate
           end /* do */
        end /* do */
   end                /* found old version */

   aentry=entries.mm0.!entry
   req='/'||opts.!selector||'?package='opts.!package'&action=file&file='afile'&entry='aentry
   
   if retrying=1 then req=req'&no_encoding=1'

   if timecheck=3 & candoadler=1 & oldfile<>'' then do
      dmd4=rx_md4(oldfile,1)
      req=req'&md4='dmd4
   end 

   if candogzip=1 & opts.!GZIP=1 & entries.mm0.!noce=0 then do
     req=req'&gzip=1'
   end          

   if candorsync=1 & opts.!rsync=1 & entries.mm0.!noce=0 then do
      rsyncok=1
      req=req'&rsync=1'
   end
   else do
      rsyncok=0
   end

   if encrypts<>'' & shared_secret<>0 then do  /* shared_secret=0 means "suppress encryption */
      req=req'&encrypt='encrypts
   end 
/* NOW GOT GET IT !!! */   

   stuff=get_a_url(opts.!server,req,auser,apwd,oldfile,,tempfile)

   if stuff='' then do 
      if notmod=1 then do               /* 304 return */
         stat.!nochange=stat.!nochange+1
         if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
         foo=write_message(logfile,quiet, ,
             cmm0||bold'No change'normal' (hash check) in 'tofile)
         iterate
      end 
      if notmod=2 then do               /* 304 return */
         stat.!nochange=stat.!nochange+1
         if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
         foo=write_message(logfile,quiet, ,
                              cmm0||bold'No change'normal' (rsync check) in 'tofile)
         iterate
      end 
      stat.!noget=stat.!noget+1
      foo=write_message(logfile,quiet,cmm0||reverse'ERROR'normal' could not GET 'afile)
      if retrying=0 then do
         ir=retrys.0+1
         retrys.ir=mm0
         retrys.0=ir 
      end
      iterate
   end /* do */

  if oldfile<>'' then do
     foo=do_backup(tofile,backfile)   /* backup file before overwriting? */
  end
  stat.!bytessent=stat.!bytessent+orisize
/* write response to the "tofile" */
   if response_tofile=0 then do
      call write_stuff_tofile 
      if len_stuff=0 then iterate
   end 
   else do
      tempfile=stuff
      call copy_tempfile_tofile 
      if len_stuff=0 then iterate
   end 

   addo=''
   if didgzip+didrsync+diddecrypt>0 then do
        addo=' < 'orisize' w/'
        if didgzip=1 then addo=addo||' GZ'
        if didrsync=1 then addo=addo||' RSY'  
        if diddecrypt=1 then addo=addo||' DeC'  
    end /* do */
    if oldfile='' then do
       stat.!created=stat.!created+1
       if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
       zz=cmm0||bold'Creating 'normal||tofile '('len_stuff' bytes'||addo
       foo=write_message(logfile,quiet,zz)
   end
   else do
      zz=cmm0||bold'Updating 'normal||tofile '('len_stuff' bytes'||addo
      foo=write_message(logfile,quiet,zz)
      stat.!updated=stat.!updated+1
      if retrying=1 then retrys.0.!ok=retrys.0.!ok+1
   end
   
end

foo=write_message(logfile,0,' ')
foo=write_message(logfile,0,bold'# files processed: 'normal||didprocess)
foo=write_message(logfile,0,bold' bytes transfered: 'normal||stat.!bytessent)

foo=write_message(logfile,0,bold'          created: 'normal||stat.!created)
foo=write_message(logfile,0,bold'          updated: 'normal||stat.!updated)
foo=write_message(logfile,0,bold'      not changed: 'normal||stat.!nochange)
foo=write_message(logfile,0,bold'          skipped: 'normal||stat.!skipped)
nerrs=stat.!nocreate+stat.!noget
foo=write_message(logfile,0,bold'           Errors: 'normal||nerrs)
if nerrs>0 then do
  foo=write_message(logfile,0,'               GET failed= 'stat.!noget)
  foo=write_message(logfile,0,'            write problem= 'stat.!nocreate)
end /* do */
foo=write_message(logfile,0,' ')
deletes=0
/* remove files? */
if dodelete=1 then do
   ff=destdir'\*.*'
   aa=sysfiletree(ff,'alls','FOS')
   do mm=1 to alls.0
      a1='!'||translate(strip(alls.mm))
      if didit.a1=0 then do
         deletes=deletes+1
         foo=sysfiledelete(alls.mm)
         if foo=0 then
           foo=write_message(logfile,quiet, ,
                bold' deleted 'normal||alls.mm )
         else
           foo=write_message(logfile,quiet, ,
                                 reverse' failed to delete 'normal||alls.mm )
      end
   end 
    foo=write_message(logfile,0, ,
         bold' Number of (orphan) files deleted: 'normal||deletes)
end
if retrys.0>0  & retrying=0 then do  /* retry (once) unGETable uris? */
   say ' '
   foo=write_message(logfile,0,' ')
   foo=write_message(logfile,0,bold' ReGET 'normal||retrys.0' unavailable files ')
   foo=write_message(logfile,0,' ')
   retrying=1 ;tocheck=retrys.0
   rng1=1  ; rng2=retrys.0
   stat.=0
   signal doretry
end

/* warn client of missing info */
if retrys.0> retrys.0.!ok  then do  
   foo=write_message(logfile,0,'')
   unavail=retrys.0-retrys.0.!Ok
   foo=write_message(logfile,0,cy_ye"Warning: "unavail" files were not successfully obtained"normal)
   foo=write_message(logfile,0,'You should re-access this UpDater package, request the "latest version",')
   foo=write_message(logfile,0,'and try again.')
   foo=write_message(logfile,0,'')
end

foo=write_message(logfile,0,cy_ye' Total elapsed time: 'normal||time('e')||' seconds')

if runfile<>'' then do
  call dorun
end

atend:
call askopts 'Q'
signal doretry


/*** jump here on error */
badguys:
say "UpClient error "Rc " at " sigl
call get_key
if logfile<>'' then call lineout logfile
exit

badguys2:
say 
say 
say "UpClient "bold"halted"normal" after processing entry #"mm0a
foo=sysfiledelete(listfile)
call get_key
if logfile<>'' then call lineout logfile
exit


/*************/
/* copy contents of tempfile to tofile-- use rexxlib move if possible
tofile should be deleted by do_backfile */

copy_tempfile_tofile:

len_stuff=0

if norexxlib=0 then do          /* use rexxlib procedures */
  if translate(filespec('d',tofile))=translate(filespec('d',tempfile)) then do
      fii=dosrename(tempfile,tofile)
      if fii=0 then DO 
          foo=write_message(logfile,quiet,fii'  Warning: Unable to rename to: 'tofile)
          RETURN 0            
      end 
   end
   else do                 /* can't move, try copying */
       fii=doscopy(tempfile,tofile,'R')
       if fii<>0 then DO 
          foo=write_message(logfile,quiet,'  Warning: Unable to copy to: 'tempfile' 'tofile)

          RETURN 0            
       end 
   END
   len_stuff=stream(tofile,'c','query size')
   return 1  
END

goo=stream(tempfile,'c','open read')
if abbrev(strip(translate(goo)),'READY')=0 then do
     foo=write_message(logfile,quiet,fii'  Warning: Unable to open: 'tempfile)
     RETURN 0            
end 
sz=charin(tempfile,'c','query size')
if sz=0 | sz='' then do
     foo=write_message(logfile,quiet,fii'   Warning: empty file: 'tempfile)
     RETURN 0            
end 

foo=stream(tofile,'c','open write')
if abbrev(translate(foo),'READY')=0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to open 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
end 

do mmw=1 to sz by 10000
   jjsize=min(10000,1+sz-mmw)
   gin=charin(tempfile,mmw,jjsize)
   foo=charout(tofile,gin)
   if foo<>0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to write to 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end
end 

foo=stream(tempfile,'c','close')
foo=stream(tofile,'c','close')
foo=sysfiledelete(tempfile)
len_stuff=sz
return 1


/*************/
/* write "stuff" string to tofile. tofile should be deleted by do_backfile */
write_stuff_tofile:
   len_stuff=0
   foo=stream(tofile,'c','open write')
   if abbrev(translate(foo),'READY')=0 then do
       foo=write_message(logfile,quiet,reverse'ERROR'normal' unable to open 'tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end 
   aa=charout(tofile,stuff,1)
   bb=stream(tofile,'c','close')
   if aa<>0 then do
       foo=write_message(logfile,quiet,cmm0||reverse'ERROR'normal' problem writing 'tofile)
       fii=sysfiledelete(tofile)
       stat.!nocreate=stat.!nocreate+1
       return 0
   end 
   len_stuff=length(stuff)
   return 1



/******/
/* run an "installation program */
dorun:
  if runfile='' then return 1
  say
   runfile=translate(strip(runfile),'\','/')
   say "Do you want to execute: "bold||runfile||normal
   aa=yesno('  enter Y to execute')
   if aa=0 then return 0
   if pos('\',runfile)>0 then 
     runfile2=destdir'\'||strip(runfile,,'\')
   else
     runfile2=runfile
   runargs=''
   if opts.!runargs<>'' then do
        runargs=unpack64(opts.!runargs)
   end 
   if opts.!runtype='PM' then 
       torun='@start "UpClient execution of: 'runfile'" /f  '||runfile2' 'runargs|| ' 2> nul '
   else
       torun='@start "UpClient execution of: 'runfile'" /f  /c '||runfile2' 'runargs|| ' 2> nul '
   signal on error name norun ; signal on syntax name norun
   rok=0
   torun
   jrc=rc
   if jrc<>0 then do 
     say
     say 'Problem ('jrc') executing 'runfile
   end
   else do
       say
       say 'Succesful execution of 'runfile
   end
   return 1
end /* do */

norun:
say
say reverse"ERROR"normal" ("rc") could not execute: "runfile
say torun
return 0


/***********/
/* write to screen and possibly log file */
write_message:procedure expose bold normal cy_ye reverse
parse arg lfile,quiet,amessage

if quiet<>1 then do   
 if length(amessage)<80 then
  say amessage
 else
   say left(amessage,75)||' ...'
end

if lfile=0 | lfile='' then return 0
am2=replacestrg(amessage,bold,' ','ALL')
am2=replacestrg(am2,cy_ye,' ','ALL')
am2=replacestrg(am2,normal,' ','ALL')
am2=replacestrg(am2,reverse,' ','ALL')
call lineout lfile,am2
return 1


/***********/
/* adler-32 crc of file aname */
fileadler:procedure expose candorsync bold normal mm0a reverse cy_ye listfile
parse arg aname

if candorsync<>1 then return ' '

foo=stream(aname,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then return ''

sz=stream(aname,'c','query size')
if sz='' | sz=0 then return ' '
aa=charin(aname,1,min(100000,sz))
adler=rx_adler32(aa)
igot=100000
do forever
       if igot>=sz then leave
      iget=min(100000,sz-igot)
      aa=charin(aname,,iget)
      adler=rx_adler32(aa,adler)
      igot=igot+100000
end
foo=stream(aname,'c','close')
return adler


/**********************/
/* backup old version of file before overwriting */
do_backup:procedure expose norexxlib reverse normal bold cy_ye mm0a listfile
parse arg tofile,backfile
 
 if backfile='' then do             /* then,delete it */
        fii=sysfiledelete(tofile)
        return 1
 end
/* can't use rexxlib */
 if norexxlib=1 then do         /* use 'COPY ' */
    address cmd '@COPY  'tofile' 'backfile ' > nul '
    if rc<>0 then do
       say 'Warning: Unable to copy to backup dir: 'tofile
    end 
    foo=sysfiledelete(tofile)
 end 

 else do                /* use rexxlib? */
 if translate(filespec('d',tofile))=translate(filespec('d',backfile)) then do
          fii=sysfiledelete(backfile)                   /* move old to backup */
          fii=dosrename(tofile,backfile)
          if fii<>1 then do
             say '  Warning: Unable to move to backup dir: 'tofile
             foo=sysfiledelete(tofile)
          end /* do */
 end
 else do                 /* can't move, try copying */
          fii=doscopy(tofile,backfile,'R')
          if fii<>0 then do
             say 'Warning: Unable to copy to backup dir: 'tofile
          end /* do */
          foo=sysfiledelete(tofile)
 end
 end

return 0

/***********/
/* read netscape supplied input file, and parse stuff from it's "header" */
read_stuff:

/* read the package list */
foo=strip(translate(stream(listfile,'c','open read')))
if abbrev(foo,'READY')=0 then do
   say reverse'UpClient ERROR:'normal' can not ('foo')open list of files to download: 'listfile
   call get_key
   exit
end 
isz=stream(listfile,'c','query size')
if (isz=0 | isz='') then do
   say 'UpClient ERROR: empty or missing 'listfile
   call get_key
   exit
end 
stuff=charin(listfile,1,isz)
foo=stream(listfile,'c','close')

/* client stuff: 
   USERPWD DESTDIR CHECK DODELETE BACKUPDIR ARANGE 
   user:pwd destdir timecheck dodelete backupdir arange
*/

parse var stuff hdrline (crlf) stuff
opts.=''
valids='PACKAGE SERVER GZIP RSYNC USERPWD DESTDIR CHECK DODELETE BACKUPDIR RANGE CURRENT_TIME CREATED QUIET RUN  ',
       'RUNTYPE RUNARGS SELECTOR ENCRYPT'
skiplist=''

do until hdrline=''
   parse var hdrline aword hdrline
   aword=strip(aword)
   parse var aword atype '=' avalue ; atype=strip(translate(atype))
   if wordpos(atype,valids)=0 then iterate
   atail='!'||atype
   opts.atail=strip(avalue)
end 

dodelete=opts.!DODELETE
destdir=opts.!DESTDIR
backupdir=opts.!BACKUPDIR
timecheck=opts.!CHECK
if timecheck=2 & candorsync=0 then do
   say 'UpClient Warning: adler-32 can not be computed (it requires rxRsync)'
   call get_key
end /* do */
quiet=opts.!quiet

runfile=strip(opts.!run)
runtype=strip(opts.!runtype)

encrypts=''
if opts.!encrypt<>'' then do                 /* see which ones are supported */
   aencrypts=translate(translate(opts.!encrypt,' ',','))
   jj=0
   do mm=1 to words(aencrypts)
        aword=strip(word(aencrypts,mm))
        if symbol('ENCRYPT.!'||aword)='VAR' then do
           encrypts=encrypts','aword
        end /* do */
    end        
    encrypts=strip(encrypts,,',')
end

age=0
if datatype(opts.!current_time)='NUM' & datatype(opts.!created)='NUM' then do
  numeric digits 10
  age=opts.!current_time-opts.!created
  if age='0' then do
    days=0; hrs=0
  end
  else do
       parse var age days '.' mins ; mins='.'mins
       hrs=1440*mins/60
  end
end 

arange=opts.!RANGE
username=opts.!USERPWD
parse var username auser ':' apwd

/* check for required fields */
if opts.!SERVER='' then do
       say 'UpClient ERROR: no central server info in package list 'listfile
       call get_key
       exit
end 
if opts.!selector='' then opts.!selector='UPDATER'

if opts.!PACKAGE='' then do
  say  'UpClient ERROR: no package name in package list 'listfile
   call get_key
  exit
end 

if opts.!DESTDIR='' then do
  say  'UpClient ERROR: no destination directory in package list 'listfile
   call get_key
  exit
end 

/* check status of destdir */
if ais_dir(destdir)=0 then do
   foo=sysmkdir2(destdir)
   if foo<>0 then do
       say 'UpClient ERROR: unable to create destdir: 'destdir
      call get_key
       exit
   end 
end 

/* check status of backupdir */
if backupdir<>0 & backupdir<>'' then do
  if ais_dir(backupdir)=0 then do
   foo=sysmkdir2(backupdir)
   if foo<>0 then do
       say 'UpClient ERROR: unable to create backupdir: 'backupdir
       call get_key
       exit
   end 
 end 
end
else do
   backupdir=''
end 

say "About to update files in..."
say '   Package: 'bold||opts.!package||normal
if  age>0 then do
   say '   (last updated: 'days 'days and ' hrs 'hours ago)'   
end
else do
   say '   (just updated)'   
end

say '   which is on the server at: 'bold|| opts.!server||normal
say 'These will be written to your computer, using...'
say '   Destination Directory: '||bold||destdir||normal

stuff2=stuff
dirks.=0
ict=0 ;idirs=0
do until stuff2=''
    parse var stuff2 aline '0d0a'x stuff2
    parse var aline . . dafile . ;dafile=strip(dafile)
    jj=lastpos('/',dafile)
    goodir='!'left(dafile,jj)
    ict=ict+1
    if dirks.goodir=1 then iterate
    idirs=idirs+1 
    dirks.goodir=1
end /* do */
say '   # of files: 'ict '(in 'idirs' directories)'

if backupdir<>'' then say '    Backup Directory: '||bold||backupdir||normal

return 0

/****************************/
askopts:
parse arg aopt
aopt=strip(aopt)

do forever 

say
goo=yesno('Please select an action','View Save Update Modify Quit',aopt)
say

select
 when goo=0 then do
   if viewer<>'' then do
      address cmd '@'viewer' 'listfile
   end 
   else do
      address cmd '@TYPE 'listfile' | more'
   end /* do */
 end
 when goo=1 then do
     call saveout  listfile
 end

 when goo=2 then return  /* start the update */

 when goo=3 then do                     /*  get more options */
  call domoreopts
 end

 when goo=4 then do
    foo=sysfiledelete(listfile)
    if logfile<>'' then call lineout logfile
    exit    /* all done */
 end
 otherwise nop

end                     /* select */

end             /* get options loop, exit via return on "Q" answer */

/*************************/
/* get more options */
domoreopts:

do forever
joo=yesno(normal'  'reverse'What to change','Exclude Range Criteria Username Logfile Back ?','B')
select
   when joo=0 then do
      say " "
      skiplist=get_string('    Enter a list of files to skip (? for more help)',,'SKIPHELP')
      say " "
    end


    when joo=1 then do
    say '    Select a range (from the "list of files") of files to UpDate '

    do forever   
      rng1=get_string('  Start at ',rng1,'RNGHELP')
      rng1=strip(rng1)
      if datatype(rng1)<>'NUM' & rng1<>'' then do
         say "Error. Please enter an integer between 1  > 0, or leave blank "
         iterate
      end 

      rng2=get_string('  End at ',rng2,'RNGHELP')
      rng2=strip(rng2)
      if datatype(rng2)<>'NUM' & rng2<>'' then do
         say 'Error. Please enter an integer between 'rng1' and 'entries.0', or leave blank '
         iterate
      end 
      leave
    end
    if rng2>entries.0 then   rng2=entries.0

    end


    when joo=2 then do
    do forever                  /* Update criteria */
       say
       dopt='A'
       if datatype(timecheck)='NUM' then   dopt=substr('ATCM',timecheck+1,1)
       hoo=yesno(normal'    'reverse'Update criteria: ','Timestamp CRC-32 MD4-128 Always ?',dopt)
       if hoo=4 then do
          call criteriahelp
          iterate
       end
       hoo=hoo+1
       if hoo=4 then hoo=0
       timecheck=hoo
       leave
    end
    say " "
    end

    when joo=3 then do
        say
        aa=ask_username()
        say
    end

    when joo=4 then do
        say
        logfile=set_logfile(logfile,0)
        say
    end

   when joo=5 then return 0

    otherwise do
       say "Select an  option: "
       say "  "bold"E"normal": Choose files to Exclude (using name patterns)"
       say "  "bold"R"normal": Choose range (from list) of files to update"
       say "  "bold"C"normal": Choose update criteria "
       say "  "bold"U"normal': Specify username, password, and a decryption key'
       say "  "bold"L"normal": Change the log file"
       say "  "bold"B"normal": Go Back to main menu. "
    end
end
end
return 0

criteriahelp:
  say "You can choose when to update a given file. "
  say "The criteria are (from least to most stringent): "
  say "  "bold"T"normal" : Check timestamp first, update if your file is older "
  say "  "bold"C"normal" : Compare 32bit (CRC) hash, update if different "
  say "  "bold"M"normal" : Compare 128 bit (MD4) hash, update if different "
  say "  "bold"A"normal" : Always -- always update file (possibly using RSYNC and GZIP)"
  return

rnghelp:
   say "You can select the range of files, in the file list, to update"
   say "Currently, you've selected " rng1 " to " rng2 
   say "To copy all " entries.0 "files, leave both start and end fields empty"
   say
   return

skiphelp:
   say "You can "bold"skip"normal" (not update) files you select."
   say "To accomplish this, enter a list of filenames."
   say "  "bold"* "normal"use fully-qualified filenames (the name they will have on your computer)"
   say "  "bold"* "normal"seperate each filename with a space "
   say "  "bold"* "normal"you can use * wildcards anywhere (careful, the * wildcard"
   say "    will also match subdirectory names)"
   say "To "bold"not"normal" skip any files, leave this field empty"
   say
   return

/***********/
/* copy filelist to user selected file */
saveout: nop
parse arg oldfile

say " "
outget:
tout=temp_dir'\UPDATER.LST'
say 'You can save the "list of files to UpDate" to a file.'
say bold"Enter name of output file (.=quit,ENTER="tout")"normal
call charout,"  "reverse " :" normal
parse pull outfile
if outfile='.' then return 0

if outfile='' then outfile=tout

foo=stream(outfile,'c','query exists')
if foo<>'' then do
    call charout,'    'foo 'exists. '
    arf=yesno(normal"     "bold"Overwrite",,'Y')
    if arf=0 then do
            outfile='' ; signal outget
     end                /* else, command line mode implies overrwrite */
     foo=sysfiledelete(outfile)
     foo=stream(outfile,'c','query exists')
     if foo<>'' then do
            say "      Could not delete "outfile
            outfile=''
            signal outget
     end 
end 
foo=strip(translate(stream(oldfile,'c','open read')))
if abbrev(foo,'READY')=0 then do
    say reverse"ERROR."normal" Unable to open response. "
    return 0
end 
sz=stream(oldfile,'c','query size')
if sz=0 | sz='' then do
    say reverse"ERROR."normal" Unable to open response. "
    return 0
end 
aaa=charin(oldfile,1,sz)
foo=stream(oldfile,'c','close')

foo=strip(translate(stream(outfile,'c','open write')))
if abbrev(foo,'READY')=0 then do
    say reverse"ERROR."normal" Unable to create "outfile
    return 0
end 
aa=charout(outfile,aaa,1)
fo=stream(outfile,'c','close')
if aa<>0 then do
   say reverse'ERROR."normal" Unable to write response to 'outfile
   return 0
end /* do */
say "   "bold"Response written to:"normal||outfile


return 1


/***********/
/* copy filelist to user selected file */
set_logfile:procedure expose bold normal cy_ye reverse destdir
parse arg logfile,firstdo
if logfile='' then logfile=0
say " "
loutget:

say 'You can write results to a log-file, or enter 'bold"0"normal" to not log results."
afile=get_string("Enter name of log file [0=no logfile] ",logfile)
if afile=logfile & firstdo<>1 then return logfile /* no change */
if afile=0  then return ''

afile=strip(afile)
if left(afile,1)<>'\' & pos(':',afile)=0 then do
   afile=destdir||'\'afile
end 

foo=stream(afile,'c','close')

foo=stream(afile,'c','query exists')
if foo<>'' then do
    call charout,'    'foo 'exists. '
    arf=yesno(normal"     "bold"Overwrite",,'Y')
    if arf=0 then  signal loutget
     foo=sysfiledelete(afile)
     foo=stream(afile,'c','query exists')
     if foo<>'' then do
            say "      Could not delete "afile
            signal loutget
     end 
end 
foo=stream(afile,'c','open write')
if abbrev(translate(strip(foo)),'READY')<>1 then do
    say "      Could not open logfile "afile
   signal loutget
end

afile=stream(afile,'c','query exists')
say "Log file: "bold||afile||normal
return afile



/********************/
/* check for unzip and rsync dlls */
check_dlls:

/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( "SockLoadFuncs","rxSock","SockLoadFuncs")
  if foo=0 then call SockLoadFuncs
end
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
   say "ERROR: UpDater requires the rxSock dynamic link library"
   call get_key
   exit
end

/* Load up advanced REXX functions */
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
  if foo=0 then call SysLoadFuncs
end
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
   say "ERROR: UpDater requires the rexxutil dynamic link library"
   call get_key
   exit
end

parse version  atype .
if atype<>"REXXSAA" then do
 say    " WARNING: UpDater ver 1.10 is designed to work under OS/2 Classic Rexx "
 say     "        If you are using some other REXX (such as object rexx) "
 say     "        you might have problems."
end  /* Do */


norexxlib=0
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
 call rxfuncadd 'rexxlibregister','rexxlib', 'rexxlibregister'
 call rexxlibregister
end
foo=rxfuncquery('rexxlibregister')
if foo=1 then do
   say "Note: could not find REXXLIB, some functions will be slower"
   say "(hit ENTER to continue)"
   pull ff
    norexxlib=1
end /* do */

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
cyanon=cy_ye
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

if rxfuncquery('rx_md4')=1  then do
   foo=RXFuncAdd( 'RXRsyncLoad', 'RXRSYNC', 'RxRsyncLoad')
   if foo=0 then  call RxRsyncLoad
end
if rxfuncquery('rx_md4')=1  then do
     say "Note: rxrsync.dll is unavailable -- rsync differencing will not be supported "
     candorsync=0
end
else do
   candoadler=1
end /* do */


/* see if GZIP is available */
if rxfuncquery('rxgzLoadFuncs')=1  then do
  foo=RXFuncAdd( 'rxgzLoadFuncs', 'rxgzLIB', 'rxgzLoadFuncs')
  if foo=0 then call rxgzLoadFuncs
end
if rxfuncquery('rxgzLoadFuncs')=1  then do
   candogzip=0
   call pmprintf("UpDater warning: unable to find rxgzlib")
end

shared_secret=''

return 0

/* ------------- */
sysmkdir2:procedure expose norexxlib reverse normal bold cy_ye mm0a listfile
parse arg adir

adir=strip(adir,'t','\')
ff=sysmkdir(adir)
if ff=0 then return ff

/* make the tree */
f2=adir'\'
dd=filespec('d',f2)
pp=filespec('p',f2)
if pp='\' | pp='' then return -1

pp2=strip(translate(pp,' ','\'))

do mm=1 to words(pp2)
   a1=subword(pp2,1,mm)
   a1=translate(a1,'\',' ')
   dd2=dd'\'a1
   hoo=sysmkdir(dd2)
end /* do */

return hoo


/***********************************/
/* ask for username & password */
ask_username:procedure expose opts. normal cy_ye bold reverse listfile opts. , 
             auser apwd shared_secret candoadler servername timeout logfile  

do forever

say "   Enter a username, password, and a decryption-key"
say '   (for the server at 'opts.!server ') '

auser=get_string('     Enter  a UserName ',auser)
auser=space(auser,0)

apwd=get_string("     Enter  a PassWord ",apwd)
apwd=space(apwd,0)

shared_secret=ask_shared(1)
if shared_secret=-1 then iterate
shared_secret=space(translate(shared_secret),0)
return 0

end



/***********************************/
/* ask user to supply a shared secret password */
ask_shared:procedure expose normal reverse bold cy_ye listfile opts.  ,
            auser apwd candoadler timeout servername logfile opts. shared_secret
parse arg allowagain

do forever
shar=get_string("  Enter  a shared-secret key ",shared_secret,"Shared_secret_help")
shar=space(shar,0)

if candoadler=1 then do         /* requires rxmd4 */

if allowagain<>1 then do
   anans=yesno(normal'     'reverse'Verify this key ',,'N')
end
else do
   anans=yesno(normal'     'reverse'Verify this key (UP-Arrow to reenter username)',,'N',1)
   if anans=-1 then return -1
end
if anans=1 then do
    nonce=space(translate(date('n')||time('n')||servername),0)
    tocheck=nonce||translate(shar)
    amd4=rx_md4(tocheck)
    req='/'opts.!selector'?VERIFY='||nonce';'amd4
    stuff=get_a_url(opts.!server,req,auser,apwd,,1)
    stuff=translate(strip(stuff))
    if abbrev(STUFF,'VERIFY=1')=0 then do
       Say ' NO such decryption key for user 'auser' at 'opts.!server
    end
    else do
        say "    Decryption key is okay!"
    end /* do */
end
end

return shar
end


shared_secret_help:
  say
  say   "As a security measure, files in this package can be encrypted before being"
  say   "transmitted over the net.  To de-crypt these files, you must provide"
  say   "a "bold"shared-secret decryption key."normal
  say
  say  bold"Notes:"normal
  say   bold" * "normal"This "bold"key"normal" will be assigned to your "reverse||auser||normal" account"
  say       "    on the server at "opts.!server
  say   bold" * "normal"It is case-insensitive, and should not have embedded spaces. "
  say   bold" * "normal"If you do NOT want to encrypt, enter a "bold"0"normal"."
  say
 return



/************/
/* create a base64 packing of a message */
mk_base64:procedure expose bold normal mm0a  reverse cy_ye listfile

do mm=0 to 25           /* set base 64 encoding keys */
   a.mm=d2c(65+mm)
end /* do */
do mm=26 to 51
   a.mm=d2c(97+mm-26)
end /* do */
do mm=52 to 61
   a.mm=d2c(48+mm-52)
end /* do */
a.62='+'
a.63='/'

parse arg mess
s2=x2b(c2x(mess))
ith=0
do forever
   ith=ith+1
   a1=substr(s2,1,6,0)
   ms.ith=x2d(b2x(a1))
   if length(s2)<7 then leave
   s2=substr(s2,7)
end /* do */
pint=""
do kk=1 to ith
    oi=ms.kk ; pint=pint||a.oi
end /* do */
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint


/*************/
/* get ip address of this machine */
get_hostname:procedure
dot_addr = SockGetHostId()
rc = SockGetHostByAddr(dot_addr, "host.")
return host.name


/*******************************************/
rsync_synopsis:procedure  expose  norexxlib reverse normal bold cy_ye mm0a listfile

parse arg afile,nblocks

if nblocks='' then nblocks=45
if datatype(nblocks)<>'NUM' then nblocks=45
if nblocks<10 | nblocks>255 then nblocks=45   /* 255 limit on # of blocks */

if afile='' then return "ERROR no old-version file specified"

/* read "Afile" */
aa=translate(stream(afile,'c','open read'))
if  abbrev(aa,'READY')=0 then return "ERROR could not open oldverfile "afile
isize=stream(afile,'c','query size')
if isize='' | isize=0 then do
    return reverse'ERROR'normal' 'afile " is unaccessible"
    return ''
end
astuff=charin(afile,1,isize)
aa=stream(afile,'c','close')


blocksize=trunc(0.9999 + (isize/nblocks))
if blocksize<200 then do
    blocksize=200
    nblocks=trunc((isize/blocksize)+0.999)
end /* do */
ac1=d2c(blocksize)
ac1=right(ac1,4,x2c('00'))
ac1=ac1||d2c(nblocks)
iat=1
do mm=1 to nblocks
  if mm=nblocks then
     ablock=substr(astuff,iat)
  else
     ablock=substr(astuff,iat,blocksize)
  acd0=rx_rsync32_md4(ablock)
  ac0=left(x2c(acd0),8)

  ac1=ac1||ac0
  iat=iat+blocksize
end
ac1=mkpack64(ac1)

return ac1

/**********************/
mkPACK64:procedure expose bold normal mm0a  reverse cy_ye listfile
parse arg mess

biga=xrange('A','Z')||xrange('a','z')||xrange('0','9')||'+/'

s2=x2b(c2x(mess))

nith=trunc((length(s2)/6)+.9)
cont=copies(' ',nith)
oof=""
do mm=0 to 63
      oof=oof||x2c(b2x(right('00'||x2b(d2x(mm)),6)))
end /* do */
do ith=1 to nith 
  a1=substr(s2,(ith*6)-5,6,0)
  cont=overlay(x2c(b2x(a1)),cont,ith) 
end /* do */
pint=""
pint=translate(cont,biga,oof)
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint

/************/
/* unpack64   :  astring=unpack64(mkpack64(astring)) */

unpack64:procedure
char_set='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
do mm=0 to length(char_set)-1
   a.mm=substr(char_set,mm+1,1)
end /* do */

parse arg mess
newmess=""
do mm=1 to length(mess)
   a1=substr(mess,mm,1)
   a1a=c2d(a1)
   select
     when a1a>64 & a1a<91  then a1b=a1a-65  /* ascii 65 to 90 */
     when a1a>96 & a1a<123 then a1b=26+(a1a-97)  /* ascii 97 to 122 */
     when a1a>47 & a1a<58  then a1b=a1a+4   /* ascii 48 to 57 */
     when a1='+' then a1b=62
     when a1='/' then a1b=63
     when a1='=' then iterate
     otherwise return ""        /* error */
   end
   pp=x2b(d2x(a1b))
   if length(pp)>6 then
        pp=substr(pp,3)
   else
        pp=right(pp,6,0)
   newmess=newmess||pp
end
ilen=trunc(length(newmess)/8)*8 ; newmess=left(newmess,ilen)
newm=x2c(b2x(newmess))
return newm



/***************************************************/
/*  rsync_ungdiff: undifference, using a gdiff difference file
                   (that may have have been produced by rsync_gdiff

     status=rsync_ungdiff(oldver_file,diff_file,newfile,GDMD4,verbo)
        OLDVER_FILE -- old version of the file
        diff_file  -- the gdiff file (in a string)
        gdmd4 -- md4 of "server side" new file -- use as an error check
                 if not specified, then error check will not be done


**************************************/

rsync_ungdiff:procedure expose   norexxlib reverse normal bold cy_ye mm0a listfile
  parse arg afile,s1,smd4


crlf='0d0a'x

/* read "Afile" */
aa=translate(stream(afile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open difffile'afile
  return ''
end
iasize=stream(afile,'c','query size')
if iasize='' | iasize=0 then do
    say 'ERROR unable to apply rsync to 'afile
    return ''
end
astuff=charin(afile,1,iasize)
aa=stream(afile,'c','close')

/* start building, according to the gdiff format */

/* check for gdiff header (char value of 'd1ffd1ff'x, and version # i.e; '04'x)*/
parse var s1 gheader +4 foover +1  s1
ggh=x2c('d1ffd1ff')
if gheader<>ggh then do
    say reverse'ERROR'normal' in difference file: not a gdiff file: 'c2x(gheader)
    return ''
end

/* ignore version number */
bstuff=''
noted=0
do forever
   if length(s1)=0 | s1='' then do
       say reverse'ERROR'normal' in RSYNC '
       return ''
   end
   
   parse var s1 atype +1 s1
   itype=c2d(atype)
   select
      when itype=0 then leave   /* 0 signals eof */
      when itype=255 then return 'ERROR gdiff copy operation too large'
      when  itype>0 & itype < 247 then do  /* get itype bytes */
         parse var s1 ccs +(itype) s1
         bstuff=bstuff||ccs
      end /* do */
      when itype=247 then do    /* get <65k bytes */
          parse var s1 jget +2 s1
          jget=c2d(jget)

          parse var s1 ccs +(jget) s1
          bstuff=bstuff||ccs
      end /* do */
      when itype=248 then do    /* get < 2billion bytes */
          parse var s1 jget +4 s1
          jget=c2d(jget)

          parse var s1 ccs +(jget) s1
          bstuff=bstuff||ccs
      end /* do */
      otherwise do   /* copy range of bytes */
         select
           when itype=249 then parse var s1 istart +2 iget +1 s1  
           when itype=250 then parse var s1 istart +2 iget +2 s1
           when itype=251 then parse var s1 istart +2 iget +4 s1
           when itype=252 then parse var s1 istart +4 iget +1 s1
           when itype=253 then parse var s1 istart +4 iget +2 s1
           when itype=254 then parse var s1 istart +4 iget +4 s1
           otherwise return 'ERROR: impossible code in gdiff '
         end
         istart=c2d(istart); iget=c2d(iget)

         bstuff=bstuff||substr(astuff,istart,iget)
      end               /* otherwise range */
   end                  /* gdiff codes */
end                     /* parsing gdiff file */

/* compute md4 of this constructed file */
if smd4<>'' then do 
  b2md4=rx_md4(bstuff)
  if strip(translate(b2md4)) <> strip(translate(smd4)) then do
     say reverse'ERROR'normal' md4 does not match: 'b2md4', 'smd4
     return ''
  end /* do */

end

return bstuff

/***************************************/
/***** call this if "all file" ungdiff */

rsync_ungdiff_file:procedure expose   norexxlib reverse normal bold cy_ye mm0a listfile ,
                logfile  temp_dir

parse arg oldfile,difffile,smd4,tempfile

crlf='0d0a'x

/* open for read "oldfile" */
aa=translate(stream(oldfile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open ungdifffile 'oldfile
  return ''
end
oldsize=stream(oldfile,'c','query size')
if oldsize='' | oldsize=0 then do
    say 'ERROR empty oldfile: 'oldfile
    return ''
end

/* open for read "difffile" */
aa=translate(stream(difffile,'c','open read'))
if  abbrev(aa,'READY')=0 then do
  say 'ERROR could not open difffile 'difffile
   foo=stream(oldfile,'c','close')
pull goo
  return ''
end
diffsize=stream(difffile,'c','query size')
if diffsize='' | diffsize=0 then do
    say 'ERROR empty diff file: 'difffile
    foo=stream(oldfile,'c','close')
    return ''
end
difffile_left=diffsize ; diffbuffer=''

/* check for gdiff header (char value of 'd1ffd1ff'x, and version # i.e; '04'x)*/
aa=rsync_pull_diff(5,1)
if aa='' then return ''

parse var aa gheader +4 .
ggh=x2c('d1ffd1ff')                     /* ignore version number */
if gheader<>ggh then do
    call rsync_error reverse'ERROR'normal' in difference file: not a gdiff file: 'c2x(gheader)' 'gheader','difffile
    return ''
end

/* start building, according to the gdiff format */
do forever

   atype=rsync_pull_diff(1)
   IF atype='' then return ''
   itype=c2d(atype)

/* process, according to the gdiff code */
   select

      when itype=0 then leave   /* 0 signals eof */
      when itype=255 then do
        call rsync_error  'ERROR gdiff copy operation too large'
        return ''
      end
      when itype < 247 then do  /* get itype (<247) bytes */
         ccs=rsync_pull_diff(itype)
         if ccs='' then return ''
         foo=charout(tempfile,ccs)
         if foo<>0  then do
            call rsync_error 'ERROR writing (a) to 'tempfile
            return ''
         end 
      end /* do */
      when itype=247 then do    /* get <65k bytes from  */
          jget=rsync_pull_diff(2)
          if jget='' then return ''
          jget=c2d(jget)
          ccs=rsync_pull_diff(jget)
          if ccs='' then return ''
          foo=charout(tempfile,ccs)
          if foo<>0  then do
             call rsync_error 'ERROR writing (b) to 'tempfile
             return ''
          end 
      end /* do */
      when itype=248 then do    /* get < 2billion bytes */
          jget=rsync_pull_diff(4)
          if jget='' then return ''
          jget=c2d(jget)
          do mm=1 to jget by 10000
             jget2=min(10000,1+jget-mm)
             ccs=rsync_pull_diff(jget2)
             if ccs='' then return ''
             foo=charout(tempfile,ccs)
             if foo<>0  then do
                call rsync_error 'ERROR writing (c) to 'tempfile
                return ''
             end 
          end           /* to jget by 10000 */
      end /* do */
      otherwise do   /* copy range of bytes from old file */
         
         select
           when itype=249 then do
              s1=rsync_pull_diff(3)
              if s1='' then return ''
              parse var s1 istart +2 iget +1 
           end
           when itype=250 then do
              s1=rsync_pull_diff(4)
              if s1='' then return ''
              parse var s1 istart +2 iget +2 
           end
           when itype=251 then do
              s1=rsync_pull_diff(6)
              if s1='' then return ''
               parse var s1 istart +2 iget +4
           end
           when itype=252 then do
              s1=rsync_pull_diff(5)
              if s1='' then return ''
              parse var s1 istart +4 iget +1 
           end
           when itype=253 then do  
               s1=rsync_pull_diff(6)
              if s1='' then return ''
               parse var s1 istart +4 iget +2
           end
           when itype=254 then do
              s1=rsync_pull_diff(8)
              if s1='' then return ''
              parse var s1 istart +4 iget +4 
           end
           otherwise return 'ERROR: impossible code in gdiff '
         end                    /* 249 to 254 codes */

         istart=c2d(istart); iget=c2d(iget)
         iend3=istart+iget-1
         if iend3>oldsize  then do
             call rsync_error 'ERROR read past end of reference-diff file 'oldfile
             return ' '
         end /* do */
         do mm=istart to iend3 by 10000
             nget=min(10000,1+iend3-mm)
             ccs=charin(oldfile,mm,nget)
             foo=charout(tempfile,ccs)
             if foo<>0  then do
                call rsync_error 'ERROR writing (d) to 'tempfile
                return ''
             end 
         end           /* to jget by 10000 */

      end               /* otherwise get from oldfile */
   end                  /* gdiff codes */

end                     /* parsing gdiff file */

foo=stream(difffile,'c','close')
foo=stream(oldfile,'c','close')
foo=stream(tempfile,'c','close')

/* compute md4 of this constructed file */
if smd4<>'' then do 
  b2md4=rx_md4(tempfile,1)
  if strip(translate(b2md4)) <> strip(translate(smd4)) then do
     say reverse'ERROR'normal' md4 does not match: 'b2md4', 'smd4
     return ''
  end 
end

return tempfile


/*** rsync error handler ******/
rsync_error:
parse arg amess
if amess<>'' then say amess
foo=stream(difffile,'c','close')
foo=stream(oldfile,'c','close')
return ''


/************/
/* pull stuff from difffile, or from difffile's buffer */
rsync_pull_diff:procedure expose diffbuffer difffile difffile_left normal reverse bold logfile 
parse arg nget,i1


do forever              /* may need to dig stuff out of file a few times */

lendiff=length(diffbuffer)
if lendiff>=nget then do
   parse var diffbuffer ccs +(nget) diffbuffer
   if lendiff=nget then diffbuffer=''
   return ccs                           /* success, return nget bytes */
end

/* else, add to diffbuffer */
if difffile_left<1 then do               /* error, buffer can't be filled*/
   call rsync_error nget' ERROR premature end of diff file 'difffile 
   return ''
end 

if i1=1 then
 t1=charin(difffile,i1,min(difffile_left,10000))
else
 t1=charin(difffile,,min(difffile_left,10000))


difffile_left=difffile_left-length(t1)

diffbuffer=diffbuffer||t1

end             /* compare against nget again */




/* ---------------------------------- */
/* return 1 if adir is an existing (possibly empty) directory , 0 if not */
ais_dir:procedure expose norexxlib reverse normal bold cy_ye   mm0a listfile
parse arg adir

if norexxlib=0 then do  /* use rexxlib, if available */
   ii=dosisdir(adir)
   return ii
end /* do */

adir=strip(adir)
adir=strip(adir,'t','\')
nowdir=directory()
nowdrive=filespec('d',nowdir'\')
nowpath=filespec('p',nowdir'\')
adr=filespec('d',adir)
if adr='' then do
   if abbrev(adir,'\')=0 then 
       adir=nowdrive||nowpath||adir
   else
       adir=nowdrive||adir
end /* do */

foo=sysfiletree(adir,goo,'D')
if  goo.0>0  then return 1
return 0




 /* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1

   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd

   "@ANSI 2>NUL | rxqueue 2>NUL"

   thisRC = 0

   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */

 InitAnsiEnd:
 signal off error
 RETURN thisRC


/*****/
get_key:procedure
call charout, "...hit ENTER to exit UpClient."
parse pull xx
return 0



/************************/
/* wild card match */

wild_match:procedure expose suppress_noslash listfile mm0a bold reverse normal cy_ye
parse upper arg needle, haystack ; haystack=strip(haystack)
needle=strip(needle)

noslash=0               /* | at end of haystack means "no / or \ in last wildcarded portion of needle */
if right(haystack,1)='|' & suppress_noslash<>1 then do
   noslash=1
   haystack=left(haystack,length(haystack)-1)
end

hayendast=0
if right(haystack,1)='*' then hayendast=1


if needle=haystack then return -1        /* -1 signals exact match */
ast1=pos('*',haystack)
if ast1=0 then return 0                 /* 0 means no match */
if haystack='*' then  do                /* global is sort of stupid -- choose "shortest" string */
   if noslash=1 then do                 /* check for noslash condition */
     noo=translate(needle,'/','\')
     if pos('/',noo)>0 then return 0
   end
   if length(needle)=0 then 
       return 100000
    else 
        return length(needle)
end
ff=haystack
ii=0
do until ff=""
  ii=ii+1
  parse var ff hw.ii '*'  ff
  hw.ii=strip(hw.ii)
end
if hw.ii='' then ii=ii-1
hw.0=ii


/* check each component of haystackw against needle -- all components
must be there */

resu=' '
istart=1 ; ido=2
if ast1>1 then do       /* first check abbrev */
  if abbrev(needle,hw.1)=0 then return 0   /* first portion of haystack also first portion of needle */
  aresu=length(hw.1)
  if hw.0=1 then do
     if noslash=1 then do                 /* check for noslash condition */
        noo=translate(substr(needle,aresu+1),'/','\')
        if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
     end
     do nm=1 to aresu
        resu=resu||' '||nm
     end /* do */
     return resu         /* if haystacy of form abc*, we have a match */
  end
  ido=2 ; istart=aresu+1
  do mm=1 to aresu
        resu=resu||' '||mm
  end /* do */
end
/* if here, then first part (a non wildcard) of haystack matches first
part of needle
Now check sequentially that each remaining part also exists
*/
do mm=ido to hw.0
  igoo=pos(hw.mm,needle,istart)
  if igoo=0 then return 0
  if noslash=1 & mm=hw.0 & hayendast=0 then do     /* this is a non *'ed haystack end */
     noo=translate(substr(needle,istart,igoo-istart),'/','\')
     if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
  end
  tres=length(hw.mm)
  istart=igoo+tres
  do nn=igoo to (istart-1)
     nn0=nn
     resu=resu||' '||nn       /* resu indices characters that really match */
  end /* do */
end

if noslash=1 & hayendast=1 then do
   noo=translate(substr(needle,nn0+1),'/','\')
   if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
end
   
if (istart >= length(needle)) | (hayendast=1) then  return resu

return 0
 


/* ----------------------------------------------------------------------- */
/* REPLACESTRG:
 newstring=replacestrg(haystack,needle,replacement,type,exact)
  Arguments:
                astring : the "haystack" to look in
                target: the "needle" to look for
                putme: the "new needle" to replace the "needle" with
                type : The direction/type of search
                        FORWARD, BACKWARD, ALL
                exact: YES-- then cases in needle and haystack must match

      Note taht regardless of value of exact, cases are retained in both
      astring and putme.

   Returns the modified astring, or the unmodified astring if target could
   not be found.
*/
/* ----------------------------------------------------------------------- */

replacestrg:procedure expose listfile mm0a bold reverse normal cy_ye

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring



/* -------------------- */
/* choose between 3 alternatives (by default,a yes or no ),
return 1 if yes (or 0,1,2 for chosen altenative ) */

yesno:procedure expose normal reverse bold cy_ye     mm0a listfile logfile  
parse arg amessage , altans,def,arrowok
ony2:
aynn=' '
if def='' then
 defans=''
else
 defans=translate(left(strip(def),1))
if altans='' then altans='No Yes'

w.0=words(altans)
goo=aynn
do iw0=1 to w.0
     w.iw0=strip(word(altans,iw0))
     a.iw0=translate(left(w.iw0,1))
     aa.iw0=substr(w.iw0,2)
     aynn=aynn||bold
     if  a.iw0=defans then aynn=aynn||cy_ye
     aynn=aynn||a.iw0||normal||aa.iw0
     goo=goo||a.iw0||aa.iw0
     if iw0<w.0 then do
       aynn=aynn'  '
       goo=goo||'  '
     end
end
if arrowok=1 then aynn=aynn||' [UP]'

do forever
 foo1=normal||reverse||amessage||'? '||normal||aynn||': 'normal
 goo=amessage'?'||goo':'

 if length(goo)<73 then do
    call charout,foo1
 end
 else do
    foo1=normal||reverse||amessage||'? '||normal
    say foo1
    call charout,'     : 'aynn||': 'normal
 end

 anans=translate(sysgetkey('echo'))
 ianans=c2d(anans)

 if ianans=0 | ianans=x2d('e0') then do
    anans=sysgetkey('noecho')
    if pos('?',altans)>0 then do
       if anans='3b'x then anans='?'
    end
    else do
       ianans=1000+c2d(anans)
    end /* do */
 end 

if anans='' | ianans=13 | ianans=10 then  anans=defans

if arrowok=1 & ianans>=1000  then do
     if ianans=1072 then  do
           say ;say
           return '-1'  /* -1 : up key */
     end
 end 


 do ijj=1 to w.0
    if abbrev(anans,a.ijj)=1 then do
        say
        return Ijj-1
    end
 end /* do */
 call charout,'0d'x
end



/*****/
/* get a string, with a default */
get_string:procedure expose normal bold reverse cy_ye logfile  
parse arg prompt,default,helpproc

do forever
aa=bold||prompt||normal
if helpproc<>'' then  aa=aa||' [? for help] '

if default<>'' then do
   bb='('reverse'ENTER'normal'='default'):'
   if length(aa||bb)>80 then do
      say aa
      say '   'bb
      call charout,"    "reverse " :" normal' '
   end 
   else do
      say aa||bb
      call charout,"    "reverse " :" normal' '
   end 
   parse pull ans
   if ans='' then ans=default
end
else do
  call charout,aa
  if length(aa)>60 then do
      say
      call charout, '    'reverse':'normal' '
  end
  else do
      call charout, ' 'reverse':'normal' '
  end
  parse pull ans
end 
if ans='?' & helpproc<>'' then do
   interpret 'CALL 'helpproc
   iterate
end /* do */
return ans
end


/**********************************************************/
/***********/
/* get a url, using socket calls */
get_a_url:procedure expose servername  rsyncok verbose notmod retrys. temp_dir encrypt. ,
                   shared_secret listfile opts. logfile response_tofile ,
                   norexxlib reverse normal bold cy_ye timeout mm0a bytessent  , 
                   didrsync didgzip orisize diddecrypt askupwd logfile  gosock opts.
parse arg server,request,username,pwd,oldfile,forcesock,tempfile

crlf = '0d0a'x
sorig_size=''
ith=0
closeit=0
iscgi=pos('CGI-BIN/',translate(request))
orisize=0

arsyncok=rsyncok
askupwd=0
req0=request
iter=0
notmod=0

if iscgi>0 | forcesock=1 | gosock='' then do
   gosock=sockhttp_opensock(gosock,server)
   if abbrev(gosock,'-1')=1 then do
      say "Error, unable to create socket to " server
      gosock=''
     exit
  end
end

agin:           /* jump here if problem (and try GET without encoding */

didrsync=0; didgzip=0 ;diddecrypt=0
response_tofile=0

message='GET 'request ' HTTP/1.1'crlf'HOST: 'server||crlf
message=message||'Referer: UpClient@'||servername||crlf
if forcesock=1 | iscgi>0 then do
   closeit=1
   message=message||'Connection: close' crlf /* forcesock implies close */
end

if arsyncok=1 & oldfile<>'' then do
   rsign=rsync_synopsis(oldfile)
   if rsign<>'' then  message=message||'Rsync-signature_updater: 'rsign||crlf
end

if username<>'' then do
   upwd=mk_base64(strip(username)':'strip(pwd))
   upwd='Basic 'upwd
   message=message||'Authorization: '||upwd||crlf
end
message=message||crlf

do oppie=1 to 2
   rc = SockSend(gosock, message)   /* SEND THE REQUEST TO THE SERVER */

/* !!! Now get the response !!!!! */
  got=sockhttp(gosock,timeout,tempfile,10000)  /* WAIT FOR, AND GET, RESPONSE */

  parse var got statline '0d0a'x got              /* get the status */
  parse var statline asockstat sockinfo 

  asockstat=strip(asockstat)
  select                        /* CHECK FOR ERROR CONDITIONS */
    when asockstat=-1 then  do
      say 'ERROR  Unable to complete request: 'sockinfo','gosock
      if datatype(gosock)='NUM' then   foo=a_sockclose(gosock,1)
      gosock=''
      return ''
    end
  
    when asockstat=-2 & ith=1 then do
         say 'ERROR  Unable to connect to 'server
         if datatype(gosock)='NUM' then foo=a_sockclose(gosock,2)
         gosock=''
         return ' '
    end

    when asockstat=-2 then do
      ith=1
      if verbose>1 then say " Can not reuse " gosock', creating new socket '
      gosock=sockhttp_opensock(gosock,server,httpport)
      if abbrev(gosock,'-1')=1 then do
         say "error connecting: "gosock
         gosock=''
         return ' '
      end 
      iterate           /* try again, with freshly minted socket */
    end

    otherwise leave             /* good response */
   end                  /* select */
end                     /* oppie */

/* IF here, response recieved. Check for non 200 response codes */
parse var sockinfo sockclosed respcode . ; respcode=strip(respcode)


select
  when respcode=401 then do
     say reverse'Username and password required!'normal
     askupwd=1
     if forcesock=1 then  foo=a_sockclose(gosock,3)
     return ' '
  end 
  when respcode>399  then do
     say reverse'ERROR'normal' not able ('respcode') to query 'server
     if forcesock=1 then  foo=a_sockclose(gosock,4)
     return ' '
  end
  when respcode=304 then do            /* not modified */
      notmod=1
      if forcesock=1 then  foo=a_sockclose(gosock,5)
      return ''
   end 
   when respcode=200 then do
      nop
   end 
   otherwise do
     say reverse'ERROR Unknown response code ('respcode') to 'server
     if forcesock=1 then  foo=a_sockclose(gosock,24)
     return ' '
   end  
end

/* if here, got a 200 response code */
if asockstat=1 then do
   gotfile=1
   t2=got
   stuff=tempfile
end 
else do                 /* returned result has headers and body */
   gotfile=0
   findit=crlf||crlf
   ifindit=pos(findit,got)
   t2=substr(got,1,ifindit)
   stuff=substr(got,ifindit+4)             /* THE ENTITY BODY */
end

/* look for varions response headers */
cencoding='';xupdater=''
clen=''

do until t2=''
   parse var t2 ahdr (crlf) t2
   parse upper var ahdr aname ':' avalue
   if strip(aname)='CONTENT-ENCODING' then cencoding=strip(avalue)
   if strip(aname)='X-UPDATER' then xupdater=strip(avalue)
   if strip(aname)='CONTENT-LENGTH' then clen=strip(translate(avalue,' ','0d0a0009'x))
   if strip(aname)='X-NOTMOD' then do
       otmod=strip(translate(avalue,' ','0d0a0009'x))
       if otmod=1 then do
          notmod=2
          if forcesock=1 then  foo=a_sockclose(gosock,6)
          return ''
        end
   end
end /* do */

if abbrev(translate(xupdater),'ERROR')=1 then do 
  if verbose>1 then say "ERROR: "||'0d0a'x||got
  if forcesock=1 then  foo=a_sockclose(gosock,7)
  return ''  /* some kind of error, give up */
end /* do */

if xupdater<>'' then do
  parse upper var xupdater xup 'MD4=' smd4
  parse upper var xup . 'SIZE=' sorig_size . ',' .
  if datatype(sorig_size)<>'NUM' then sorig_Size=''
end
if gotfile=0 then
   orisize=length(stuff)
else
   orisize=stream(tempfile,'c','query size')



if clen<>''  then do
 if orisize<>clen then do  /* error, not correct amount of bytes recieved */
   say reverse'ERROR'normal' content-length mismatch: 'clen ', actual='||orisize
   if forcesock=1 then  foo=a_sockclose(gosock,8)
   return ' '
 end 
end

/* unencode response? */
encodeok=1
badenc=''

if cencoding<>'' then do   /* unencode from right to left */
    cencoding=translate(cencoding,' ',',')

    do jj=words(cencoding) to 1 by -1
        aword=strip(word(cencoding,jj))
        select
           when abbrev(aword,'ENCRYPT=')=1 then do
              if gotfile=1 then do
                  tempfile=do_decrypt(aword,tempfile,1)  /* tempfile will be name of decrypted file */
                  stuff=tempfile
              end
              else do
                 stuff=do_decrypt(aword,stuff)
              end
              if stuff='' then do
                if verbose>1 then say "UpDateMe error: unable to decrypt"
                if forcesock=1 then  foo=a_sockclose(gosock,9)
                return ""
              end
              diddecrypt=1
           end 
           when aword='GZIP' then do
              if gotfile=0 then do
                 stuff=do_ungzip(stuff)
              end
              else do
                 tempfile=do_ungzip(tempfile,1)
                 stuff=tempfile
              end
              if stuff='' then do
                if verbose>1 then say "UpDateMe error: bad ungzip"
                encodeok=0
                leave
              end
              didgzip=1
           end
           when aword='GDIFF' then do
              if oldfile='' then do             /* should never happen */
                encodeok=0
                leave
              end /* do */

              if gotfile=1 then do               /* differences are in a file */

                   tempfile2=make_tempname('UD3',norexxlib,temp_dir)
                   stat=rsync_ungdiff_file(oldfile,tempfile,smd4,tempfile2)
                   if stat='' then do
                      if verbose>1 then say 'UpDateMe error: bad ungdiff '  
                      encodeok=0
                      leave
                   end
                   foo=sysfiledelete(tempfile)
                   tempfile=tempfile2
                   stuff=tempfile
              end
              else do                           /* differences are in a string */
                 stuff=rsync_ungdiff(oldfile,stuff,smd4)
                 if stuff='' then do
                    if verbose>1 then say 'UpDateMe error: bad ungdiff '  
                    encodeok=0
                    leave
                 end
              end
              didrsync=1
           end                   /*  GDIFF encoding */
           when aword='IDENTITY' then iterate
           otherwise do
                badenc=badenc' 'aword
                encodeok=0
                leave
           end
        end  /* select */
    end /* cencoding */
end /* cencoding <> '' */

if encodeok=0 then do           /* problem encoding-- retrieve without any encoding ? */
    if iter=0 then do
        areq=''
        do until request=''
            parse var request a1 '&' request ; ta1=translate(a1)
            if abbrev(ta1,'GZIP')+abbrev(ta1,'RSYNC')=0 then areq=areq||'&'||a1
        end 
        request=strip(areq,,'&') ;iter=1 ;arsyncok=0; 
        signal agin
    end /* do */
    else do
        if verbose>0 then say reverse'ERROR'normal' unknown encoding encountered ('badenc') trying w/o encoding'
    end /* do */
end /* do */

if badenc<>'' then do
      say reverse'ERROR'normal' unknown encoding 'badenc
      if forcesock=1 then  foo=a_sockclose(gosock,10)
      return ""
end

/* check final size */
if sorig_size<>'' then do
  if gotfile=0 then
         len_final=length(stuff)
  else
         len_final=stream(tempfile,'c','query size')
  if strip(sorig_size)<>len_final then do
       say reverse'ERROR'normal' size ('len_final') does not match original size ('sorig_size')'
       if forcesock=1 then  foo=a_sockclose(gosock,11)
       return ""
  end 
end 

if forcesock=1 then  foo=a_sockclose(gosock,12)
if gotfile=1 then response_tofile=1
return stuff

/*********************************/
/* find a name for a temporary file */
make_tempname:procedure
parse arg ext,norexxlib,tempdir
ext=strip(ext) ; tempdir=strip(tempdir)

if pos(norexxlib,'01')=0 then do
   norexxlib=rxfuncquery('REXXLIBREGISTER')
end 

if tempdir='' then tempdir=value('TEMP',,'os2environment')

if norexxlib<>0 then
    tfoo='t'||right(date('d')||time('s'),7,'0')
else
    tfoo='t'||right(dospid()||dostid(),7,'0')

tempfile=tempdir'\'tfoo'.'||strip(ext,'l','.')
foo=stream(tempfile,'c','open write')
if abbrev(strip(translate(foo)),'READY')=0 then return ''      /* unable to write to this file */
foo=stream(tempfile,'c','close')
foo=sysfiledelete(tempfile)             /* delete it (possibly 0 length file just created */
if stream(tempfile,'c','query exists')<>'' then return '' /* could not delete */
return tempfile         /* success! */


/***********************************/
/* un gzip a file */
do_ungzip:procedure  expose temp_dir listfile bold reverse normal logfile   norexxlib
parse arg astring,isfile

if isfile=0 | isfile='' then do
   a2=rxgzInflateString(astring)
   return a2                            /* return as string */
end

tempfile=make_tempname('UD2',norexxlib,temp_dir)
a2=rxgzInflateFile(astring,tempfile)
if a2<>0 then return ''
foo=sysfiledelete(astring)

return tempfile               /* tempfile is now working file */


/*******************************************/
rsync_synopsis:procedure  expose  norexxlib reverse normal bold cy_ye mm0a listfile logfile  

parse arg afile,nblocks

if nblocks='' then nblocks=45
if datatype(nblocks)<>'NUM' then nblocks=45
if nblocks<10 | nblocks>255 then nblocks=45   /* 255 limit on # of blocks */

if afile='' then return "ERROR no old-version file specified"

/* read "Afile" */
aa=translate(stream(afile,'c','open read'))
if  abbrev(aa,'READY')=0 then return "ERROR could not open synopfile "afile
isize=stream(afile,'c','query size')
if isize='' | isize=0 then do
    return reverse'ERROR'normal' 'afile " is unaccessible"
    return ''
end
astuff=charin(afile,1,isize)
aa=stream(afile,'c','close')


blocksize=trunc(0.9999 + (isize/nblocks))
if blocksize<200 then do
    blocksize=200
    nblocks=trunc((isize/blocksize)+0.999)
end /* do */
ac1=d2c(blocksize)
ac1=right(ac1,4,x2c('00'))
ac1=ac1||d2c(nblocks)
iat=1
do mm=1 to nblocks
  if mm=nblocks then
     ablock=substr(astuff,iat)
  else
     ablock=substr(astuff,iat,blocksize)
  acd0=rx_rsync32_md4(ablock)
  ac0=left(x2c(acd0),8)

  ac1=ac1||ac0
  iat=iat+blocksize
end
ac1=mkpack64(ac1)

return ac1


/***********************************/
/* decrypt a file */
do_decrypt:procedure expose  temp_dir shared_secret  encrypt. listfile bold normal cy_ye reverse logfile ,
                          norexxlib opts.
parse arg arg1,astring,isfile

useenc=''
parse var arg1 . '=' a2 ; a2='!'||strip(translate(a2))
if symbol('ENCRYPT.'||a2)<>'VAR' then return ''  /* not supported encrytion type */
doit=encrypt.a2

if shared_secret='' then do
    shared_secret=ask_shared()
end 
shared_secret=translate(shared_secret)

tmpf=make_tempname('1',norexxlib,temp_dir)  /* where the decrypted stuff will be written to */

/* if file, then astring is name ofenocded file */
if isfile<>1 then do
   tmpfenc=make_tempname('ENC',norexxlib,temp_dir)
end /* do */

foo=sysfiledelete(tmpf)
if isfile<>1 then do
  foo=sysfiledelete(tmpfenc)
  joo=charout(tmpfenc,astring,1)
  oog=stream(tmpfenc,'c','close')
  if joo<>0 then do
    foo=sysfiledelete(tmpf)
    foo=sysfiledelete(tmpfenc)
    return ''
  end 
end
else do
  tmpfenc=astring
end

doit=replacestrg(doit,'%IN',tmpfenc,'ALL')
doit=replacestrg(doit,'%OUT',tmpf,'ALL')
doit=replacestrg(doit,'%KEY',shared_secret,'ALL')
doit=strip(doit)
aa=word(doit,1)
signal on syntax name noenc ; signal on  error name noenc

if pos('(',aa)>0 then do
    doit='foo='doit
    interpret doit 
end
else do
   address cmd '@'doit 
end /* do */

signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpfenc)     /* don't need this anymore */

if isfile=1 then do
   return tmpf          /* decrypted file is now the working file */
end /* do */


oof=strip(translate(stream(tmpf,'c','open read')))
if abbrev(oof,'READY')=0 then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
sz=stream(tmpf,'c','query size')
if sz=0 | sz='' then do
  foo=stream(tmpf,'c','close')
  foo=sysfiledelete(tmpf)
  return ''         /* some kind of error */
end
aa=charin(tmpf,1,sz)
foo=stream(tmpf,'c','close')
foo=sysfiledelete(tmpf)
return aa



noenc:          /* jump here on error in decoding software */
signal on error name badguys; signal on syntax name badguys
foo=sysfiledelete(tmpf)
foo=sysfiledelete(tmpfenc)
return ''


/***************************************************************************/
/***************************************************************************/
/* SOCKhttp: a replacement for a sequence of sockrecv calls; 
             optimized for http requests 

  call as

      stuff=sockhttp(socket,[socket_timeout,tfile,max_notfile])

  where:
      socket == a socket that's been established using sockhttp_opensock
                (or with sockconnect).
               Alternatively, an ip address in the form
                        ii.jj.kk:port
                where
                        ii.jj.kk is an ip address
                        :port is an optional port (:80 is the default)
                If this address is provided, then a socket will be opened, 
                used, and then closed.

                Note: if a socket is provided, it will NOT be closed 
                      (you should close it using stat=a_sockclose(socket)

    socket_timeout == optional. a timeout value in seconds 
                      (per socket call, default=30)
    tfile    == optional. file to write results to (default, do NOT write to file)
 max_Notfile == optional. maximum response size for writing to string. If response
                > then this, then return headers and put body into tfile
                If 0 (the default), then always write to file 
and
   stuff =  status_line '0d0a'x response

where: 

  status_line: a space delimited set of values:
      stat_code   message

  stat_code: takes values
     -2 = error, probably due to specified socket not being open
     -1 = error 
      0 = success, stuff contains entire response line, response headers & body
      1 = success, stuff contains response line & response headers,
         resonse body will be in tfile.
         This can only happen if  stat tfile<>'' & length(response)>max_notfile 

  message:
     if stat_code<0, then a several word description of the error
     otherwise, wasclosed response_line; where--
        wasclosed: 0 if connection was not closed, 1 if it was
        response_code: the response code (i.e.; 200)


 response:
   if stat_code<0, then stuff will be empty
      stat_code=0, the response headers and body
      stat_code=1, the headers (body will be in tfile)

Example:
   stuff=sockhttp(,,'foo.tmp')
   parse var stuff statline '0d0a'x stuff1
   parse var statline statcode message
   select 
     when statcode<0 then say "Error message: "message
     when statcode=0 then do
          parse message wasclosed response_code
          parse var stuff1 response_headers '0d0a0d0a'x response_body
      end
     when statcode=1 then do
       response_headers=stuff1   / * response_body is in foo.tmp * /
     end
     otherwise
   end


Notes:
    * if tfile not defined, then max_notofile is ignored
    * see "user changable parameters" for some default values
    * socket_timeout refers to maximum seconds between "sockrecv" requests. 
      It does NOT refer to total length of time required to recieve a message.
      Thus, a number of medium length delays (say, a few seconds required
      to complete each of several sockrecv requests) will NOT cause a timeout 
      (in other words, the timeout counter is reset upon each successful 
      completion of a 1000 byte sockrecv request).
  
*/

SOCKhttp:PROCEDURE expose bold normal cy_ye reverse logfile mm0a verbose

/* ------------ User changable parameters  --------------------- */

/* default time out in seconds for each set of socket calls
   (if timeout argument not given) */
def_socket_timeout=30

/* default value of max_notfile */
def_max_notfile=0       /* if tfile specified, 0 means "always write body to tfile*/

/* maximum length of response. If response > than this, an error is returned */
maxlen=1000000000  /* 1 gigabyte */

/* amount of status messages. 0=none, 1=some, 2=more */

/* ------------ end of user changable parameters -----------------*/

PARSE Arg socket,socket_timeout,tfile,max_notfile                    

if datatype(socket_timeout)<>'NUM' then socket_timeout=def_socket_timeout
if datatype(socket_timeout)<>'NUM' then do
   return '-1 Bad socket timeout value : 'socket_timeout
end 

if datatype(max_notfile)<>'NUM' then max_notfile=def_max_notfile
if datatype(max_notfile)<>'NUM' then do
   return '-1 Bad max_notfile value : 'max_notfile
end 

if maxlen='' then maxlen=1000000000
if datatype(maxlen)<>'NUM' then do
   return '-1 Bad maxlen value : 'maxlen
end 

isclosesock=0
if pos(".",socket)>0 then do             /* socket is an ip address */
   parse var socket anip ':' aport ; aport=strip(aport) ;anip=strip(anip)
   if aport=''  then aport=80
   socket=sockhttp_opensock(,anip,aport)
   if abbrev(socket,'-1')=1 then return '-1 Unable to create socket '
   isclosesock=1
end /* do */


if verbose>2 then say "Socket will wait for " socket_timeout " seconds ...."

/* READY to start recieving */

if Sockioctl(socket,'FIONBIO',1) = -1 then  do      /* switch to nonblocking mode */
   Return '-1 crashed in sockioctl 'socket':'errno
end

/* global parameters */
incoming=''
fileon=0
rheaders=''
clen='' ; ischunked=0
len_toget=''
wasclosed=0
trailers=''

ict=0

/* first, get header */
call sockhttp_headers    /* also sets ichunked, incoming, and clen */

ares=result
if ares<>'' then do
  if isclosesock=1 then do
      foo=a_sockclose(socket,13)
  end
  return ares    /* ares might be an error message, starting with -1 */
end

parse var rheaders respline '0d0a'x response
parse var respline . icode .

if icode>299 & icode<400 then do        /* 300, hence no body */
   return '0 0 'icode||'0d0a'x||rheaders
end

/* 3 ways of sending data
1) with content-length header
2) using chunked encoding
3) closing connection at end of data transferal */

if ischunked<>1 then do
   if len_toget=0 then
        nop             /* incoming was gotten */
   else
        call sockhttp_nonchunk
end
else do
   call sockhttp_chunk
   if verbose>0 then say ''
   if trailers<>'' then rheaders=rheaders||'0d0a'x||trailers
end

/* did an error occur? */
ares=result
if ares<>'' then do
  if isclosesock=1 then foo=a_sockclose(socket,14)
  return ares    /* ares might be an error message, starting with -1 */
end

if sockioctl(socket,'FIONBIO',0) = -1 then do          /* switch to blocking mode */
    if verbose>0 then say 'Sockhttp: ioctl error on switch to blocking mode: ' errno
end

daclosed=0

if wasclosed=1 | isclosesock=1 then do
  daclosed=1 
  foo=a_sockclose(socket,15)
end

if fileon=0 then 
   return '0 'wasclosed' 'icode||'0d0a'x||rheaders||'0d0a0d0a'x||incoming
else
   return '1 'wasclosed' 'icode||'0d0a'x||rheaders


/***** ----------------- ***/
/* read header section (and response line)
  Sets:  rheaders, incoming, ischunked, clen 
if no error, return ''. Otherwise, return '-1 error message */

sockhttp_headers:

i1000=600
timeout=socket_timeout
Do While TimeOut > 0

    res=Sockrecv(socket,'data',i1000) 

    if res=0 then do
       return '-1 Socket prematurely closed'
    end /* do */

    if res<0 then do                           /* error condition ? */
      If errno <> 'EWOULDBLOCK' THEN  do      /* real crash ? */
          if errno='ECONNRESET' | errno='ENOTSOCK' then  do
              Return '-2 socket closed?  '  /* might be bad socket */
          end
          else do
              Return '-1 crashed in sockrecv 'errno  /* yes, real crash */
          end
      end

      /* not a crash, but no data available:  errno = EWOULDBLOCK & sockrecv returned -1 */

      ict=ict+1;     if verbose>2 then say 'SockHttp_headers: Waiting ('ict')...'

      goo=syssleep(0.25)           /* relinquish the CPU for one second, this is from REXXUTIL */

      TimeOut = TimeOut - 0.25 /* count down my timer */
      Iterate                    /* loop again */
   End                           /* if sockrecv = -1 */
   if res<0 then return "-1 Socket timed out " 
   ikk=pos('0d0a0d0a'x,data)

   if ikk=0 then do                /* all of DATA is header info */
      rheaders=rheaders||data
      iterate                   /* sockrecv next block */
  end

/* if here, got all of the headers */
  rheaders=rheaders||left(data,ikk-1)
  if verbose>2 then say length(rheaders)||' bytes of request headers'

  incoming=substr(data,ikk+4)          /* get beginning of content */

/* find content-length, or "chunked" transfer-encoding */
   rhh=rheaders
   do until rhh=''
       parse var rhh aline '0d0a'x rhh
       parse upper var aline aname ':' aval ;
       aname=strip(translate(aname)) ; aval=strip(translate(aval))
       select 
           when aname='CONTENT-LENGTH' then clen=aval
           when aname='TRANSFER-ENCODING' then do
               if pos('CHUNKED',aval)>0 then ischunked=1
           end
           otherwise nop
       end
    end             /* found end of response headers */
    if clen<>'' then do
        if verbose>1 then  say "Content-length = "clen
        len_toget=clen-length(incoming)
    end
    if ischunked=1 & verbose>1 then say "Using chunked encoding "  
    leave
end                 /* building rheaders */
return ''               /* blank return signals okay */

/**************************/
/* chunked read of content   sets INCOMING, WASCLOSED, FILEON; writes to TFILE */

sockhttp_chunk:
buffer=incoming         /* left over from header read */
i1000=1000
incoming=''

totbytes=0
if verbose>0 then call charout,'Bytes read: 'totbytes||'0d'x

do forever              /* come here to read another chunk */

   if verbose>0 then call charout,'Bytes read: 'totbytes||'0d'x

   if length(incoming)>max_notfile & tfile<>'' then do
        call write_to_tfile
   end 

  ipos=pos('0d0a'x,buffer)
  if ipos=0 then do                  /* recharge buffer */
     data=sockin(socket,i1000,socket_timeout,verbose)
     parse var data scode '0d0a'x buffer0 

     if scode<0 then return data   /* some kind of error */
     if scode=0 | buffer0='' then return '-1 {a} premature close of chunked response'
     buffer=buffer||buffer0
     totbytes=totbytes+length(buffer0)
     iterate
  end      

/* determine size of chunk */
  aa=left(buffer,ipos-1)
  buffer=substr(buffer,ipos+2)
  parse var aa gg ';' .
  gtsize=x2d(strip(gg))

  if gtsize=0 then leave               /* no more content to get */
  if gtsize<0 then return '-1 error reading chunk size '

/* is this chunk||crlf within the buffer */
  if (gtsize+2)<=length(buffer) then  do
     incoming=incoming||left(buffer,gtsize)
     if gtsize+2=length(buffer) then
        buffer=''
     else
        buffer=substr(buffer,gtsize+3)    /* buffer now starts with a new chunk */
     iterate                        /* extract next chunk, either from buffer or from sockin */
  end

/* chunk is larger then the buffer */
  toget=(gtsize+2)-length(buffer)       /* note that chunk always has appended crlf */
  if toget<3 then do            /* special case (dangling cr or crlf */
     if toget=1 then 
        incoming=incoming||left(buffer,length(buffer)-1)
     else
        incoming=incoming||buffer

     data=sockin(socket,toget,socket_timeout,verbose)
     parse var data scode '0d0a'x data 
     if scode<0 then return data   /* some kind of error */
     if scode=0 then return '-1 {b} premature close of chunked response'
     buffer=''          /* get next chunk from sockin */
     totbytes=totbytes+length(data)
     iterate
  end

/* buffer does not contain entire chunk; so sockin some more */
  incoming=incoming||buffer

/* read chunks via calls to sockin */
  do forever            /* get this "chunk" in 1000 byte increments */
    j1000=min(1000,toget)            /* get trailing crlf */
    data=sockin(socket,j1000,socket_timeout,verbose)
    parse var data scode '0d0a'x data 
    if scode<0 then return data   /* some kind of error */
    if scode=0 then return '-1 {c} premature close of chunked response'

    lendata=length(data)
    totbytes=totbytes+lendata

    toget=toget-lendata
    if toget=0 then do        /*  end of chunk  */
        incoming=incoming||left(data,lendata-2)
        buffer=''
        leave
    end 
    else do             
        incoming=incoming||data
    end


  end                   /* forever for this chunk */

/*  large resource and tfile available?  save it to a file */
   if length(incoming)>max_notfile & tfile<>'' then do
        call write_to_tfile
   end
    
end             /* get get next chunk (exit via LEAVE */


if fileon=1 then do
    astat=sock_closetfile()
    if astat<>'' then return astat   /* error if not '' */
end

if wasclosed=1 then return ''           /* closed, to stop here */
if buffer='0d0a'x then do
  wasclosed=0
  return ''        /* no trailers */
end

if right(buffer,4)='0d0a0d0a'x then do
   trailers=left(buffer,length(buffer)-4)        
   wasclosed=0
   return ''
end

trailers=buffer

do mm=1 to 50           /*50k trailer max */
  data=sockin(socket,i1000,socket_timeout,verbose)
  parse var data scode '0d0a'x data
  if scode<0 then return data   /* some kind of error */
  if scode=0 then do          /* conection closed */
    wasclosed=1
    return ''
  end
  trailers=trailers||data
  if right(trailers,4)='0d0a0d0a' then do
     trailers=left(trailers,length(trailers)-4)
     wasclosed=0
     return ''
  end
end
say 
return '-1 trailers too long '


/*************/
/* possibly write incoming to tfile */
write_to_tfile: 
      if fileon=0 then do               /* initialize file */
          foo=stream(tfile,'c','close')
          foo=sysfiledelete(tfile)
          foo=strip(translate(stream(tfile,'c','open write')))
          if abbrev(foo,'READY')=0 then Return '-1 unable to open file: 'tfile
          fileon=1
      end
      nm=charout(tfile,incoming)
      if nm<>0 then return '-1 error writing to file '
      incoming=''
   end 
return


/*********----------------*****************/
/* non-chunked read of content
  sets INCOMING, WASCLOSED, FILEON; writes to TFILE */

sockhttp_nonchunk:

i1000=1000
Do forever              /* build up one socket call at a time */

    if len_toget<>'' then do
        i1000=min(1000,len_toget)
    end 
    data=sockin(socket,i1000,socket_timeout,verbose)

/*  parse out status and data: -1=error, 0=closed,1=data */
    parse var data scode '0d0a'x data

    if scode<0 then return data   /* some kind of error */

    if scode=0 then do          /* conection closed */
       if fileon=1 then do
          astat=sock_closetfile()
          if astat<>'' then return astat   /* error if not '' */
       end
       wasclosed=1
       return ''
    end

/* if here, still building (sockinstat=0) */

   incoming=incoming||data

   if verbose>1 then say "SockHttp_nochunk: total data recieved: "length(incoming) 

   if length(incoming)>maxlen then return '-1 Maxlen exceeded 'maxlen

/*  large resource and tfile available?  save it to a file */
   if length(incoming)>max_notfile & tfile<>'' then do
      if fileon=0 then do               /* initialize file */
          foo=stream(tfile,'c','close')
          foo=sysfiledelete(tfile)
          foo=strip(translate(stream(tfile,'c','open write')))
          if abbrev(foo,'READY')=0 then Return '-1 unable to open file: 'tfile
          fileon=1
      end
      nm=charout(tfile,incoming)
      if nm<>0 then return '-1 error writing to file '
      incoming=''
   end 

   len_toget=len_toget-length(data)

   if len_toget=0 then do                 /* content-length bytes have been read */
       if fileon=1 then do
          astat=sock_closetfile()
          if astat<>'' then return astat   /* error if not '' */
       end
       wasclosed=0              /* though it might be closed on next read */
       return ''
   end 

End              /*  ------ get next sockrecv */

/* should never get here */


/* ------------------ */
/* write to tfile, and close  */
sock_closetfile:
 nm=0
 if incoming<>'' then nm=charout(tfile,incoming)
 if nm<>0 then do
    if verbose>0 then say "ERROR: unable to write to file: "tfile
     Return '-1 unable to write to file'
 end 
 foo=stream(tfile,'c','close')        /* don't bother checking for error, but we could */
 return ''



/*******/
/* non blocking sockrecv  */
sockin:procedure   expose bold normal cy_ye reverse logfile mm0a
parse arg socket,i1000,socket_timeout,verbose

atimeout=socket_timeout
if atimeout='' then atimeout=30
if verbose='' then verbose=0

ict=0

Do While aTimeOut > 0
    res=Sockrecv(socket,'data',i1000) 
    select 

      when res<0 then do                           /* error condition, or nothing recived? */
         If errno <> 'EWOULDBLOCK' THEN  do
            if errno='ECONNRESET' then
                Return '-2 socket (sockin) closed?  '  /* yes, real crash */
            else 
               Return '-1 crashed in sockin 'errno  /* yes, real crash */
         end

/* else not a crash, but no data available (errno = EWOULDBLOCK & sockrecv returned -1)  */
         ict=ict+1
         if verbose>1 then say 'SockIn: Waiting ('ict')...'
         goo=syssleep(0.25)           /* relinquish the CPU for one second, this is from REXXUTIL */

         aTimeOut = aTimeOut - 0.25 /* count down my timer */
         Iterate                    /* loop again */
      End                           /* if sockrecv = -1 */

      when res<-1 then do            /* some other error */
         Return '-1 Error in sockin 'errno  
      end 

      when res=0 then return '0'     /* signal "closed connection */

      otherwise return '1'||'0d0a'x||data

   end
        
end             /* timeout */
return '-1 timeout'             /* if here, atimeout<0 */


/***/
a_sockclose: procedure
parse arg a1,a2   /* a2 is caller code */
foo=sockclose(a1)
return foo


/********************************************/
/* open up a socket ----------- **/
/* note that gosock is returned, or -1 error message  */ 
sockhttp_opensock:procedure   expose bold normal cy_ye reverse logfile mm0a

parse arg gosock,server,httpport

if httpport='' then do
    if abbrev(translate(server),'HTTP://')=1 then parse var server . '://' server 
    parse var server server ':' httpport
end /* do */

if datatype(gosock)='NUM' then rc = a_sockclose(gosock,13)   /* close gosock? */

server=strip(server)
httpport=strip(httpport)
if httpport="" | datatype(httpport)<>'NUM' then httpport=80
crlf = '0d0a'x

family  ='AF_INET'

rc=1
if verify(server,'1234567890.')>0 then 
   rc=sockgethostbyname(server, "serv.0")  /* get dotaddress of server */
else
  serv.0addr=strip(server)

if rc=0 then  return '-1 ERROR Unable to resolve 'server

dotserver=serv.0addr                    /* .. */
gosaddr.0family=family                  /* set up address */
gosaddr.0port  =httpport
gosaddr.0addr  =dotserver

gosock = SockSocket(family, "SOCK_STREAM", "IPPROTO_TCP")

rc = SockConnect(gosock,"gosaddr.0")
if rc<0 then do 
     return '-1   Unable to connect to 'server' 'rc
end

return gosock

