/*25 Dec 1999. Daniel Hellerstein (danielh@crosslink.net)
  UpDater-cgi: A cgi-bin script to do rsync based server-to-server updater.

        This is the "central" portion.

 For details, see updater.doc

Reminder: this portion uses "package files", that are stored in the
updater_dir\package directory.

A Package file contains "mime-like" entries, with each entry seperated by a 
blank line. Entries must begin with a   name:, where name 
is one of the following:
   title:               -- the title of this package
   description:         -- a longer description of this package
   privileges:          -- required privileges (possibly *)
   include:               -- a list of files in this package
   exclude:             -- list of files to exclude 
   no_encode:           -- list of files for which gzip and rsync is suppressed
   run:                 -- execute a program on a remote client AFTER updating

*/


/**** User changeable parameters ****/


/* add crc's of file in package list (required for "crc32 check" by remote
   servers. 1=yes, 0=no */
addcrc=1

/* Always use cache entry if it's current. That is, suppress NOCACHE=1 option */
always_use_cache=1

/* colors and or background used in some html displays */
back1='bgcolor="#88aa66"'

/* allow use of GZIP encoding (requires gzip.exe) */
candogzip=1

/* allow use of rsync (requires rxrsync.dll)
   To use rsync, the server must be able to provide
   a 500 byte header, with the nane Rsync-signature_updater, 
   as script-accessible environment variable. */
candorsync=1

/* ip name of this server. Some servers have problems with the 
   SCRIPT_NAME cgi-bin environment variable; you can use this
   as a "backup" (for when SCRIPT_NAME does not yield 
   a value).
   If you aren't sure, leave it blank (the program will use
   socket calls to determine this server's ip address) */
my_servername=''

/* Name to use in URI's to call this script. 
  Leave blank to use default of "cgi-bin/udpater.cmd" */

SCRIPT_NAME=''


/* list of files, in or under the updater directory, that the SEND= option
   is allowed to "send to the client" */
send_files='UPDATER.DOC RXGZLIB.DLL GZIP.EXE RXRSYNC.DLL UPCLIENT.CMD'

/*  the "updater" directory -- should be a fully qualified directory.
    Or, leave it blank to use the default (the UPDATER subdirectory of 
    the GoServe working directory). */

UPDATER_DIR='' 
 

/* status message display: 0=none, 1=some, 2=more */
verbose=1

/**** End of User changeable parameters ****/

updater_cgi:    

parse arg  stuff

verb=value('REQUEST_METHOD',,'os2environment')
if verb="" then do
   say " This cgi-bin script is not meant to be run in stand-alone mode. "
   exit
end  /* Do */
signal on error name badguys; signal on syntax name badguys
crlf = '0d0a'x

if script_name='' then script_name='cgi-bin/updater.cmd'
script_name=strip(script_name,'l','/')

list= value("QUERY_STRING",,'os2environment')
servername=value('SERVER_NAME',,'os2environment')
if servername='' then do
  if my_servername='' then do
     servername=get_hostname()
  end
  else do
     servername=my_servername
  end 
end
basedir=directory()

if updater_dir='' then do
     updater_dir=strip(basedir,,'\')'\UPDATER'
end /* do */

if dosisdir(updater_dir)=0 then do
    say 'Content-type: text/plain '
    say
    say ' UPDATER configuration error. No such updater directory: 'updater_dir      
    return 
end

package_dir=updater_dir'\PACKAGE'
if dosisdir(package_dir)=0 then do
    say 'Content-type: text/plain '
    say
    say' UPDATER configuration error. No such package directory: 'package_dir
    return 
end

call check_dlls         /* load some dlls */
if result=0 then return /* fatal error */

/* pull out arguments */
args.=''
if list='' then list='package=!list&ashtml=1'
do until list=""                /* get user input */
   parse var list a1 '&' list
   parse var a1 a1a '=' a1b0
   a1a='!'||translate(strip(a1a))
   args.a1a=strip(a1b0)
end

call do_central

return 

/*************************************/
/* here if updater is acting as a central server */
do_central:

/* send UPCLIENT.CMD */
if strip(translate(args.!SEND))<>'' then do
  if wordpos(strip(translate(args.!send)),translate(send_files))=0 then do
     say 'Content-type: text/plain'
     say 
     say 'No such file available 'args.!send
     return 0
  end 
  afile=updater_dir'\'||strip(args.!send)
  foo=stream(afile,'c','query exists')
  if foo='' then do
     say 'Content-type: text/html'
     say
     say '<html><head><title>UpClient not available</title></head>'
     say '<body 'back1'> '
     say '<h3>File not available </h3>'
     say 'Sorry, 'args.!send ' is not available.'
     say '</body></html>'
     say
     return
   end
   else do
     if args.!text=1 then
        say 'Content-type: text/plain'
     else
        say 'Content-type: application/octet-stream'
     say 'Content-Disposition: attachment; filename="'args.!send'"'
     say
     avv=getsay(afile)
     return
   end 
end 


/* show some documentation on upclient */
if translate(aRgs.!action)='UPCLIENTDOC' then do
       call tell_upclient
       return
end /* do */

if abbrev(translate(strip(args.!action)),'GETL2')=1 then do    /* form to get client options */
       call get_client_options
       return
end

/* (the default) return a list of current packages? */
IF ARGS.!PACKAGE='?' | translate(strip(ARGS.!PACKAGE))='!LIST' then DO
      call do_packagelist
      return status
end 

/* return info on a selected package */
/*  ? -- a request for listing of currently available packages
    PACKAGE_NAME -- a name of a package (must correspond to a
                    file in the PACKAGE_DIR 
*/

package_file=package_dir'\'||strip(args.!package)||'.PKG'
isize=stream(package_file,'c','query size')
if (isize=0 | isize='') then do
    say 'Content-type: text/plain '
    say
    say ' UpDater ERROR: empty or missing package: 'args.!package
    return 
end

stat=read_package(package_file,isize)             /* read in package file */

/************
 NOTE -- cgi version does NOT support username/password access to packages 
*************/


/* check action. */
 anaction=translate(fixit(args.!ACTION))

 select

/* list contents of this package */
    when abbrev(ANACTION,'DISP') then DO                
       call disp_package
       return 1
    end    

/* return a "get list". The remote server should request each file on this
   list, subject to date checking, possibly using rsync */

    when abbrev(anaction,'GETL')=1 then do    /* set package list ! */
       call send_gets
       return 1
    end

/* get a file from a package */
    when abbrev(anaction,'FILE')=1 then do   
        call get_file
        return result
    end
    otherwise 
 end  /* select */


say 'Content-type: text/plain '
say
say 'UpDater: No action was specified '

return 0


/***********************/
/*get a file, "charout" it to stdout; perhaps delete */
getsay:procedure
parse arg afile,dodel

foo=stream(afile,'c','open read')
if abbrev(strip(translate(foo)),'READY')<>1 then do
  if dodel=1 then foo=sysfiledelete(afile)
  return 0
end
sz=stream(afile,'c','query size')
if sz=0 | sz='' then do
   if dodel=1 then foo=sysfiledelete(afile)
   return 0
end

if sz<20000 then do
    aa=charin(afile,1,sz)
    call charout,aa
end /* do */
else do
   do mm=1 to sz by 10000
      iread=min(1+sz-mm,10000)
      if mm=1 then
           aa=charin(afile,1,iread)
       else
          aa=charin(afile,,iread)
      call charout,aa
   end 
end
foo=stream(afile,'c','close')
if dodel=1 then foo=sysfiledelete(afile)
return 1



/*************************************/
/* get client options */
get_client_options:
packagename=translate(strip(args.!package))
say 'Content-type: text/html'
say
say '<html><head><title>Updater Client options </title></head>'
say '<body 'back1'>'
say '<h3>Please select a few UpDater  options</h3>'
say 'Files listed in the <tt>'args.!package '</tt> package (on <tt> ' servername'</tt>)'
say 'will be UpDated to your computer.'
   
/* create a form  */
say '<form action="/'script_name'" method="GET">'
say '<input type="hidden" name="action" value="GETL">'
say '<input type="hidden" name="package" value="'args.!package'">'
say '<input type="hidden" name="client" value="1">'

say '<input type="Submit" value="Get the files in 'packagename'... ">'
say '<table>'

say '<tr valign="top"><td>Destination directory (on your computer)</td> '
say '<td><input type="text" name="DESTDIR"  size=30> </td>'

say '<tr valign="top"><td>Backup directory (on your computer).</td> '
say '<td><input type="text" name="BACKUPDIR" size=30>'
say '<br><em> To suppress backing up changed files, leave this field empty.</em></td>'


say '<tr valign="top"><td>Update checks &amp; cleanup option</td>' 
say '<td><input type="radio" name="CHECK" value="1" checked> '
say 'Update if newer (using file creation date) <bR>'
say '<input type="radio" name="CHECK" value="2" > '
say 'Update if 32bit (crc32) file hash is different <bR>'
say '<input type="radio" name="CHECK" value="3">'
say 'Update if 128bit (md4) file hash is different <bR>'
say '<input type="radio" name="CHECK" value="0">'

say 'Always update '

say '<hr width="25%"> <input type="checkbox" name="DODELETE" value="1" > '
say 'Delete all existing files (in your destination directory) that are not mentioned in this package'
say '</td>'

say '<tr><td colspan=2 align="middle"><hr><b>Advanced Options </b><br> </td>'
say '<tr valign="top"><td valign="top">Range to retrieve</td>'
say '<td> Retrieve entries from '
say '#<input type="text" name="RANGE1"  size=5></em>'
say ' to '
say '#<input type="text" name="RANGE2"  size=5><em>(leave both boxes blank to retrieve all files)</em>'
say '</td>'
say '<tr ><td valign="top">Features </td>'
say '<td><input type="checkbox" name="nocache" value=1 > Use the latest version of <tt> 'packagename'</tt> ?'
say '<br><input type="checkbox" name="dorun" value=1 > Automatically execute <em>installation</em> program <em>(if one is available)</eM> ?'
say '<br><input type="checkbox" name="quiet" value=1 > Quiet output (minimal display of status messages)?'
say '</td>'
say ''
say ''

say ''
say ''
say '</table><hr>'
ab='Get the files in 'packagename'...'
say '<input type="Submit" value="'||reverse(ab)||'">'

say '</form>'

say '<p>'
say '<a href="/'||script_name||'?">Return to UpDater main menu</a> (at 'servername')'

say '</body></html>'

return 1


/*************************************/
/* get a file from a package
   Uses filename, entry #, and package name to determine 
   actual file.
   Assuming that no_encode does not apply to this file,
      If RSYNC specified, will return an rsync differenc file.
      If GDIFF specified, will giff the file
     (GDIFF after RSYNC).
*/   
get_file:
afile=strip(translate(args.!file,'\','/'),,'\')
aentry=strip(args.!entry)
doerase=' ' ;celist=''
if aentry> package_opts.0 then do
   'say content-type: text/plain'
   'say x-updater: ERROR '
   say
   say  "No such entry: "aentry
   return 1
end 
if Pos('\',afile)>0 then do
    if package_opts.aentry.!subs<>1 then do
       'say content-type: text/plain'
       'say x-updater: ERROR '
       say
       say  "Subdirectories are not accessible "
       return 1
    end
end 
/* append afile to !cfile, but watch out for wildcards */
cfile=package_opts.aentry.!cfile

foo=translate(cfile,' ','\')
aa=word(foo,words(foo))
if (pos('.',aa)+pos('*',aa)+pos('?',aa))=0 then cfile=cfile'\*.*'

iast=pos('*',cfile)
if iast>0  then do
   islash=lastpos('\',cfile,iast)
   cfile2=left(cfile,islash)||afile
end /* do */
else do
   cfile2=cfile
end /* do */

/* excluded file? */

aa=check_exclude(cfile2)
if aa=1 then do
  say 'Content-type: text/plain '
  say
  say 'Updater can not access 'afile' in package: 'args.!package
  return 0
end 

aa=sysfiletree(cfile2,'goo','FT')

if goo.0=0 then do              /* couldn't find it */
   say 'Content-type: text/plain'
   say
   say 'Updater could not find 'afile' in package: 'args.!package
   return foo
end /* do */

if anaction='FILE1' then do    /* force without encoding or date checking */
  mtype=get_MediatypE(cfile2)
  say 'Content-type: 'mtype
  say 'Content-disposition:  attachment; filename="'||filespec('n',cfile2)||'"'
  say 
  foo=getsay(cfile2)
  return 1
end

parse var goo.1 adate orig_size .
xlist='SIZE='||strip(orig_size)||',DIR='||strip(package_opts.aentry.!rdir)

/* check hash? -- no longer used (instead, crc32 check on client side */
if args.!md4<>''  then do
   amd4=strip(translate(rx_md4(cfile2,1)))
   if amd4=strip(translate(args.!Md4)) then do
      say 'Content-type: application/x-updater'
      say 'X-NotMod: 1'
      say
      return 1
   end
end /* do */

/* are we allowed to encode this file? */
if strip(args.!No_encoding)=1 then
  noencode=1
else
  noencode=check_noencode(cfile2)

/* rsync this? */
if  noencode=0 & candorsync=1 then do 
  call rsignature
  if result=1 then do   /* found signature */
       dorsync=do_rsync(rheader,cfile2)
       if dorsync<>0 then do
           cfile2=dorsync
           xlist=xlist||',md4='||amd4
           doerase='ERASE '     
           celist='gdiff'
           foo=stream(cfile2,'c','close')
       end /* do */
  end
end

lencfil2=stream(cfile2,'c','query size')
/* gzip this ? */
if args.!gzip=1 & candogzip=1 & noencode=0 & lencfil2>100 then do
  stat=do_gzip(cfile2)
  if stat<>0 then do
      if doerase='ERASE' then do
        foo=sysfiledelete(cfile2)
      end
      doerase='ERASE'
      cfile2=stat
      celist=strip(celist||',gzip',,',')
   end
end

say 'Content-type: application/x-updater'
say 'x-updater: 'xlist
if celist<>'' then do
  say 'Content-encoding: 'celist
end
sz=stream(cfile2,'c','query size')
say 'Content-length: 'sz
say
if doerase='ERASE' then
  foo=getsay(cfile2,1)
else
  foo=getsay(cfile2)


return 1


/***********************************/
/* gzip a file */
do_gzip:procedure 
parse arg afile

atid=dostid()
apid=dospid()
tmpd=strip(value('TEMP',,'OS2ENVIRONMENT'),'t','\')
tmpf=tmpd'\G'||strip(left(apid,3))||atid||'.GZ'
foo=sysfiledelete(tmpf)

aa=rxgzdeflatefile(afile,tmpf)
if aa=0 then return tmpf
foo=sysfiledelete(tmpf)
return 0




/***************/
/* compute a gdiff difference file, using rsync-signature as a synopsis */
do_rsync:Procedure expose amd4
parse arg rsign,ffile

rsign=unpack64(rsign)
blocksize=c2d(substr(rsign,1,4))
nblocks=c2d(substr(rsign,5,1))
synopsis=''
do mm=1 to nblocks
   jat=((mm-1)*8)+6
   foo=substr(rsign,jat,8)
   synopsis=synopsis||left(foo,20)
end

comment='srersync pre-reply '
aa=left(comment,81)||left(blocksize,7)||left(nblocks,9)||left('md4',35)
synopsis=aa||synopsis

tdir=value('TEMP',,'os2environment')  /* will create this file */
atid=dostid()
apid=dospid()
a1=tdir||'\'atid'_'apid||'.SYN'
foo=sysfiledelete(a1)
status=rx_rsync_gdiff(ffile,synopsis,a1,1)     /* compute a gdiff, using sypnopsis */
foo=stream(a1,'c','close')
parse var status status amd4 ; status=strip(status)
if status<>'OK' then do
  if verbose>1 then call pmprintf('UpDater-cgi rsync error: 'status)
  foo=sysfiledelete(a1)
  return 0              /* error, could not do rsync */
end

foo=stream(a1,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then do
  foo=stream(a1,'c','close')
  foo=sysfiledelete(a1)
  if verbose>1 then  call pmprintf('UpDater-cgi WARNING: unable to open difference file 'a1)
  return 0
end

issize=stream(a1,'c','query size')
if (issize=0 | issize='') then do       /* some kind of error */
  foo=stream(a1,'c','close')
  foo=sysfiledelete(a1)
  return 0
end

return a1               /* return file containing rsync result */


/****************/
/*Look for a rsync-signature request header. If none, do nothing */
rsignature:
rheader=value('http_rsync_signature_updater',,'os2environment')
if rheader='' then return 0
return 1

/*************************************/
/* create a "get list". This list will be used by remote server
or remote client -- the remote server should ask for 
each of these files; checking datestamp and crc first, and  
perhaps using rsync & gzip 

The response consists of lines of the form:
   datestamp entry_number filename rel_dir crc
where:
   datestamp is yy/mm/dd/hr/min
   entry_number refers to the nth entry in the package file.
   filename may contain subdirectory info (if a /S was specified)
   rel_dir is the "relative directory" the remote server should place the file in
   crc is an adler-32 checksum

Note that the x-updater response header also has important info

Note that /dir/filename are relative to a package entry -- they are NOT
interepreted using the sre-http virtual directory, etc. rules 

Also, possibly use cache file, or save as cache file.
*/

send_gets:                              /* return # of entries written */

/* find all files matching each  .!cfile entry */

/* either send as plain text (for remote server processing), or
  as an html list (for human processing */
astext=1

/* if client response, check for required fields first */
if args.!client=1 then do
  ddir=fixit(args.!destdir)
  if ddir='' then do
    say 'Content-type: text/html'
    say
    say '<html><head><title>ERROR: no destination directory </title></head>'
    say '<body 'back1'> '
    say '<h3>ERROR: no destination directory </h3>'
    say 'You forgot to specify a destination directory.'
    say 'The destination directory is a directory on <b>your</b> computer,'
    say 'it is where UpDater will place the files in this package.'
    say '<p><em>Please use your browser''s BACK key, and select a destination directory</em>'
    say '</body></html>'
    astext=0
    return 1
  end
end /* do */

numeric digits 11
nowtime=date('b')+(time('m')/1440)    /* current date/time  -- 1 minute resolution */

/* possibly return a cached filelist */
do yi=1 to 1
   if strip(args.!ashtml)=1 | package_opts.!cache=0 then leave
   if (always_use_cache<>1 & args.!nocache=1) | package_opts.!cachestamp=0 then leave
   if package_opts.!cachestamp+package_opts.!cache<nowtime then leave  
/* IF here, use cached entry! */
   goo=stream(package_opts.!cachefile,'c','open read')
   if abbrev(strip(translate(goo)),'READY')=0 then leave
   sz3=stream(package_opts.!cachefile,'c','query size')
   if sz3=0 | sz3='' then leave
   aax=charin(package_opts.!cachefile,1,sz3)
   foo=stream(package_opts.!cachefile,'c','close')
   parse var aax hdrline '0d0a'x aax
   if length(aax)=0 then leave
   aline='Package='args.!package
   aline=aline||' '||'Server='servername
   CC=GET_CREATED(HDRLINE)
   parse var cc cc1 cc2

   tnow=make_timestamp(package_file)
   if tnow>cc2 then leave         /* if package file has changed, don't use cache */

   aline=aline||' '||'CREATED='CC1
   aline=aline||' '||'pKG_DATE='CC2

   if candogzip=1 then aline=aline' GZIP=1'
   if candorsync=1 then aline=aline' RSYNC=1'
   aline=aline' SELECTOR='script_name

   aline=aline' CURRENT_TIME='nowtime
   if args.!client=1 then call add_remote_client_stuff

   say 'Content-type: application/x-updater'
   xlist='get=1'
   if candorsync=1 then xlist=xlist||',rsync'
   if candogzip=1 then xlist=xlist||',gzip'

   say 'X-updater: 'xlist
   say 
   call charout,aline||'0d0a'x
   call charout,aax
   return 1
end                     /* end of cached response */

cachefile=''            /* '' means "do not save to cache file */
if strip(args.!ashtml)=1 then do
  astext=0
  say 'Content-type: text/html'
  say
  say '<html><head><title>Select a file to retrieve </title></head>'
  say '<body 'back1'> '
  say '<h3>UpDater: Client directed file retrieval mode </h3>'
  say 'Select a file to retrieve from the <b>'||strip(translate(args.!package))'</b> package'
  say '<em>(on 'servername') </em> '
  say '<hr width="30%">'
  say '<em>There are <a name="top"> <tt>'package_opts.0'</tt> </a>sections in 'args.!package':</em>'
  say '<table><tr>'
  mn=0
  do jj=1 to package_opts.0
     mn=max(mn,length(package_opts.jj.!rdir))
  end /* do */
  mn=mn+3
  ncols=trunc(80/mn)
  do jj=1 to package_opts.0
       say '<td><a href="#sec'||jj||'">'package_opts.jj.!rdir'</a>&nbsp;&nbsp;&nbsp;</td>'
       if jj//ncols=0 then say '<tr>'
  end /* do */
  say '</table><hr width="30%">'
  xtras=''
  if args.!rsync=1 then xtras='&rsync=1'
  if args.!gzip=1 then xtras=xtras||'&gzip=1'
end
else do
   say 'Content-type: application/x-updater'
   xlist='get='package_opts.0
   if candorsync=1 then xlist=xlist||',rsync'
   if candogzip=1 then xlist=xlist||',gzip'
   say 'X-updater: 'xlist
   say 

   aline='Package='args.!package
   aline=aline||' '||'Server='servername
   aline=aline||' '||'CREATED='nowtime
   if candogzip=1 then aline=aline' GZIP=1'
   if candorsync=1 then aline=aline' RSYNC=1'
   aline=aline' SELECTOR='script_name

   aline=aline||' '||'PKG_DATE='package_opts.!PKG_DATE

   if args.!client=1 then call add_remote_client_stuff
   say aline

  if astext=1 & package_opts.!cache<>0 then do
    foo=sysfiledelete(package_opts.!cachefile)
    foo=stream(package_opts.!cachefile,'c','open write')
    if abbrev(strip(translate(foo)),'READY')=1 then do  /* cache file open */
       cachefile=package_opts.!cachefile
       call lineout cachefile,aline 
    end 
  end

end /* do */

ndid=0
do jj=1 to package_opts.0
   rdir=strip(package_opts.jj.!rdir)
   if (astext=0) then do
      if jj>0 then
         say '<font size="+2"><a name="sec'||jj'">'rdir'</a></font> (<a href="#top">top</a>)'  
      else
         say '<font size="+2"><a name="sec'||jj'">'rdir'</a></font> '  
      say '<ul>'  
   end
   sss=package_opts.jj.!subs
   dirget=package_opts.jj.!cfile

   foo=translate(dirget,' ','\')
   aa=word(foo,words(foo))
   if (pos('.',aa)+pos('*',aa)+pos('?',aa))=0 then dirget=dirget'\*.*'

   thisdir=strip(filespec('d',dirget)||filespec('p',dirget),,'\')

/* make sure directory exists */
   if dosisdir(thisdir)=0 then do
       call pmprintf('UpDater-cgi warning: 'args.!package', no such directory 'thisdir )
   end 

   nthisdir=length(thisdir)
   csss=''; if sss=1 then csss='S'
   a1=sysfiletree(dirget,flist,'FT'||CSSS)
   ndid=ndid+flist.0
   do jj2=1 to flist.0
        parse var flist.jj2 adate . . aname ;aname=strip(aname)
        if left(adate,2)<70 then 
            adate='20'||adate
        else
            adate='19'||adate

        KK=CHECK_EXCLUDE(ANAME)
        IF KK=1 then ITERATE
        aname2=delstr(aname,1,nthisdir)
        aname3=translate(aname2,'/','\')
        if astext=1 then do             /* as x-updater response */
           acrc=''
           noce=check_noencode(aname)
           if addcrc=1 then do
               acrc=fileadler(aname)
           end
            say adate||' '||jj||' '||aname3||' 'rdir' 'noce' 'acrc
            if cachefile<>'' then do
              call lineout cachefile,adate||' '||jj||' '||aname3||' 'rdir' 'noce' 'acrc
            end
        end

        else do         /* as an html list */
           modddate=''
           if args.!nodate<>1 then moddate='&mod='||adate
           aurl='<a target="UpDater" href="/'||script_name||'?file='||aname3||'&entry='||jj||'&package='||args.!package||'&action=file1' ,
                ||xtras||'">'
           say '<li> '||aurl||aname3||'</a> '
        end /* do */

   end /* do */

   if (astext=0) then do
      say '</ul>'  
   end

end /* do */

if astext=0 then do
   say '<a href="/'||script_name||'?">Return to updater main menu</a> (at 'servername')'
   say '</body></html>'
end /* do */

/* close cache file? */
if cachefile<>'' then foo=stream(cachefile,'c','close')

return ndid


/********/
/* pull stuff from cache header line, save in hdr.! */
get_CREATED:procedure expose hdr.
parse arg aline0
created=0 ; pkg_date=0
DO UNTIL ALINE0=''
  parse var aline0 a1 aline0
  parse var a1 avar '=' aval; avar=strip(translate(avar))
  if avar='CREATED' then created=strip(aval)
  if avar='PKG_DATE' then pkg_date=strip(aval)
end
return created' 'pkg_date
return 0

/************/
/* add remote client stuff to "aline" */
add_remote_client_stuff:
      if ddir<>'' then do
         aline=aline' DESTDIR='||ddir
      end
      if fixit(args.!BACKUPDIR)<>'' then do
         aline=aline' BACKUPDIR='||fixit(args.!BACKUPDIR)
      end
      if args.!DODELETE<>'' then do
         aline=aline' DODELETE='args.!DODELETE
      end
      if args.!CHECK<>'' then do
         aline=aline' CHECK='args.!CHECK
      end
      rng1=strip(fixit(args.!range1))
      if rng1<>'' then do
         rng2=strip(fixit(args.!range2))
         if datatype(rng1)='NUM' & datatype(rng2)='NUM' then do
             rng12=strip(rng1)||':'||strip(rng2)
             aline=aline' RANGE='||rng12
         end /* do */
      end
      if args.!QUIET=1 then aline=aline' QUIET=1 '
      if args.!dORUN=1 then  do
           if package_opts.!RUN<>'' then do
               parse var package_opts.!run aprog atype runargs
               ctype=translate(strip(atype))
               istype=''
               if ctype='PM' then do
                  istype='PM'
               end /* do */
               else do
                  parse var package_opts.!run . runargs
               end /* do */
               isargs=''
               if abbrev(translate(strip(runargs)),'ARG=')=1 then do
                  parse var runargs . '=' isargs
               end /* do */
               aline=aline' RUN='||strip(aprog)
               if istype<>'' then aline=aline' RUNTYPE='||istype
               if isargs<>'' then aline=aline' RUNARGS='||mkpack64(isargs)
           end /* do */
       end

      return 1
   
/************/
/* unpack64   :  astring=unpack64(mkpack64(astring)) */

unpack64:procedure
char_set='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
do mm=0 to length(char_set)-1
   a.mm=substr(char_set,mm+1,1)
end /* do */

parse arg mess
newmess=""
do mm=1 to length(mess)
   a1=substr(mess,mm,1)
   a1a=c2d(a1)
   select
     when a1a>64 & a1a<91  then a1b=a1a-65  /* ascii 65 to 90 */
     when a1a>96 & a1a<123 then a1b=26+(a1a-97)  /* ascii 97 to 122 */
     when a1a>47 & a1a<58  then a1b=a1a+4   /* ascii 48 to 57 */
     when a1='+' then a1b=62
     when a1='/' then a1b=63
     when a1='=' then iterate
     otherwise return ""        /* error */
   end
   pp=x2b(d2x(a1b))
   if length(pp)>6 then
        pp=substr(pp,3)
   else
        pp=right(pp,6,0)
   newmess=newmess||pp
end
ilen=trunc(length(newmess)/8)*8 ; newmess=left(newmess,ilen)
newm=x2c(b2x(newmess))
return newm


/**********************/
mkPACK64:procedure
parse arg mess

biga=xrange('A','Z')||xrange('a','z')||xrange('0','9')||'+/'

s2=x2b(c2x(mess))

nith=trunc((length(s2)/6)+.9)
cont=copies(' ',nith)
oof=""
do mm=0 to 63
      oof=oof||x2c(b2x(right('00'||x2b(d2x(mm)),6)))
end /* do */
do ith=1 to nith 
  a1=substr(s2,(ith*6)-5,6,0)
  cont=overlay(x2c(b2x(a1)),cont,ith) 
end /* do */
pint=""
pint=translate(cont,biga,oof)
j1=length(pint)//4
if j1<>0 then pint=pint||copies('=',4-j1)
return pint


/************************************************/
/* procedure from TEST-CGI.CMD by  Frankie Fan <kfan@netcom.com>  7/11/94 */
DecodeKeyVal: procedure
  parse arg Code
  Text=''
  Code=translate(Code, ' ', '+')
  rest='%'
  do while (rest\='')
     Parse var Code T '%' rest
     Text=Text || T
     if (rest\='' ) then
      do
        ch = left( rest,2)
        if verify(ch,'01234567890ABCDEF')=0 then
           c=X2C(ch)
        else
           c=ch
        Text=Text || c
        Code=substr( rest, 3)
      end
  end
  return Text


/************/
/* clean up an argument */
fixit:procedure
parse arg aa
aa=translate(aa,' ','+'||'0d0a0900'x)
aa=decodekeyval(aa)
aa=strip(aa)
return aa

/*************/
/* CHECK A FILEname against an exclusion list */
check_exclude:procedure expose package_opts.
parse arg afile

foo=0
do mm=1 to package_opts.!exclude.0
   ex1=package_opts.!exclude.mm
   sub1=package_opts.!exclude.mm.1
 
   if (sub1<>1) then do         
      adir=translate(filespec('d',afile)||filespec('p',afile))
      xdir=translate(filespec('d',ex1)||filespec('p',ex1))
      if adir<>xdir then iterate   /* skip if not same directory */
      aname=filespec('n',afile)
      xname=filespec('n',ex1)
      foo=wild_match(aname,xname)
    end
    else do             /* subdir matches okay */
      foo=wild_match(afile,ex1)
    end                 /* sub1 */
    if foo<>0 then return 1           /* match found, so exclude */
end /* do */
return 0                /* if here, no exclusions */



/*************/
/* CHECK A FILEname against an  noencode list */
check_noencode:procedure expose package_opts.
parse arg afile

foo=0
do mm=1 to package_opts.!noencode.0
   ex1=package_opts.!noencode.mm
   sub1=package_opts.!noencode.mm.1
 
   if (sub1<>1) then do         
      adir=translate(filespec('d',afile)||filespec('p',afile))
      xdir=translate(filespec('d',ex1)||filespec('p',ex1))
      if adir<>xdir then iterate   /* skip if not same directory */
      aname=filespec('n',afile)
      xname=filespec('n',ex1)
      foo=wild_match(aname,xname)
    end
    else do             /* subdir matches okay */
      foo=wild_match(afile,ex1)
    end                 /* sub1 */
    if foo<>0 then return 1           /* match found, so do not encode */
end /* do */
return 0                /* if here, no noencodes */



/*************/
/* construct a list of packages.
   First line: # of packages
   2.,#Packages+1 lines: package name descripton (if requested)
*/


do_packagelist:

astext=1

if strip(args.!ashtml)=1 then astext=0
if astext=1 then
     say 'Content-type: text/plain'
else
     say 'Content-type: text/html'
say   'X-updater: package_list '
say 

if astext=0 then do
  say '<html><head><title>Currently available UpDater packages </title></head>'
  say '<body 'back1'>'
  say '<h3>Welcome to UpDater (beta 1.08)</h3>'
end

 foo=sysfiletree(package_dir'\*.pkg',plist,'FT')
 if astext=1 then do
   say plist.0
 end
 else do
    say '<blockquote>This UpDater <em>central server </em> &nbsp; (at <tt> 'servername')</tt> '
    say 'currently supports <tt>'plist.0'</tt> <em>packages</em></blockquote><table>'
 end

 do mm=1 to plist.0
       adesc=''
       parse var plist.mm adate . . nname ;nname=strip(nname)
       if left(adate,2)<70 then 
            adate='20'||adate
       else
            adate='19'||adate
       nname0=filespec('n',nname)
       if strip(translate(args.!package))='!LIST' then do  /* extract description */
            isize=stream(nname,'c','query size')
            if (isize=0 | isize='') then do    /* bad package */
                if astext=1 then
                   say '; unavailable package: 'nname0
                else
                   say '<tr><td>'mm'</td><td><tt>'nname0'</tt></td><td><em> unavailable </em> </td>'

                iterate
            end /* do */
            stat=read_package(nname,isize)             /* read in package file */
            foo=stream(nname,'c','close')
            adesc=package_opts.!title
       end /* do */

       nname0a=nname0
       foo=lastpos('.',nname0)
       if foo>1 then nname0a=left(nname0,foo-1)
       if astext=1 then do
          say adate' 'nname0a' 'adesc
       end
       else do
          parse var nname0 nname0a '.' .
          say '<tr><td>'mm'</td><td><a href="/'||script_name||'?package='nname0a'&action=display">'nname0a'</a> </td><td> 'adesc '</td>'
       end
 end /* do */
 if astext=0 then do
   say '</table>'
   say '<hr>Would you like to read the <a target="info" href="/'||script_name||'?send=UPDATER.DOC&text=1">UpDater documentation</a>'
   say '</body></html>'
 end
 return 1


/*************************************/
/* formatted display of  the various entries in this package */
disp_package:
 say 'Content-type: text/html '
 say 'X-updater: display_package '

  say
  say '<html><head><title>Displaying an UpDater package </title></head>'
  say '<body 'back1'>'
  say '<h3>Contents of Updater Package: '||strip(translate(args.!package))'</h3>'
  say '<ul><li><b>Title</b>: 'package_opts.!title
  say '<li><b>Description</b>: 'package_opts.!desc
  say '</ul>'
  say '<h3>You can ... </h3>'

  say '<menu>'
  say '<li>'
  say '<a href="/'||script_name||'?package='||args.!package||'&action=getl2&client=1">'
  say 'UpDate these files</a> to your computer '
  say '(using the <a target="info" href="/'||script_name||'?action=UPCLIENTDOC">UpClient helper app</a>) '
  say '<li> View  &amp; select '
  say '<a href="/'||script_name||'?package='||args.!package||'&action=getl&ashtml=1">all the files</a> ',
                       ' in <b>'args.!package '</b>?'
  say '<li><a href="/'||script_name||'?">Return to UpDater main menu</a> (at 'servername')'

  say '</menu>'
  say '<h3>Description of the 'args.!package' package</h3>'
  say '<table><tr><th>Remote Dir </th><th>Central Files </th><th>Subdirectories? </th>'
  do jj= 1 to package_opts.0
     sok='' 
     if package_opts.jj.!subs=1 then sok='YES'
     a1=package_opts.jj.!rdir
     a2=package_opts.jj.!cfile
     say '<tr><td> 'a1'</td><td> 'a2'</td><td> 'sok'</td></tr>'
  end /* do */
  say '</table>'
  if package_opts.!exclude.0>0  then do
    say '<hr width="30%">'
    say '<b>File exclusion rules</b><br>'
    say '<table><tr><th>File Rule</th><th>Subdirectories? </th>'
    do jj= 1 to package_opts.!exclude.0
       sok='' 
       if package_opts.!exclude.jj.1=1 then sok='YES'
       a2=package_opts.!exclude.jj
       say '<tr><td> 'a2'</td><td> 'sok'</td></tr>'
    end 
  end
  say '</table>'
  say '</body></html>'
  return 1

  end

/***********/
/* describe the upclient helper app */
tell_upclient:
  say 'Content-type: text/html '
  say
  say '<html><head><title>The UpClient helper app </title></head>'
  say '<body 'back1'>'
  say '<a name="upclient"><h3>The UpClient helper app </h3></a>'
  say 'The <a href="/'||script_name||'?send=UPCLIENT.CMD">UpClient</a> helper application is a REXX program (UPCLIENT.CMD)'
  say 'that will update a package of files to your computer. '
  say '<b>To use UPCLIENT.CMD, you must be running NetScape under OS/2.</b>'
  say '<p>Assuming this describes you, after '
  say '<a href="/'||script_name||'?send=UPCLIENT.CMD">downloading UpClient</a>'
  say 'you should <ol>'
  say '<li>Copy UPCLIENT.CMD to a directory in your PATH (i.e.; to x:\OS2\APPS, where x: is your boot drive)'
  say '<li>Tell NetScape to use UPCLIENT.CMD with all <tt>application/x-updater</tt> responses'
  say '<br>To do this, you should: '
  say '<menu><li>Open up the Preferences menu in Netscape (under NS 4.6,<tt> Edit-Preferences</tt>)'
  say '<li>Select <tt>Applications</tt>'
  say '<li>Select the <tt>New Type</tt> option'
  say '<li>Fill in the fields of the <tt>New Type</tt> screen with: '
  say '<ul><li><u>Description of type</u>: UpDater Client '
  say '<li><u>File Extension</u>: UPD '
  say '<li><u>MIME Type</u>: application/x-updater'
  say '<li><u>Application to use</u>: cmd.exe /c "x:\os2\apps\upclient.cmd"'
  say '<br> <em>be sure to include the " characters </em>'
  say '</ul>'
  say '</menu>'
  say '</ol>'
  say 'Once UpClient is installed, when you UpDate a package from a'
  say '<Em>UpDater central server</em>, Netscape will run UpClient in '
  say 'seperate window.  After asking a few questions, UpClient will'
  say 'GET files and write them to your hard drive.'
  say '<hr width="30%">'
  say 'Note: UpClient works best when you have the following libraries/programs installed:'
  say '<ol>'
  say '<li> <a href="/'||script_name||'?send=rxRSYNC.DLL">The rxRsync dynamic link library</a>'
  say '<em>(install this in your <TT>LIBPATH</tt>. For example, in x:\OS2\DLL)</em>'
  say '<li> <a href="/'||script_name||'?send=gzip.exe">The GZIP executable</a>'
  say '<em>(install this in your <TT>PATH</tt>. For example, in x:\OS2\APPS)</em>'
  say '</ol>'

  say '</body></html>'

  return 1

/*************************************/
/* read package file into package_opts. stem */
read_package:procedure expose package_opts. crlf candorsync candogzip
parse arg afile,isize

afilea=charin(afile,1,isize)||'0d0a'x||' '

doing=''
package_opts.=''
package_opts.!exclude.0=0
package_opts.!noencode.0=0
package_opts.!cache=0

parse var afile afil0 '.' .
afilc=afil0'.PKC'

if stream(afilc,'c','query size')=0 then foo=sysfiledelete(afilc)  /* 0 length files are trouble */

package_opts.!PKG_DATE=make_timestamp(afile)
package_opts.!cachefile=afilc
package_opts.!cachestamp=make_timestamp(afilc)  /* timestamp of "cache" entry */

package_opts.0=0
do until afilea=''
  parse var afilea aline (crlf) afilea
  aline=strip(aline)

  select 
    when abbrev(aline,';')=1 then iterate   /* skip comments */
    when aline='' & doing='' then iterate   /* skip multiple blank lines */
    when aline='' then do           /* end of a entry */ 
       doing=''                   /* get ready for next entry */
       iterate
    end
    when doing='' then do           /* find name: */
      if pos(':',aline)=0 then iterate  /* error, ignore */
      parse var aline aname ':' aline
      doing=strip(translate(aname))
      
    end
    OTHERWISE NOP
   END
   if aline='' then iterate
   SELECT
    when abbrev(doing,'DESC')=1 then do   /* not a FILES entry */
        package_opts.!DESC=package_opts.!DESC' 'aline
        iterate
    end
    when abbrev(doing,'TITLE')=1 then do   /* not a FILES entry */
        package_opts.!TITLE=package_opts.!TITLE' 'aline
        iterate
    end

    when abbrev(doing,'FILE')+abbrev(doing,'INC')>0 then do   /* an include entry */
       parse var aline remote_dir central_file alsosubs .
       inn=package_opts.0+1
       package_opts.inn.!rdir='/'||strip(translate(strip(translate(remote_dir)),'/','\'),,'/')

       ifile=translate(strip(translate(central_file)),'\','/')

       foo=translate(ifile,' ','\')
       aa=word(foo,words(foo))
       if (pos('.',aa)+pos('*',aa)+pos('?',aa))=0 then ifile=ifile'\*.*'

       package_opts.inn.!cfile=ifile
       if translate(strip(alsosubs))='/S' then package_opts.inn.!subs=1
       package_opts.0=inn
    end

    when abbrev(doing,'EXC')=1 then do   /* a EXCLUDE entry */
       parse var aline  exc_file alsosubs .
       inn=package_opts.!exclude.0+1
       efile=translate(strip(translate(exc_file)),'\','/')

       foo=translate(efile,' ','\')
       aa=word(foo,words(foo))
       if (pos('.',aa)+pos('*',aa)+pos('?',aa))=0 then efile=efile'\*.*'

       package_opts.!exclude.inn=efile
       if translate(strip(alsosubs))='/S' then package_opts.!exclude.inn.1=1
       package_opts.!exclude.0=inn
    end

    when abbrev(doing,'NO_E')=1 then do   /* a no_encode entry */
       parse var aline  noe_file alsosubs  .
       inn=package_opts.!noencode.0+1
       package_opts.!noencode.inn=translate(strip(translate(noe_file)),'\','/')
       if translate(strip(alsosubs))='/S' then package_opts.!noencode.inn.1=1
       package_opts.!noencode.0=inn
    end

    when abbrev(doing,'RUN')=1 then do
        package_opts.!run=strip(aline)
    end 

    when abbrev(doing,'CACHE')=1 then do   /* a no_encode entry */
       parse var aline  adays . ; adays=strip(adays)
       if datatype(adays)='NUM' then  package_opts.!cache=adays
    end

    otherwise do
      AOPT='!'||DOING
      package_opts.aopt=package_opts.aopt||' '||aline
      iterate
    end /* do */

  end         /*select */
end             /* do loop */
return 1



/****/
/* make a nnn.xxx timestamp */
make_timestamp:procedure
parse arg afile
foo=sysfiletree(afile,'ttt','FT')
if ttt.0=0 then return 0                /* no time stamp */
parse var ttt.1 yr '/' mon '/' day '/' hr '/' mnutes .
if yr<70 then 
  yr=2000+yr
else
  yr=1900+yr
tt2=dateconv(yr||mon||day,'S','B')
numeric digits 10
tt3=((hr*60)+mnutes)/1440
tstamp=tt2+tt3
return tstamp 

/***********/
/* adler-32 crc of file aname */
fileadler:procedure expose candorsync
parse arg aname

if candorsync=0 then return ''

foo=stream(aname,'c','open read')
if abbrev(strip(translate(foo)),'READY')=0 then return ''

sz=stream(aname,'c','query size')
if sz='' | sz=0 then return ' '
aa=charin(aname,1,min(100000,sz))
adler=rx_adler32(aa)
igot=100000
do forever
   if igot>=sz then leave
   iget=min(100000,sz-igot)
   aa=charin(aname,,iget)
    adler=rx_adler32(aa,adler)
    igot=igot+100000
end
foo=stream(aname,'c','close')

return adler


/*** jump here on error */
badguys:
call pmprintf("updater-cgi error "Rc " at " sigl)
    say 'Content-type: text/plain '
    say
    say 'error 'rc ' at ' sigl
end
return ' '


/********************/
/* check for unzip and rsync dlls */
check_dlls:

/* --- Load the tcp/ip function library, if necessary --- */
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
  foo=RxFuncAdd( "SockLoadFuncs","rxSock","SockLoadFuncs")
  if foo=0 then call SockLoadFuncs
end
if RxFuncQuery("SockLoadFuncs")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rxSock dynamic link library"
   say
   return 0
end

/* Load up advanced REXX functions */
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
  foo= RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs')
  if foo=0 then call SysLoadFuncs
end
if RxFuncQuery("SysLoadFuncs")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rexxutil dynamic link library"
   say
   return 0
end

/* Load up REXX lib functions */
if RxFuncQuery("rexxlibregister")=1 then  do    /* not there */
  foo=rxfuncadd('rexxlibregister','rexxlib', 'rexxlibregister')
  if foo=0 then call rexxlibregister
end
if RxFuncQuery("Rexxlibregister")=1 then  do    /* not there */
   say 'Content-type: text/plain'
   say 
   say "ERROR: UpDater requires the rexxlib dynamic link library"
   say
   return 0
end

if candorsync=1 then do         /* can we really? */
  if rxfuncquery('rx_md4')=1  then do
     foo=RXFuncAdd('RXRsyncLoad', 'RXRSYNC', 'RxRsyncLoad')
     if foo=0 then  call rxrsyncload
     t1=rxfuncquery('rx_md4')
     if t1=1 then do
       if verbose>1 then call pmprintf('UpDater-cgi warning: rxrsync not available -'directory())
       candorsync=0
     end  
  end
end

/* see if GZIP is available */
if candogzip=0 then signal check_done

signal on error name nogzip; signal on syntax name nogzip
isok=0
nn=queued()
do nn0=1 to nn
   pull .
end
address cmd '@GZIP -V 2> NUL '
if rc=0 then isok=1
do nn0=1 to nn
   pull .
end
nogzip: 
candogzip=isok
if candogzip=0 & verbose>1 then call pmprintf('UpDater-cgi-cgi warning: GZIP not available')

signal on error name badguys; signal on syntax name badguys

checkdone:              /* skip here if gzip disabled */

return 1


/************************/
/* wild card match, with comparision against prior wild card match */
/* needle : what to look for 
   haytack : what to compare it to. Haystack may contain numerous * wildcard 
             characters
   oldresu : prior return from wild_match; or empty.
Return (depends on oldresu):
  If needle is exact match to haystack: return -1
  If needle does not match haystack (even with wild card checking) : return 0
  If needle wildcard matches haystack, and oldresu='': returns match information
  If needle wildcard matches haystack, and if oldresu<>'' (is a prior 
   return from wild_match), then the current match is compared to
   this oldresu.  If the current match is "better" (has more matching 
   characters early in the string), then : return match info
   If it's worse (or the same): return 0

Basically, -1 means "exact match", 0 means "no match" or "not better match"
(if oldresu not specified, 0 always means "no match"), and everything else
means "wild card match".

SPECIAL FEATURE: if haystack ends with a |, then no "slash" is allowed in the
final wildcarded portion of the needle.  That is, the portion of the needle
"covered" by the final (or only, if there is just one *) in the haystack
can NOT contain a / or a \. If it does, it's a NO MATCH 

eg: using a needle of: animal/cats/food.1
  The follwing haystacks yield:
       animal/ *candy  --  no match
       anim* / *.1      --  match
       animal/ *.1|    --  no match (* covers cats/food, which contains a /)
       anim* /food*|   --  match (final * covers ".1")
       * /cats*|       --  no match (final * covers "/food.1:"


*/

wild_match:
parse upper arg needle, haystack,oldresu,suppress_noslash


 aresu=awild_match(needle,haystack)
 if aresu=0 then return aresu     /* no match */
 if aresu=-1 | oldresu=' ' then return aresu  /* exact match, or first wildcard match */

/* Is this a better WILDCARD MATCH */
   wrdsnew=words(ARESU);wrdsold=words(oldRESU)
   useold=1
   do Nmm=1 to max(wrdsold,wrdsnew)
       if Nmm>wrdsnew then leave
       if Nmm>wrdsold then do
             useold=0; leave
       end  
       a1=strip(word(oldresu,Nmm))
       a2=strip(word(aresu,Nmm))
       if a1=a2  then iterate
       if a2>a1 then leave  /* new matching element > old matching element, thus new is worse match */
       useold=0           /* found a matching element in new < then corresponding element in old*/
       leave            /* thus, new is better match */
    end

    IF USEold=0 THEN return aresu
     return 0           /* non superior match (might be same, in which case old is used*/




awild_match:procedure expose suppress_noslash
parse upper arg needle, haystack ; haystack=strip(haystack)
needle=strip(needle)

noslash=0               /* | at end of haystack means "no / or \ in last wildcarded portion of needle */
if right(haystack,1)='|' & suppress_noslash<>1 then do
   noslash=1
   haystack=left(haystack,length(haystack)-1)
end

hayendast=0
if right(haystack,1)='*' then hayendast=1


if needle=haystack then return -1        /* -1 signals exact match */
ast1=pos('*',haystack)
if ast1=0 then return 0                 /* 0 means no match */
if haystack='*' then  do                /* global is sort of stupid -- choose "shortest" string */
   if noslash=1 then do                 /* check for noslash condition */
     noo=translate(needle,'/','\')
     if pos('/',noo)>0 then return 0
   end
   if length(needle)=0 then 
       return 100000
    else 
        return length(needle)
end
ff=haystack
ii=0
do until ff=""
  ii=ii+1
  parse var ff hw.ii '*'  ff
  hw.ii=strip(hw.ii)
end
if hw.ii='' then ii=ii-1
hw.0=ii


/* check each component of haystackw against needle -- all components
must be there */

resu=' '
istart=1 ; ido=2
if ast1>1 then do       /* first check abbrev */
  if abbrev(needle,hw.1)=0 then return 0   /* first portion of haystack also first portion of needle */
  aresu=length(hw.1)
  if hw.0=1 then do
     if noslash=1 then do                 /* check for noslash condition */
        noo=translate(substr(needle,aresu+1),'/','\')
        if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
     end
     do nm=1 to aresu
        resu=resu||' '||nm
     end /* do */
     return resu         /* if haystacy of form abc*, we have a match */
  end
  ido=2 ; istart=aresu+1
  do mm=1 to aresu
        resu=resu||' '||mm
  end /* do */
end
/* if here, then first part (a non wildcard) of haystack matches first
part of needle
Now check sequentially that each remaining part also exists
*/
do mm=ido to hw.0
  igoo=pos(hw.mm,needle,istart)
  if igoo=0 then return 0
  if noslash=1 & mm=hw.0 & hayendast=0 then do     /* this is a non *'ed haystack end */
     noo=translate(substr(needle,istart,igoo-istart),'/','\')
     if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
  end
  tres=length(hw.mm)
  istart=igoo+tres
  do nn=igoo to (istart-1)
     nn0=nn
     resu=resu||' '||nn       /* resu indices characters that really match */
  end /* do */
end

if noslash=1 & hayendast=1 then do
   noo=translate(substr(needle,nn0+1),'/','\')
   if pos('/',noo)>0 then return 0      /* slash in wildcard means "no match" */
end
   
if (istart >= length(needle)) | (hayendast=1) then  return resu

return 0
 



/* ----------------------------------------------------------------------- */
/* MEDIATYPE: Return the media type of a file, based on its extension.     */
/* ----------------------------------------------------------------------- */
get_mediatype:
parse arg aa
  /* First get the extension; this assumes filenames have at least one '.' */
  ???=translate(substr(arg(1), lastpos('.',arg(1))+1))

  /* Fastpath very common types [add your own favourites] */
  if ???='HTM' then return 'text/html'
  if ???='HTML' then return 'text/html'
  if ???='GIF' then return 'image/gif'
  if ???='SHT' then return 'text/html'
  if ???='SHTML' then return 'text/html'



/* special cases */

  
  /* Set up the table of all types that we are interested in */
  known.   ='application/octet-stream'  /* default type */
  known.ps ='application/postscript'
  known.pdf='application/pdf'
  known.zip='application/zip'
  known.au ='audio/basic'
  known.snd='audio/basic'
  known.wav='audio/x-wav'
  known.mid='audio/x-midi'
  known.gif='image/gif'
  known.bmp='image/bmp'
  known.jpg='image/jpeg';  known.jpeg='image/jpeg'
  known.tif='image/tiff';  known.tiff='image/tiff'
  known.htm='text/html' ;  known.html='text/html'
  known.sht='text/html' ;  known.shtml='text/html'
  tmp1='HTML-SSI'           
  known.tmp1='text/html'   
  
  known.txt='text/plain'
  known.lst='text/plain'
  known.me='text/plain'
  known.log='text/plain'
  /* known.doc='text/plain' */
  known.faq='text/plain'
  known.mpg='video/mpeg';  known.mpeg='video/mpeg'
  known.mov='video/quicktime'
  known.avi='video/x-msvideo'
  known.js='appplication/javascript'

  /* Now it's trivial... */

  return known.???



get_hostname:procedure
dot_addr = SockGetHostId()
rc = SockGetHostByAddr(dot_addr, "host.")
return host.name

